      subroutine rdap(na,isft,x,b,p,isub)
      common /cwflag/ iwflag(6)
      character*6 atom
      common /cltc/ atom(100)
      dimension isft(*),x(6,*),b(*),p(*),isub(*)
      call getinp(inpu)
      call getout(iout)
      call freadc('basic structure',0,dummy,1)
      if(iwflag(3).eq.1) then
          write(6,301)
      end if
      do 9 i=1,na
      read(inpu,*) ik,atom(i),isft(i),(x(j,i),j=1,6),b(i),p(i),isub(i)
      if(iwflag(3).eq.1) then
            write(iout,302) ik,atom(i),isft(i),(x(j,i),j=1,6),
     *      b(i),p(i),isub(i)
      end if
 9    continue
      if(iwflag(3).eq.1) then
           write(iout,300)
      end if
 10   continue
 102  format(i2,a4,a2,i2,7f9.6)
 300  format(1h )
 301  format(1h ,'  No',2x,'atom',2x,'s.f.',4x
     * ,'x',8x,'y',8x,'z',8x,'t',8x,'u',8x,'v',8x,'b',
     *     8x,'p',6x,'isub')
 302  format(1h ,i4,1x,a,1x,i2,1x,6f9.5,1x,2f9.3,3x,i1)
      return
      end

      subroutine rdasf(ip)
      common /cwflag/ iwflag(6)
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand,
     *              iel(3,100)
      dimension a(4,20),b(4,20),c(20)
      common /cpnf1/ atp(3),atp0(3),datpdp(3,3,100)
      call getinp(inpu)
      call getout(iout)
      do 10 i=1,20
      df1(i)=0.0
 10   df2(i)=0.0
      call getipnf(ipnf1,ipnf2,ipnf3)
c      read(inpu,101) ne,iand,ia
      call freadi('ne=',1,ne,1)
      call freadi('iand=',1,iand,0)
      call freadi('inpd=',1,ia,0)
      if(ipnf3.eq.1) then
         do i=1,ne
            call freadi('iel=',2,iel(1,i),0)
         end do
         call freadr('atp=',3,atp0,0)
      end if
      if(ia.ne.0) ia=1
      if(iwflag(3).eq.1) then
           write(iout,205) ne,iand,ia
      end if
      call freadc('scattering factor',0,dummy,1)
      do 20 ik=1,ne
      if(ia.eq.0) read(inpu,100) (ascf(i,ik),i=1,35)
      if(ia.eq.1) read(inpu,102) (a(i,ik),b(i,ik),i=1,4),c(ik)
      if(iand.eq.1) read(inpu,102) df1(ik),df2(ik)
      if(ip.eq.-1) then
          if(ia.eq.1) read(inpu,102) (a(i,ik+ne),b(i,ik+ne),
     *        i=1,4),c(ik+ne)
          if(ia.eq.0) read(inpu,100) (ascf(i,ik+ne),i=1,35)
          if(iand.eq.1) read(inpu,100) df1(ik+ne),df2(ik+ne)
      end if
 20   continue
      if(iwflag(3).eq.1) then
           write(iout,202)
      end if
      do 30 ik=1,ne
      if(ia.eq.1) then
           do 31 i=1,35
           sint=((i-1)*0.05)**2
           ascf(i,ik)=c(ik)
           if(ia.eq.1) ascf(i,ik+ne)=c(ik+ne)
           do 31 j=1,4
           ascf(i,ik)=ascf(i,ik)+a(j,ik)*exp(-b(j,ik)*sint)
           if(ip.eq.-1) ascf(i,ik+ne)=ascf(i,ik+ne)+a(j,ik+ne)*
     *              exp(-b(j,ik+ne)*sint)
 31        continue
      end if
      if(iwflag(3).eq.1) then
           if(iand.ne.1) write(iout,2001) ik
           if(iand.eq.1) write(iout,2002) ik,df1(ik),df2(ik)
           if(ia.eq.1) write(iout,203) (i,a(i,ik),i,b(i,ik),i=1,4),c(ik)
           write(iout,201) (ascf(i,ik),i=1,35)
           if(ip.ne.-1) go to 30
           if(iand.ne.1) write(iout,2041)
           if(iand.eq.1) write(iout,2042) df1(ik+ne),df2(ik+ne)
           if(ia.eq.1) write(iout,203)(i,a(i,ik+ne),i,b(i,ik+ne),i=1,4),
     *          c(ik+ne)
           write(iout,201) (ascf(i,ik+ne),i=1,35)
      end if
 30   continue
      return
 100  format(12f6.3)
 101  format(3i3)
 102  format(9f8.5)
 2001 format(1h ,'table',i3)
 2002 format(1h ,'table',i2,8x,'real and imaginary parts of dispersion
     *         correction',2f10.5)
 201  format((1h ,12(f6.3,4x)))
 202  format(1h ,'atomic scattering factor table')
 203  format(1h ,'input data'/1h ,4('a',i1,'=',f10.6,1x,'b',i1,'=',
     *         f10.6,1x),'c=',f10.6)
 2041 format(1h ,'second species')
 2042 format(1h ,'second species real and imaginary parts of dispersion
     *          correction',2f10.5)
 205  format(1h ,'ne=',i3,2x,'iand=',i3,2x,'inpd=',i3)
      end


      subroutine rdfour(nw,nt,ifrt1,ifrt2,coeff)
      common /cwflag/ iwflag(6)
      character*4 ifrt1(nw,2,nt)
      dimension ifrt2(nw,3,nt),coeff(nw,nt),sig(4),cs(4),
     *         n1(4),n2(4),n3(4),cef(4),ico(4)
      character sig,cs,ico
      character*80 dummy
      call getinp(inpu)
      call getout(iout)
      call freadc('fourier term',0,dummy,1)
      do 30 i=1,nw
      do 30 k=1,nt
      do 301 j=1,2
 301  ifrt1(i,j,k)='    '
      do 302 j=1,3
 302  ifrt2(i,j,k)=0
 30   continue
      if(iwflag(3).eq.1) then
           write(iout,201)
      end if
      i=1
      k=0
 10   read(inpu,100) (sig(j),cs(j),n1(j),n2(j),n3(j),cef(j),
     *                                           ico(j),j=1,4)
      do 11 j=1,4
      if(sig(j).eq.' '.and.cs(j).eq.' ') go to 11
      k=k+1
      ifrt1(i,1,k)=sig(j)
      ifrt1(i,2,k)=cs(j)
      ifrt2(i,1,k)=n1(j)
      ifrt2(i,2,k)=n2(j)
      ifrt2(i,3,k)=n3(j)
      coeff(i,k)=cef(j)
      if(cef(j).eq.0.0) coeff(i,k)=1.0
      if(ico(j).ne.' ') go to 11
      if(iwflag(3).eq.1) then
             write(iout,200) i,((ifrt1(i,jj,l),jj=1,2),
     *                 (ifrt2(i,jj,l),jj=1,3),coeff(i,l),l=1,k)
      end if
      k=0
      i=i+1
 11   continue
      if(i.ne.nw+1) go to 10
      return
 100  format(4(2a1,3i2,f10.6,1x,a1))
 200  format(1h ,i3,2x,4(2a1,'(',3i2,')',f10.6,2x)/(1h ,5x,4(2a1,'(',
     *       3i2,')',f10.6,2x)))
 201  format(1h ,'fourier terms')
      end

      subroutine rdintl(x,mx,ja,ea,x1,isub,n1,n2,nu)
      common /cwflag/ iwflag(6)
      character*4 mx(n1,n2,*)
      dimension x(n1,n2,*),ja(4,*),ea(*),x1(*),isub(*)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /cnsti/ ix,ib,if,itvr,itst,nds,na4
c      common /cltc/ atom(2,100)
      character*6 atom
      common /cltc/ atom(100)
      integer dspmdl,tmpmdl,sctmdl
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /citfs/ itfs(100)
      common /ceat/ eat(6,3)
      common /cdim/ idm,nde,ied
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      character*4 cmp1,cmp2,cmp3,cmp4,aa,no
      character*80 dummy
      dimension cmp1(3),cmp2(7),cmp3(12),cmp4(1)
      data no/'#'/
      data cmp1/'u','v','w'/,cmp2/'b','b44d','b55d','b66d','b56d',
     *      'b64d','b45d'/,cmp3/'b11','b22','b33','b23','b31',
     *      'b12','b44d','b55d','b66d','b56d','b64d','b45d'/,
     *      cmp4/'p'/
c*******************************************************************
c                      read initial parameters
c*******************************************************************
      call getinp(inpu)
      call getout(iout)
      call freadc('initial parameter',0,dummy,1)
      if(nde.ne.2) go to 500
      aa=cmp2(4)
      cmp2(4)=cmp2(7)
      cmp2(7)=aa
      aa=cmp3(9)
      cmp3(9)=cmp3(12)
      cmp3(12)=aa
 500  continue
c*******************************************************************
c             read independent initial amplitudes
c*******************************************************************
      if(iwflag(3).eq.1) then
           write(iout,201) (i,i=1,nw)
      end if
      do 10 i=1,na
      if(iwflag(3).eq.1) then
           write(iout,209) i
      end if
      if(dspmdl.eq.1) then
          do 11 j=1,3
          read(inpu,100) (x(i,j,k),mx(i,j,k),k=1,nw)
          if(iwflag(3).eq.1) then
               write(iout,200) atom(i),cmp1(j),
     *                  (x(i,j,k),mx(i,j,k),k=1,nw)
          end if
 11   continue
      end if
      if(tmpmdl.eq.1) then
          js=4
          je=3+it
c         if(itempf.eq.2.and.itfs(i).eq.0) je=3+it-5
          if(itempf.lt.0.and.itfs(i).eq.0) je=3+it-5
c         if(itempf.eq.1.or.itempf.eq.2.and.itfs(i).eq.1) go to 123
          if(itempf.ge.1.or.itempf.lt.0.and.itfs(i).eq.1) go to 123
          do 121 j=js,je
          read(inpu,100) (x(i,j,k),mx(i,j,k),k=1,nw)
          if(iwflag(3).eq.1) then
               write(iout,200) atom(i),cmp2(j-3),
     *                   (x(i,j,k),mx(i,j,k),k=1,nw)
          end if
 121      continue
c123      if(itempf.eq.0.or.itempf.eq.2.and.itfs(i).eq.0) go to 134
 123      if(itempf.eq.0.or.itempf.lt.0.and.itfs(i).eq.0) go to 134
          do 122 j=js,je
          read(inpu,100) (x(i,j,k),mx(i,j,k),k=1,nw)
          if(iwflag(3).eq.1) then
               write(iout,200) atom(i),cmp3(j-3),
     *                     (x(i,j,k),mx(i,j,k),k=1,nw)
          end if
 122      continue
 134      continue
      end if
      if(sctmdl.eq.1.or.sctmdl.eq.-1) then
          js=4+it
          je=4+it
c         if(itempf.eq.2.and.itfs(i).eq.0) js=4+it-5
c         if(itempf.eq.2.and.itfs(i).eq.0) je=4+it-5
          if(itempf.lt.0.and.itfs(i).eq.0) js=4+it-5
          if(itempf.lt.0.and.itfs(i).eq.0) je=4+it-5
          do 13 j=js,je
          read(inpu,100) (x(i,j,k),mx(i,j,k),k=1,nw)
          if(iwflag(3).eq.1) then
               write(iout,200) atom(i),cmp4(1),
     *                   (x(i,j,k),mx(i,j,k),k=1,nw)
          end if
 13       continue
      end if
 10   continue
c**********************************************************************
c                     variable parameter table
c**********************************************************************
c      read(inpu,112) jx,jb,jf
      call freadi('jx=',1,jx,1)
      call freadi('jb=',1,jb,0)
      call freadi('jf=',1,jf,0)
      if(iwflag(3).eq.1) then
           write(iout,207) jx,jb,jf
      end if
      ii=0
      ic=0
      ixs=1
      ixe=0
      ibs=1
      ibe=0
      ifs=1
      ife=0
      if(dspmdl.eq.1) then
c***********table for atom position****************
           do 21 i=1,na
           do 21 j=1,3
           do 21 k=1,nw
           if(mx(i,j,k).eq.' ') then
               ii=ii+1
               ic=ic+1
               ja(1,ic)=i
               ja(2,ic)=j
               ja(3,ic)=k
               ja(4,ii)=1
               ea(ic)=1.0
               x1(ii)=x(i,j,k)
           end if
 21        continue
           ixs=ii+1
           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
                write(iout,203)
                if(ii.ne.0) write(iout,202)
     *               (no,i,ja(1,i),ja(2,i),ja(3,i),ea(i),i=1,ic)
           end if
           if(jx.gt.0) then
               call freadc('positional parameter',0,dummy,1)
               call rdsymv(ja,ea,nzc,jx,ii,ic)
           end if
           ixe=ii
      end if
      i1=1
      i2=ii
      if(ii.gt.ix) call quit('*** increase ix***')
      if(tmpmdl.eq.1) then
c************table for temperature factor*************
           ij=ii+1
           jj=0
           if(iwflag(3).eq.1) then
                write(iout,204)
           end if
           do 22 i=1,na
           je=it
           js=isub(i)
c          if(itempf.eq.2.and.itfs(i).eq.0) je=it-5
           if(itempf.lt.0.and.itfs(i).eq.0) je=it-5
           do 22 j=1,je
           do 22 k=1,nw
           if(mx(i,j+3,k).eq.' ') then
               jj=jj+1
               ii=ii+1
c              if(itempf.eq.2.and.itfs(i).eq.0.and.j.eq.1) go to 220
               if(itempf.lt.0.and.itfs(i).eq.0.and.j.eq.1) go to 220
               ic=ic+1
               ja(1,ic)=i
               ja(2,ic)=j
c              if(itempf.eq.2.and.itfs(i).eq.0.and.j.gt.1) then
               if(itempf.lt.0.and.itfs(i).eq.0.and.j.gt.1) then
                   ja(2,ic)=j+5
               end if
               ja(3,ic)=k
               ja(4,ii)=1
               ea(ic)=1.0
               if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
                    if(itempf.eq.2) write(iout,202)
     *                 no,ii,ja(1,ic),ja(2,ic),ja(3,ic),ea(ic)
               end if
c220           if(itempf.ne.2.or.itfs(i).ne.0.or.j.ne.1) go to 222
 220           if(itempf.ge.0.or.itfs(i).ne.0.or.j.ne.1) go to 222
               ja(4,ii)=6
               do 221 kx=1,6
               ic=ic+1
               ja(1,ic)=i
               ja(2,ic)=kx
               ja(3,ic)=k
 221           ea(ic)=eat(kx,js)
               icw=ic-6
               if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
c                   if(itempf.eq.2) write(iout,202)
                    if(itempf.lt.0) write(iout,202)
     *                   (no,ii,ja(1,icw+l),ja(2,icw+l),
     *                       ja(3,icw+l),ea(icw+l),l=1,6)
               end if
 222           x1(ii)=x(i,j+3,k)
           end if
 22        continue
           ibs=ii+1
           k=ic-ii
           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
c                if(jj.ne.0.and.itempf.ne.2) write(iout,202)
                 if(jj.ne.0.and.itempf.ge.0) write(iout,202)
     *                     (no,i,ja(1,i+k),ja(2,i+k),
     *                       ja(3,i+k),ea(i+k),i=ij,ii)
           end if
           if(jb.gt.0) then
               call freadc('thermal parameter',0,dummy,1)
c              if(itempf.ne.2) call rdsymv(ja,ea,nzc,jb,ii,ic)
c              if(itempf.eq.2) call rdsymw(ja,ea,nzc,jb,ii,ic,isub)
               if(itempf.ge.0) call rdsymv(ja,ea,nzc,jb,ii,ic)
               if(itempf.lt.0) call rdsymw(ja,ea,nzc,jb,ii,ic,isub)
           end if
           ibe=ii
      end if
      i3=i2+1
      i4=ii
      if(ibe-ixe.gt.ib) call quit('****increase ib****')
      if(sctmdl.eq.1.or.sctmdl.eq.-1) then
c**********table for occupation probability**********
           ij=ii+1
           kk=0
           do 23 i=1,na
           je=it
c          if(itempf.eq.2.and.itfs(i).eq.0) je=it-5
           if(itempf.lt.0.and.itfs(i).eq.0) je=it-5
           do 23 j=1,1
           do 23 k=1,nw
           if(mx(i,j+3+je,k).eq.' ') then
               kk=kk+1
               ii=ii+1
               ic=ic+1
               ja(1,ic)=i
               ja(2,ic)=j
               ja(3,ic)=k
               ja(4,ii)=1
               ea(ic)=1.0
               x1(ii)=x(i,j+3+je,k)
           end if
 23        continue
           ifs=ii+1
           k=ic-ii
           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
                write(iout,205)
                if(kk.ne.0) write(iout,202)
     *                (no,i,ja(1,i+k),ja(2,i+k),ja(3,i+k)
     *                        ,ea(i+k),i=ij,ii)
           end if
           if(jf.gt.0) then
               call freadc('occupational parameter',0,dummy,1)
               call rdsymv(ja,ea,nzc,jf,ii,ic)
           end if
           ife=ii
      end if
      i5=i4+1
      i6=ii
      ios=ii+1
      if(ife-ibe.gt.if) call quit('****increase if****')  
c*****twin domain**************************************
      if(itwin.ne.0) then
           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
                write(iout,210)
           end if
           call freadc('twin parameter',0,dummy,1)
           call rdsymv(ja,ea,nzc,itvr,ii,ic)
      end if
      i7=i6+1
      i8=ii
c*****out of step**************************************
c      if(itwin.lt.0) then
c           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
c                write(iout,211)
c           end if
c           call freadc('out of step',0,dummy,1)
c           call rdsymv(ja,ea,nzc,itst,ii,ic)
c      end if
      i9=i8+1
      i10=ii
c*******************************************************************
c         read independent structural parameters related with
c           the constrained amplitudes and other parameters
c*******************************************************************
      ii=ii+nds
      i11=i10+1
      i12=ii
      if(isext.ne.0) ii=ii+2
      i13=i12+1
      i14=ii
      ioe=i14
      nu=ioe
c       nu: number of parameters
      if(ixe.ge.ixs.or.ibe.ge.ibs.or.ife.ge.ifs.or.ioe.ge.ios) then
          read(inpu,101) (x1(i),i=ixs,ixe),(x1(i),i=ibs,ibe),
     *                (x1(i),i=ifs,ife),(x1(i),i=ios,ioe)
      end if
c********************************************************************
      if(iwflag(3).eq.1) then
           write(iout,212) (x1(i),i=ixs,ixe),(x1(i),i=ibs,ibe),
     *            (x1(i),i=ifs,ife),(x1(i),i=ios,ioe)
      end if
c********************************************************************
      if(iwflag(3).eq.1) then
           write(iout,208)
      end if
      if(nde.ne.2) return
      aa=cmp2(4)
      cmp2(4)=cmp2(7)
      cmp2(7)=aa
      aa=cmp3(9)
      cmp3(9)=cmp3(12)
      cmp3(12)=aa
      return
 100  format((12x,6(f9.4,a1)))
 101  format(8(f9.4,1x))
 110  format(4i3,f12.6)
 111  format(4(3i3,f11.6))
 112  format(3i3)
 200  format(1h ,a,2x,a4,6(f9.5,a1)/(1h ,12x,6(f9.5,a1)))
 201  format(1h ,'fourier term',6i10/(1h ,12x,6i10))
 202  format((1h ,5(a1,i3,1x,3i3,f7.3,2x)))
 203  format(1h ,'positional parameter')
 204  format(1h ,'thermal parameter')
 205  format(1h ,'occupational parameter')
 206  format(1h ,'je=',i3,1x,'ja1=',i3,1x,'ja2=',i3,1x,'ja3=',i3,1x,
     *       'ea=',f12.6)
 207  format(1h ,'jx=',i3,1x,'jb=',i3,1x,'jf=',i3/1h ,
     *     'correspondence between fourier amplitudes and independent',
     *         ' parameters')
 208  format(1h1)
 209  format(1h ,'atom',i3)
 210  format(1h ,'domain size')
 211  format(1h ,'out of step')
 212  format(1h ,'additional parameters'/(1h ,(8f10.4)))
      end

      subroutine rdiobs(iwght)
      common /cwflag/ iwflag(6)
      common /fhkl/ hkln(100),fobs(100),fcal(100),wght(100),im(20),is(2)
     *         ,sf
      common /cdim/ idm,nde,ied
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      integer hkln,nslct,ih(6),hm,jh(6)
      integer h4,hd
c     common /islct/ hd(3),h4(3,40),nslct
      common /islct/ hd(6),h4(3,40),nslct
      common /filen/ flfobs,flfcal
      common /cnsti/ ix,ib,if,itvr,itst,nds,na4
      complex fcal
      character*26 flfobs,flfcal
      character*80 fmt
      common /chkln/ iex(6),hm(6)
      call getinp(inpu)
      call getout(iout)
c     open(unit=91,access='direct',recl=1200,file=flfobs)
c     open(unit=92,access='direct',recl=800,file=flfcal)

c      read(inpu,103) nslct,((h4(i,j),i=1,nde),j=1,nslct)
      call freadi('ng=',1,nslct,1)
      do 150 i=1,nslct
          call freadi('h3+i=',nde,h4(1,i),1)
 150  continue
      if(iwflag(3).eq.1) then
           write(iout,'(a,i3,a,20i3)') ' ng=',nslct,' h3+i=',
     *           ((h4(i,j),i=1,nde),j=1,nslct)
      end if
      if(nde.eq.3) go to 211
          j=nde+1
          do 212 k=1,nslct
          do 212 i=j,3
 212      h4(i,k)=0
 211  continue
c      read(inpu,105) fmin,wg0,hm
      call freadr('fmin=',1,fmin,1)
      call freadr('wg0=',1,wg0,0)
      call freadi('hm=',6,hm,0)
      if(iwflag(3).eq.1) then
           write(iout,201) fmin,wg0
      end if
c      read(inpu,100) inp,iorf,fmt
      call freadi('inp=',1,inp,1)
      call freadi('iorf=',1,iorf,0)
      call freadc('format=',1,fmt,0)
      if(iwflag(3).eq.1) then
           write(iout,202) inp,iorf,fmt
      end if
      do 21 i=1,6
      if(hm(i).ne.0) go to 20
 21   continue
      do 22 i=1,3
      j=i+3
      hm(i)=24
 22   hm(j)=10
 20   iex(6)=1
      do 24 i=1,5
      j=6-i
 24   iex(j)=iex(j+1)*(hm(j+1)*2+1)
      i=0
      is(1)=0
      is(2)=0
      sf=0.0
      iw1=0
      if(inp.ne.5) rewind 3
c****** read at least once even if nds=0 ******
      inde=max(1,nds)
c*******************************
      do 11 inds=1,inde
      ii=0
 10   continue
      i=mod(i,100)
      ih(4)=0
      ih(5)=0
      ih(6)=0
      if(inp.eq.5) read(inpu,fmt) (ih(j),j=1,idm),aiobs,wg
      if(inp.ne.5) read(3,fmt) (ih(j),j=1,idm),aiobs,wg
      if(ih(1).eq.999) go to 11
      iabsn=0
      if(nslct.gt.0) then
           if(ihslct(ih).eq.1) then
               go to 510
           else
               go to 10
           end if
      end if
 510  continue
      ii=ii+1
      i=i+1
      is(1)=is(1)+1
      hkln(i)=0
      do 17 j=1,6
           hkln(i)=hkln(i)+(ih(j)+hm(j))*iex(j)
 17   continue
      if(iorf.eq.1) then
         fobs(i)=aiobs
         sigmf=wg
      else if(iorf.ne.1) then
         fobs(i)=sqrt(aiobs)
         sigmf=(wg/fobs(i))/2
      end if
      wght(i)=wghtf(fobs(i),sigmf,iwght,fmin,wg,wg0)
      if(wght(i).ne.0.0) is(2)=is(2)+1
      sf=sf+fobs(i)**2*wght(i)
      if(i.eq.100) iw1=iw1+1
      if(i.eq.100) write(unit=91,rec=iw1) hkln,fobs,wght
      go to 10
 11   im(inds)=ii
      if(i.ne.0) write(unit=91,rec=iw1+1) hkln,fobs,wght
      if(iwflag(3).eq.1) then
           write(iout,200) is,hm
      end if
c     close(unit=91)
c     close(unit=92)
      return
 100  format(2i2,19a4)
 102  format(6f12.6)
 103  format(22i3)
 104  format(18i3)
 105  format(2f12.6,6i3)
 200  format(1h ,'number of total reflections',i5,5x,
     *            'number of reflections used',i5/1h ,
     *            'maximum miller indices',6i5)
 201  format(1h ,'fmin=',f12.6,3x,'wg0=',f12.6)
 202  format(1h ,'inp=',i3,3x,'iorf=',i3,3x,'format=',a)
      end

      function ihslct(ih)
      integer ih(*)
      integer os(3)
      integer h4,hd
c     common /islct/ hd(3),h4(3,40),nslct
      common /islct/ hd(6),h4(3,40),nslct
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /cdim/ idm,nde,ied
      integer hm
      common /chkln/ iex(6),hm(6)
      ihslct=1
      do 23 j=1,idm
           if(iabs(ih(j)).gt.hm(j)) then
               ihslct=-1
               return
           end if
 23   continue
      if(nslct.eq.0) return
      do 141 ia=1,nslct
      do 141 n=1,nsymo
          call gethr(ih,hd,rr,n)
          call isatel(hd,os)
          do 143 j=1,nde
          if(abs(os(j)-h4(j,ia)).gt.0) go to 144
 143      continue
          return
 144      do 145 j=1,nde
          if(abs(os(j)+h4(j,ia)).gt.0) go to 141
 145      continue
          return
 141  continue
      ihslct=0
      return
      end

      subroutine isatel(h,os)
c     order of satellite reflection
      integer h(*),os(*)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      common /cdim/ idm,nde,ied
      os(1)=abs(h(4))
      os(2)=abs(h(5))
      os(3)=abs(h(6))
      do 134 isub=2,nsub
           do 135 jd=4,idm
              j=zmtrx(jd,isub)
              if(abs(h(j)).lt.os(jd-3)) then
                   os(jd-3)=abs(h(j))
              end if
 135       continue
 134  continue
      return
      end

      function wghtf(fobs,sigmf,iwght,fmin,wg,wg0)
c     weighting scheme
      wghtf=wg
      if(iwght.eq.1.and.fobs.gt.fmin) wghtf=1.0
      if(iwght.lt.2.and.fobs.le.fmin) wghtf=wg0
c      if(iwght.eq.2.and.fobs.gt.fmin) wghtf=100.0/fobs**2
c      if(iwght.eq.2.and.fobs.le.fmin) wghtf=100.0/fmin**2
      if(iwght.eq.2) wghtf=1./(sigmf**2)
      if(iwght.eq.3.and.fobs.gt.fmin) wghtf=fobs/10.
      if(iwght.eq.3.and.fobs.le.fmin) wghtf=fmin/10.
      return
      end

      subroutine rdlc
      common /cwflag/ iwflag(6)
      common /ltccnt/ a,b,c,cosa,cosb,cosc,sina,sinb,sinc,
     *        as,bs,cs,cosas,cosbs,coscs,sinas,sinbs,sincs
      character*80 mater
      common /ctitle/ mater
      call getinp(inpu)
      call getout(iout)
c      read(inpu,99) mater
      call freadc('title=',1,mater,1)
c      read(inpu,100) a,b,c,cosa,cosb,cosc
      call freadr('a=',1,a,1)
      call freadr('b=',1,b,0)
      call freadr('c=',1,c,0)
      call freadr('cosa=',1,cosa,0)
      call freadr('cosb=',1,cosb,0)
      call freadr('cosc=',1,cosc,0)
      if(iwflag(2).eq.1) then
           write(iout,'(a)') mater
      end if
      if(iwflag(3).eq.1) then
           write(iout,300) a,b,c,cosa,cosb,cosc
      end if
      sina=sqrt(1.0-cosa**2)
      sinb=sqrt(1.0-cosb**2)
      sinc=sqrt(1.0-cosc**2)
      return
 100  format(6f12.6)
 300  format(1h ,'a=',f9.4,1x,'b=',f9.4,1x,'c=',f9.4,1x,
     *    'cosa=',f9.5,1x,'cosb=',f9.5,1x,'cosc=',f9.5)
      end


      subroutine rdpnf2
      common /cwflag/ iwflag(6)
c      common /cpnf2/ atom1(100),atom2(100),nsym(100),
c     *        icnt(100),trd(6,100),dmax(100),dmin(100),npi(100)
      common /cpnf2/ atom1(200),atom2(200),nsym(200),
     *        icnt(200),trd(6,200),dmax(200),dmin(200),npi(200)
      common /cpnf/ grad1,expn1,grad2,expn2,np
c      common /cpnf/ grad1,expn1,grad2,expn2,grad3,expn3,np
      integer atom1,atom2
      call getinp(inpu)
      call getout(iout)
c      read(inpu,100) np
      call freadi('nb=',1,np,1)
      if(iwflag(3).eq.1) then
           write(iout,200) np
      end if
      do 20 i=1,np
 20   npi(i)=0
      if(iwflag(3).eq.1) then
           write(iout,201)
      end if
      i=0
      j=1
 10   i=i+1
      read(inpu,110) atom1(i),atom2(i),nsym(i),icnt(i),(trd(k,i),k=1,6)
     *        ,rdmin,rdmax,icont
      if(icont.ne.0) icont=1
      npi(j)=npi(j)+1
      if(icont.eq.1) then
           if(iwflag(3).eq.1) then
                 write(iout,210) j,atom1(i),atom2(i),nsym(i),icnt(i),
     *                        (trd(k,i),k=1,6)
           end if
      else
           if(iwflag(3).eq.1) then
                 write(iout,210) j,atom1(i),atom2(i),nsym(i),icnt(i),
     *                        (trd(k,i),k=1,6),rdmin,rdmax
           end if
      end if
      if(icont.eq.0) then
           dmin(j)=rdmin
           dmax(j)=rdmax
           j=j+1
      end if
      if(j.ne.np+1) go to 10
      return
 100  format(i3)
 110  format(4i3,8f8.6,i3)
 200  format(1h ,'constraint condition for bond distances'/1h ,'nb=',
     *           i3)
 201  format(1h ,6x,'atom pair',24x,'additional translation vector'
     *          /1h ,'no.',2x,'atom 1',2x,
     *         'atom 2',2x,'sym. no.',2x,'icnt',4x,
     *         't1',9x,'t2',9x,'t3',9x,'t4',9x,'t5',9x,
     *         't6',9x,'dmin',7x,'dmax')
 210  format(1h ,i3,2x,2(i5,2x),1x,i5,5x,i3,3x,8f11.6)
      end

      subroutine rdextc(isext)
      common /cwflag/ iwflag(6)
      dimension cm(3,3),om(3,3),aa(10),bb(10),cc(10),ff(10)
      common /extcr1/ wv,abc0,cm,om,aa,bb,cc,ff,nbf,cef,cbt2,vol
      common /extcr2/ ex(1000),ey(1000),ez(1000),wxyz(1000),mp,mq,mr
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3)
c     read data for extinction correction
c      read(5,110) nbf,mp,mq,mr,icm
      call freadi('nbf=',1,nbf,1)
      call freadi('mp=',1,mp,0)
      call freadi('mq=',1,mq,0)
      call freadi('mr=',1,mr,0)
      call freadi('icm=',1,icm,0)
      if(nbf.gt.10) then
          call quit('nbf>10')
      end if
      if(mp*mq*mr.gt.1000) then
          call quit('mp*mq*mr>1000')
      end if
c      read(5,112) (aa(i),bb(i),cc(i),ff(i),i=1,nbf)
      do 9 i=1,nbf
      call freadr('aa=',1,aa(i),1)
      call freadr('bb=',1,bb(i),0)
      call freadr('cc=',1,cc(i),0)
      call freadr('ff=',1,ff(i),0)
 9    continue
c      read(5,111) wv,abc0,bth,amag
      call freadr('wv=',1,wv,1)
      call freadr('abc0=',1,abc0,0)
      call freadr('bth=',1,bth,0)
      call freadr('amag=',1,amag,0)
c     read(5,111) ((cm(i,j),j=1,3),i=1,3)
      call freadr('cm=',9,cm,1)
      call trnsp(cm)
      if(icm.eq.0) go to 20
          if(iwflag(3).eq.1) then
               write(6,213) ((cm(i,j),j=1,3),i=1,3)
          end if
          do 10 i=1,3
          do 10 j=1,3
          om(i,j)=0
          do 10 k=1,3
 10       om(i,j)=om(i,j)+cm(i,k)*gaby(k,j)
          do 11 i=1,3
          do 11 j=1,3
 11       cm(i,j)=om(i,j)
 20   continue
c     read(5,111) ((om(j,i),j=1,3),i=1,3)
      call freadr('om=',9,om,1)
      call trnsp(om)
      if(iwflag(3).eq.1) then
           write(6,210) nbf,mp,mq,mr,icm
           write(6,211) (aa(i),bb(i),cc(i),ff(i),i=1,nbf)
           write(6,212) wv,abc0,bth,amag
           write(6,213) ((cm(i,j),j=1,3),i=1,3)
           write(6,214) ((om(i,j),j=1,3),i=1,3)
      end if
c      if(nbf.eq.1) then
c          aa(1)=aa(1)**2
c          bb(1)=bb(1)**2
c          cc(1)=cc(1)**2
c          ff(1)=ff(1)**2
c      end if
      v=gabx(1,1)*gabx(2,2)*gabx(3,3)*amag
      if(isext.gt.0) then
           cef=(wv*28.18/v)**2
      else
           cef=(wv*10.0/v)**2
      end if
      cbt=cos(2.0*bth*6.28318/360.0)
      cbt2=cbt**2
      call table(mp,mq,mr,wxyz,ex,ey,ez,nbf,aa,bb,cc,ff)
      do 195 i=1,3
      do 195 j=1,3
 195  cm(i,j)=cm(i,j)*wv
      return
 110  format(26i3)
 111  format(10f8.5)
 112  format(4f8.5)
 210  format(1h ,'nbf',i3,3x,'mp',i3,3x,'mq',i3,3x,'mr',i3,3x,'icm',i3)
 211  format(1h ,'boundary functions'/1h ,5x,'aa',10x,'bb',10x,'cc',
     *        10x,'ff'/(1h ,4f12.5))
 212  format(1h ,'wave length',f12.5,6x,'linear absorption coef.',
     *        f12.5,6x,'bragg angle of monochrometer',f12.5/1h ,
     *       'magnification of calculated structure factors',f12.5)
 213  format(1h ,'cell orientation matrix'/(1h ,3f12.5))
 214  format(1h ,'orientation matrix'/(1h ,3f12.5))
      end

      subroutine trnsp(am)
      real am(3,3),bm(3,3)
      do 100 i=1,3
      do 100 j=1,3
          bm(j,i)=am(i,j)
 100  continue
      do 200 i=1,3
      do 200 j=1,3
          am(i,j)=bm(i,j)
 200  continue
      return
      end

      subroutine rdsymo(na,isk)
      common /cwflag/ iwflag(6)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /cctr/ ctr(6,0:48),nctr
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      common /bgn/ ilm(3),icorc(3),ilc(3)
      common /kwave/ y(3,3,3),vc(3)
      common /cdim/ idm,nde,ied
      dimension imps(48),fmt(2)
      integer rg(6,6,5)
      real tg(6,5)
      character*4 fmt
      character*30 coord
c     character cbrv(7),brv*5
      character*80 str
c     data str
c     *    /'give reflection conditions for general reflections'/
c     data cbrv/'p','a','b','c','i','f','r'/
      data fmt/'in','  '/
      call getinp(inpu)
      call getout(iout)
c     initialozation
      do 16 i=1,3
      ilm(i)=1
      ilc(i)=1
      icorc(i)=0
      do 16 j=1,3
 16   y(j,i,1)=0.0
c 16   y(i,j)=0.0
c      read(inpu,100) nde,nsymo,icent,ige,nctr
      call freadi('ndm=',1,nde,1)
      call freadi('nsymo=',1,nsymo,0)
      call freadi('icent=',1,icent,0)
      call freadi('ige=',1,ige,0)
      call freadi('nctr=',1,nctr,0)
      do 17 nd=1,nde
c       read(inpu,*) (y(i,nd,1),i=1,3),icorc(nd),ilm(nd)
        call freadr('k=',3,y(1,nd,1),1)
        call freadi('icorc=',1,icorc(nd),0)
        call freadi('ilm=',1,ilm(nd),0)
 17   continue

      icom=0
      do 18 nd=1,nde
          if(icorc(nd).eq.0) then
             icom=1
             ilm(nd)=1
          end if
 18   continue
c
c      if(icom.eq.1) read(inpu,100) ilc
      if(icom.eq.1) call freadi('ilc=',3,ilc,1)
      if(iwflag(3).eq.1) then
           write(iout,210) nde,nsymo,icent,ige,nctr
      end if
      idm=nde+3
      if(iwflag(3).eq.1) then
           write(iout,205)
      end if
      do 60 nd=1,nde
      if(icorc(nd).eq.1) ii=1
      if(icorc(nd).eq.0) ii=2
      if(iwflag(3).eq.1) then
           write(iout,204) nd,(y(j,nd,1),j=1,3),icorc(nd),ilm(nd),
     *                     fmt(ii)
      end if
 60   continue
      if(iwflag(3).eq.1) then
           if(icom.eq.1) write(iout,211) ilc
           write(iout,'(1h )')
      end if
      do 8 k=1,6
         ctr(k,0)=0
 8    continue
      if(nctr.gt.0) then
c         read(inpu,*) 'centring translation'
          call freadc('centering translation',0,dummy,1)
          do 9 k=1,nctr
          read(inpu,'(a)') coord
          call decod1(coord,ctr(1,1),k)
 9        continue
      end if
c     read(inpu,*) 'symmetry operator'
      call freadc('symmetry operator',0,dummy,1)
      do 10 k=1,nsymo
      read(inpu,'(a)') coord
      call decode(coord,rr,tt,k)
 10   continue
c*****call getri(re,ri,nsymo,y,nde)
      if(iwflag(3).eq.1) then
           if(nctr.gt.0) then
                call wtctr(ctr,nctr,idm)
           end if
           if(icent.eq.1) then
                 write(iout,2022)
           else
                 write(iout,2021)
           end if
           if(ige.eq.1) then
                write(iout,201) 'generating elements'
           end if
           write(iout,'(1h )')
      end if
      nn=nde+1
      if(iwflag(3).eq.1) then
           call wtsymo(rr,tt,nsymo,idm)
      end if
      if(ige.eq.1) then
           call ordr(rr,imps,nsymo,idm)
           do 123 i=1,nsymo
           do 123 j=1,idm
           tg(j,i)=tt(j,i,1)
           do 123 k=1,idm
           rg(j,k,i)=rr(j,k,i,1)
 123       continue
           impt=1
           do 13 i=1,6
           tt(i,1,1)=0.0
           do 13 j=1,6
           rr(i,j,1,1)=0.0
           rr(i,i,1,1)=1.0
 13        continue
           do 50 ns=1,nsymo
           imp=imps(ns)
           do 11 i=2,imp
           do 11 j=1,impt
           mp1=j+(i-2)*impt
           mp2=j+(i-1)*impt
           call mpso(rg,tg,ns,rr,tt,mp1,mp2,idm)
 11        continue
 50        impt=impt*imp
           nsymo=impt
           if(iwflag(3).eq.1) then
                write(iout,207)
                write(iout,'(1h )')
                call wtsymo(rr,tt,nsymo,idm)
           end if
      end if
 81   continue
      do 85 n=2,nsub
          write(6,*) 'substructure',n
c         symmetry operators for the i-th subsystem
          do 86 ns=1,nsymo
              call getzrz(zmtrx(1,n),rr(1,1,ns,1),rr(1,1,ns,n))
              call getzx(zmtrx(1,n),tt(1,ns,1),tt(1,ns,n))
 86       continue
           call wtsymo(rr(1,1,1,n),tt(1,1,n),nsymo,idm)
 85   continue
      return
 100  format(7i3)
 101  format(9i3,3f9.6,i3)
 102  format(3f8.5,2i3)
 103  format(24i3)
 200  format(1h ,2x,i2,4x,9f6.2,5x,3f10.6,5x,i3)
 201  format(1h ,a)
 2021 format(1h ,'symmetry operation',10x,'noncentrosymmetric')
 2022 format(1h ,'symmetry operation',10x,'centrosymmetric')
 204  format(1h ,'wavevector k',i1,10x,3f9.6,3x,'icorc=',i3,2x
     *       ,'ilm=',i3,2x,a2,'commensurate')
 205  format(1h ,'basic wavevectors')
 206  format(1h ,'generating elements')
 207  format(1h ,'symmetry operators generated by generating elements')
 208  format(1h ,i3,10x,24i3)
 209  format(1h ,'atom',9x,'symmetry operator to be skipped =1')
 210  format(1h ,'ndm=',i2,2x,'nsymo=',i3,2x,'icent=',i2,2x,'ige=',
     *           i2,2x,'nctr=',i2)
 211  format(1h ,'periods along a,b,c axes' ,3i5)
 230  format(1h ,7i5)
      end

      subroutine getrr(rr,tt,ns,re,ri,te,ti)
      integer rr(6,6,*),re(3,3,*),ri(3,3,*)
      real tt(6,*),te(3,*),ti(3,*)
      common /cdim/ idm,nde,ied
      common /kwave/ y(3,3,3),vc(3)
      call getinp(inpu)
      call getout(iout)
      do 12 i=1,idm
      if(i.le.3) then
           tt(i,ns)=te(i,ns)
      else
           tt(i,ns)=ti(i-3,ns)
      end if
      do 12 j=1,idm
      if(i.le.3.and.j.le.3) then
           rr(i,j,ns)=re(i,j,ns)
      else if(i.le.3.and.j.gt.3) then
           rr(i,j,ns)=0
      else if(i.gt.3.and.j.le.3) then
           rr(i,j,ns)=0
           do 121 k=1,3
 121       rr(i,j,ns)=rr(i,j,ns)+y(k,i-3,1)*re(k,j,ns)
c 121       rr(i,j,ns)=rr(i,j,ns)+y(i-3,k)*re(k,j,ns)
           do 122 k=1,nde
 122       rr(i,j,ns)=rr(i,j,ns)-ri(i-3,k,ns)*y(j,k,1)
c 122       rr(i,j,ns)=rr(i,j,ns)-ri(i-3,k,ns)*y(k,j)
      else
           rr(i,j,ns)=ri(i-3,j-3,ns)
      end if
 12   continue
      do 13 i=1,6
      do 13 j=idm+1,6
 13   rr(i,j,ns)=0
      do 14 i=idm+1,6
      do 14 j=1,6
 14   rr(i,j,ns)=0
      do 15 i=idm+1,6
 15   tt(i,ns)=0
      return
      end


      subroutine ordr(re,imps,nsymo,idm)
      integer re(6,6,*),imps(*)
      integer r(6,6),a(6,6),b(6,6)
      data eps/0.001/
      call getinp(inpu)
      call getout(iout)
      do 10 i=1,nsymo
           do 11 j=1,idm
           do 11 k=1,idm
           r(j,k)=re(j,k,i)
 11        b(j,k)=r(j,k)
           do 12 j=1,7
c    check whether r is identity operator or not
                do 16 k=1,idm
                if(r(k,k).ne.1) go to 15
                do 16 l=1,idm
                if(k.ne.l.and.r(k,l).ne.0) go to 15
 16             continue
                imps(i)=j
                go to 10
c       a=r
 15             do 13 k=1,idm
                do 13 l=1,idm
 13             a(k,l)=r(k,l)
c       r=a*b   ==> r=r*re
                do 14 k=1,idm
                do 14 l=1,idm
                r(k,l)=0
                do 14 m=1,idm
 14             r(k,l)=r(k,l)+a(k,m)*b(m,l)
 12        continue
 10   continue
      do 20 i=1,nsymo
      if(imps(i).ge.7) then
           ierror=1
           go to 21
      else
           ierror=0
      end if
 20   continue
 21   continue
      if(ierror.eq.1) then
           write(iout,'(1h ,''error in symmetry operator ?'',a,24i3)')
     *      '  order: ',(imps(i),i=1,nsymo)
      end if
      return
      end

      subroutine wtctr(ctr,nctr,idm)
      real ctr(6,0:*)
      common /cwflag/ iwflag(6)
      character*3 wctr(6,48)
      integer wd(3),w
      data wd/6,5,4/,eps/0.001/
      call getinp(inpu)
      call getout(iout)
      write(iout,'(1h )')
      write(iout,*) 'centering translation'
      call getwtt(ctr(1,1),wctr,nctr,idm)
      if(idm.eq.4) write(iout,204) ((wctr(i,k),i=1,idm),k=1,nctr)
      if(idm.eq.5) write(iout,205) ((wctr(i,k),i=1,idm),k=1,nctr)
      if(idm.eq.6) write(iout,206) ((wctr(i,k),i=1,idm),k=1,nctr)
      if(i.eq.idm) write(iout,'(1h )')
      return
 204  format(1h ,4(3(a,','),a,';   '))
 205  format(1h ,4(5(a,','),a,';   '))
 206  format(1h ,4(6(a,','),a,';   '))
      end 

      subroutine wtsymo(rr,tt,nsymo,idm)
      integer rr(6,6,*)
      real tt(6,*)
      common /cwflag/ iwflag(6)
      character*3 wtt(6,48)
      integer wd(3),w
      data wd/6,5,4/,eps/0.001/
      call getinp(inpu)
      call getout(iout)
      w=wd(idm-3)
      ll=(nsymo-1)/w+1
      le=nsymo-(ll-1)*w
      call wtsmop(rr,tt,nsymo,idm-3,3)
      write(iout,'(1h )')
      call getwtt(tt,wtt,nsymo,idm)
      do 31 ii=1,ll
      lbgn=(ii-1)*w+1
      if(ii.ne.ll) lend=lbgn+w-1
      if(ii.eq.ll) lend=lbgn+le-1
      do 31 i=1,idm
      if(idm.eq.4) write(iout,204) ((rr(i,j,k),j=1,idm),wtt(i,k),
     *                 k=lbgn,lend)
      if(idm.eq.5) write(iout,205) ((rr(i,j,k),j=1,idm),wtt(i,k),
     *                 k=lbgn,lend)
      if(idm.eq.6) write(iout,206) ((rr(i,j,k),j=1,idm),wtt(i,k),
     *                 k=lbgn,lend)
      if(i.eq.idm) write(iout,'(1h )')
 31   continue
      return
 204  format(1h ,8(4i2,1x,a,2x))
 205  format(1h ,7(5i2,1x,a,2x))
 206  format(1h ,6(6i2,1x,a,2x))
      end

      subroutine getwtt(tt,wtt,nsymo,idm)
      real tt(6,*)
      character*3 wtt(6,*)
      real rt(8)
      character*3 wt(8)
      data rt/0.,0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data wt/' 0 ','1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data eps/0.00001/
      call getinp(inpu)
      call getout(iout)
      do 100 i=1,nsymo
         do 110 j=1,idm
            td=tt(j,i)
            td=mod(td,1.)
            if(td.lt.-eps) then
               td=td+1
            else if(td.gt.1-eps) then
               td=td-1
            end if
            do 120 k=1,8
               if(abs(td-rt(k)).lt.eps) then
                  if(k.eq.1) then
                     write(wtt(j,i),fmt='(i2)') int(tt(j,i))
                  else
                     wtt(j,i)=wt(k)
                  end if
                  go to 110
               end if
 120        continue
 110     continue
 100  continue
      return
      end

      subroutine mpso(r1,t1,m1,r2,t2,m2,m3,idm)
      integer r1(6,6,*),r2(6,6,48,*)
      real t1(6,*),t2(6,48,*)
      do 10 i=1,idm
         t2(i,m3,1)=0.0
         do 11 j=1,idm
            t2(i,m3,1)=t2(i,m3,1)+r1(i,j,m1)*t2(j,m2,1)
 11      continue
         t2(i,m3,1)=t2(i,m3,1)+t1(i,m1)
********************************************
         tt=t2(i,m3,1)
         t2(i,m3,1)=mod(tt,1.)
********************************************
         do 12 j=1,idm
            r2(i,j,m3,1)=0.0
            do 13 k=1,idm
               r2(i,j,m3,1)=r2(i,j,m3,1)+r1(i,k,m1)*r2(k,j,m2,1)
 13         continue
 12      continue
 10   continue
      return
      end

      subroutine rdtsym(itwin)
      common /cwflag/ iwflag(6)
      integer rr
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cdim/ idm,nde,ied
      character*30 coord
      character*80 dummy
      call getinp(inpu)
      call getout(iout)
c     read twin operators
c      read(inpu,*) 'twin operator'
      call freadc('twin operator',0,dummy,1)
      if(itwin.ge.1) write(iout,203) 'twin operator'
c     if(itwin.lt.0) write(iout,203) 'twin operator for coherent twin'
      write(iout,'(1h )')
      ie=iabs(itwin)
      do 11 i=1,ie
      j=nsymo+i
      read(inpu,'(a)') coord
      call decode(coord,rr,tt,j)
 11   continue
      if(iwflag(3).eq.1) then
           call wtsymo(rr(1,1,nsymo+1,1),tt(1,nsymo+1,1),ie,idm)
      end if
      return
 101  format(9f5.3,3f9.6)
 201  format(1h ,2x,i2,4x,9f6.2,5x,3f10.6,5x,f10.6)
 203  format(1h ,a)
      end

      subroutine rdsymv(ja,ea,nzc,jx,ix,in)
      common /cwflag/ iwflag(6)
      dimension ea(*),ja(4,*),ia(4),jr(4,3),er(4)
      character*4 ql,no,ia
      data ql/' '/,no/'#'/
      call getinp(inpu)
      call getout(iout)
      if(jx.eq.0) return
      if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
           write(iout,201)
      end if
      ix0=ix
      jn=in
      ja4=0
 1    continue
      read(inpu,101) ((jr(i,j),j=1,3),er(i),ia(i),i=1,4)
      do 13 i=1,4
      if(ia(i).eq.' '.and.jr(i,1).eq.0.and.jr(i,2).eq.0
     *       .and.jr(i,3).eq.0) go to 13
      in=in+1
      ja4=ja4+1
      if(ia(i).eq.' ') ix=ix+1
      if(in.gt.nzc) go to 20
      do 14 j=1,3
 14   ja(j,in)=jr(i,j)
      ea(in)=er(i)
      if(ia(i).eq.' ') ja(4,ix)=ja4
      if(ia(i).eq.' ') ja4=0
 20   if(ia(i).eq.' '.and.ix-ix0.eq.jx) go to 15
 13   continue
      go to 1
 15   if(in.gt.nzc.and.ix-ix0.lt.jx) go to 1
      if(in.gt.nzc.and.ix-ix0.eq.jx) go to 99
      ix1=ix0+1
      do 10 i=ix1,ix
      nz=ja(4,i)
      if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
           write(iout,202) (no,i,(ja(j,n+jn),j=1,3),ea(n+jn),n=1,nz)
      end if
 10   jn=jn+nz
      return
 99   l=in-nzc
      write(iout,203) l
      stop
 101  format(4(3i3,f10.6,a1))
 201  format(1h )
 202  format((1h ,5(a1,i3,1x,3i3,f9.4,3x)))
 203  format(1h ,'lack of nzc',i6)
      end

      subroutine rdsymw(ja,ea,nzc,jx,ix,in,isub)
      common /cwflag/ iwflag(6)
      dimension ea(*),ja(4,*),ia(4),jr(4,3),er(4),isub(*)
      common /ceat/ eat(6,3)
      common /citfs/ itfs(100)
      character*4 ia
      call getinp(inpu)
      call getout(iout)
      if(jx.eq.0) return
      if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
           write(iout,201)
      end if
      ix0=ix
      jn=in
      ja4=0
 1    continue
      read(inpu,101) ((jr(i,j),j=1,3),er(i),ia(i),i=1,4)
      do 13 i=1,4
      if(ia(i).eq.' '.and.jr(i,1).eq.0.and.jr(i,2).eq.0
     *       .and.jr(i,3).eq.0) go to 13
      kend=1
      if(ia(i).eq.' ') ix=ix+1
      if(itfs(jr(i,1)).eq.0.and.jr(i,2).eq.1) kend=6
      do 30 k=1,kend
      in=in+1
      ja4=ja4+1
      if(in.gt.nzc) go to 20
      do 14 j=1,3
 14   ja(j,in)=jr(i,j)
      ea(in)=er(i)
      if(itfs(jr(i,1)).eq.0.and.jr(i,2).eq.1) ja(2,in)=k
      if(itfs(jr(i,1)).eq.0.and.jr(i,2).gt.1) ja(2,in)=jr(i,2)+5
      if(itfs(jr(i,1)).eq.0.and.jr(i,2).eq.1) then
           js=isub(ja(1,in))
           ea(in)=er(i)*eat(k,js)
      end if
 30   continue
      if(ia(i).eq.' ') ja(4,ix)=ja4
      if(ia(i).eq.' ') ja4=0
 20   if(ia(i).eq.' '.and.ix-ix0.eq.jx) go to 15
 13   continue
      go to 1
 15   if(in.gt.nzc.and.ix-ix0.lt.jx) go to 1
      if(in.gt.nzc.and.ix-ix0.eq.jx) go to 99
      ix1=ix0+1
      do 10 i=ix1,ix
      nz=ja(4,i)
      if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
           write(iout,202) (i,(ja(j,n+jn),j=1,3),ea(n+jn),n=1,nz)
      end if
 10   jn=jn+nz
      return
 99   l=in-nzc
      write(iout,203) l
      stop
 101  format(4(3i3,f10.6,a1))
 201  format(1h )
 202  format((1h ,5(i3,'#',1x,3i3,f9.4,3x)))
 203  format(1h ,'lack of nzc',i6)
      end
c
      subroutine wtsmop(r1,t1,nsymo,d1,d2)
c*******************************************************************
c         representation of symmetry operators in the i.t. format
c*******************************************************************
      implicit integer (a-z)
      dimension r1(6,6,*)
      dimension r(6,6),lenc(48),ip(16)
      real t1(6,*),t(6),eps,cnt2(27,6),rtr(7)
      character xyz(6)
c        for (d2+d1) dimensional case
      character*31 z1(48),bl
      character*3 ntr(7)
      data xyz/'x','y','z','t','u','v'/
      data ntr/'1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data rtr/0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data bl/'                            '/
      call getinp(inpu)
      call getout(iout)
      eps=0.00001
      d3=d1+d2
c******** write centering translations *********
c      if(ncnt.gt.1) then
c      do 50 i=1,ncnt
c      z1(i)=bl
c      cp=0
c      if(i.eq.1) then
c           z1(1)(1:1)='('
c           cp=1
c      end if
c      do 51 j=1,d3
c          do 52 k=1,7
c          if(abs(rtr(k)-cnt2(i,j)).lt.eps) then
c               z1(i)(cp+1:cp+3)=ntr(k)
c               cp=cp+3
c               go to 51
c          end if
c 52       continue
c          if(abs(cnt2(i,j)).lt.eps) then
c               z1(i)(cp+1:cp+1)='0'
c               cp=cp+1
c          end if
c 51   continue
c      if(i.lt.ncnt) then
c           z1(i)(cp+1:cp+1)=';'
c           cp=cp+1
c      else
c           z1(i)(cp+1:cp+1)=')'
c           cp=cp+1
c      end if
c      ip(i)=cp
c 50   continue
c      write(iout,'(1h ,6a)') (z1(i)(1:ip(i)),i=1,ncnt)
c      end if
c******** write symmetry operators *******
      do 10 ii=1,nsymo
           cp=1
           do 11 i=1,d3
           t(i)=t1(i,ii)
           do 11 j=1,d3
 11        r(i,j)=r1(i,j,ii)
           do 15 i=1,d3
                t(i)=mod(t(i),1.0)
                if(t(i).lt.eps) then
                     t(i)=t(i)+1
                else if(t(i).gt.1.0-eps) then
                     t(i)=t(i)-1
                end if
 15        continue
           do 14 i=1,22
           z1(ii)=bl
 14        continue
           do 13 i=1,d3
           do 131 j=1,7
           if(abs(t(i)-rtr(j)).le.eps) then
                z1(ii)(cp:cp+2)=ntr(j)
                cp=cp+3
                go to 132
           end if
 131       continue
           if(abs(t1(i,ii)).gt.eps) then
              if(t1(i,ii).gt.eps) then
                 write(z1(ii)(cp:cp),fmt='(i1)') int(t1(i,ii))
                 cp=cp+1
              else
                 write(z1(ii)(cp:cp+1),fmt='(i2)') int(t1(i,ii))
                 cp=cp+2
              end if
           end if
 132       continue
           do 12 j=1,d3
           if(j.le.d2) then
                k=j
           else if(j.gt.d2) then
                k=j+(3-d2)
           end if
           if(r(i,j).eq.1) then
                if(cp.eq.1) then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                else if(z1(ii)(cp-1:cp-1).eq.',') then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                else
                     z1(ii)(cp:cp+1)='+'//xyz(k)
                     cp=cp+2
                end if
           else if(r(i,j).eq.-1) then
                z1(ii)(cp:cp+1)='-'//xyz(k)
                cp=cp+2
           end if
           if(j.eq.d3.and.i.ne.d3) then
                z1(ii)(cp:cp)=','
                cp=cp+1
           else if(j.eq.d3.and.i.eq.d3) then
                z1(ii)(cp:cp)=';'
                cp=cp+1
           end if
 12        continue
 13        continue
           lenc(ii)=istrln(z1(ii))
 10   continue
      write(iout,'(1h ,6(a,1x))') (z1(ii)(1:lenc(ii)),ii=1,nsymo)
      return
      end

      subroutine decod1(coord,t,n)
c     centering translation in I.T into matrix representation
      character coord*30
      real t(6,*)
      common /cdim/ idm,nde,ied
      character sym(6)*20,xyz(6)
      call getinp(inpu)
      call getout(iout)
c     position of ',' 
      i=1
      do 10 k=1,idm-1
         m=index(coord(i:30),',')
         if(m.eq.0) call quit(' incorrect centering translation')
         sym(k)=coord(i:i+m-2)
         i=i+m
 10   continue
      sym(idm)=coord(i:30)
c
      do 30 j=1,idm
         t(j,n)=0
         i=index(sym(j),'/')
         if(i.gt.0) then
            read(sym(j)(i-1:i-1),'(i1)') n1
            read(sym(j)(i+1:i+1),'(i1)') n2
            t(j,n)=float(n1)/float(n2)
            if(i.ne.2.and.sym(j)(i-2:i-2).eq.'-') t(j,n)=-t(j,n)
         endif
   30 continue
      end

      subroutine decode(coord,r,t,n)
c     symmetry operation in I.T into matrix representation
      character coord*30
      integer r(6,6,*)
      real t(6,*)
      common /cdim/ idm,nde,ied
      character sym(6)*20,xyz(6)
      data xyz/'x','y','z','t','u','v'/
      call getinp(inpu)
      call getout(iout)
c     position of ',' 
      i=1
      do 10 k=1,idm-1
         m=index(coord(i:30),',')
         if(m.eq.0) call quit(' incorrect symmetry operation')
         sym(k)=coord(i:i+m-2)
         i=i+m
 10   continue
      sym(idm)=coord(i:30)
c
      do 30 j=1,idm
         t(j,n)=0
         do 20 k=1,idm
            r(j,k,n)=0
   20    continue
c
c        rotation matrix
         do 25 k=1,idm
            i=index(sym(j),xyz(k))
            if(i.gt.0) then
               if(i.eq.1) then
                  r(j,k,n)=1
               else
                  if(sym(j)(i-1:i-1).eq.'+') then
                     r(j,k,n)=1
                  else
                     r(j,k,n)=-1
                  endif
               endif
            endif
   25    continue
c
c        translation vector
         i=index(sym(j),'/')
         if(i.gt.0) then
            read(sym(j)(i-1:i-1),'(i1)') n1
            read(sym(j)(i+1:i+1),'(i1)') n2
            t(j,n)=float(n1)/float(n2)
            if(i.ne.2.and.sym(j)(i-2:i-2).eq.'-') t(j,n)=-t(j,n)
         endif
   30 continue
      end

      subroutine freadi(prfx,n,var,nl)
      integer var(*)
      character*(*) prfx
      integer ip,ep
      character*256 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      if(nl.eq.1) then
           read(inpu,'(a)',end=200) buf
           ip=1
      end if
      ipd=index(buf(ip:256),prfx)
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else if(nl.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      jp=ep+1
      do 150 i=1,n
          do 10 j=jp,256
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue

          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp:256),' ')
          ipd2=index(buf(jp:256),',')
          if(ipd1.gt.0.and.ipd2.gt.0) then
              jp=min(ipd1,ipd2)+jp
          else if(ipd1.gt.0) then
              jp=ipd1+jp
          else if(ipd2.gt.0) then
              jp=ipd2+jp
          else
              jp=256
          end if
c         jp: beginning of next prefix or value
 150  continue
      if(jp.eq.256) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      read(buf(ep+1:jp),*) (var(i),i=1,n)
      ip=jp
      return
 200  continue
           write(iout,'(2a)') prfx,' not found'
           call quit(' ')
      return
      end

      subroutine freadr(prfx,n,var,nl)
      real var(*)
      character*(*) prfx
      integer ip,ep
      character*256 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      if(nl.eq.1) then
           read(inpu,'(a)',end=200) buf
           ip=1
      end if
      ipd=index(buf(ip:256),prfx)
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else if(nl.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
c      if(ipd.eq.0) then
c           write(iout,'(2a)') prfx,' not found'
c           call quit(' ')
c      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      jp=ep+1
      do 150 i=1,n
          do 10 j=jp,256
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue
          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp:256),' ')
          ipd2=index(buf(jp:256),',')
          if(ipd1.gt.0.and.ipd2.gt.0) then
              jp=min(ipd1,ipd2)+jp
          else if(ipd1.gt.0) then
              jp=ipd1+jp
          else if(ipd2.gt.0) then
              jp=ipd2+jp
          else
              jp=256
          end if
c         jp: beginning of next prefix or value
 150  continue
      if(jp.eq.256) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      read(buf(ep+1:jp-1),*) (var(i),i=1,n)
      ip=jp
      return
 200  continue
          write(iout,'(2a)') prfx,' not found'
          call quit(' ')
      return
      end

      subroutine freadc(prfx,n,var,nl)
      character*(*) var(*)
      character*(*) prfx
      integer ip,ep
      character*256 buf
      common /cbuf/ buf,ip
      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      lval=len(var(1))
      if(nl.eq.1) then
           read(inpu,fmt='(a)',end=200) buf(1:256)
           ip=1
      end if
      ipd=index(buf(ip:256),prfx)
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else if(nl.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
c      if(ipd.eq.0) then
c           write(iout,'(2a)') prfx,' not found'
c           call quit(' ')
c      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      jp=ep+1
      do 150 i=1,n
          do 10 j=jp,256
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue
          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp+1:256),'''')
          if(ipd1.gt.0) then
              jp=ipd1+jp+1
          else
              jp=256
          end if
c         jp: beginning of the next prefix or value
 150  continue
      if(jp.eq.256) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      read(buf(ep+1:jp-1),*) (var(i)(1:lval),i=1,n)
      ip=jp
      return
 200  continue
           write(iout,'(2a)') prfx,' not found'
           call quit(' ')
      return
      end

      function istrln(c)
      character*(*) c
      l=len(c)
      do 10 i=l,1,-1
      if(c(i:i).ne.' ') then
          istrln=i
          return
      end if
 10   continue
      istrln=0
      return
      end

      function ioval()
      common /cwflag/ iwflag(6)
      character*6 atom
      common /cltc/ atom(100)
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand
      common /cdim/ idm,nde,ied
      integer rr
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      integer hkln,nslct,ih(6),hm
      integer h4,hd
c     common /islct/ hd(3),h4(3,40),nslct
      common /islct/ hd(6),h4(3,40),nslct
      entry idmf()
          idmf=idm
      return
      entry ndef()
          ndef=nde
      return
      end

      subroutine setinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cinpu=inpu
      return
      end

      subroutine setout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      coutu=iout
      return
      end

      subroutine getinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      inpu=cinpu
      return
      end

      subroutine getout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iout=coutu
      return
      end

      subroutine setskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cskip=iskp
      return
      end

      subroutine getskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iskp=cskip
      return
      end

      subroutine getzx(zmtrx,x,zx)
      integer zmtrx(*)
      real x(*),zx(*)
      do 100 i=1,6
         zx(i)=x(zmtrx(i))
 100  continue
      return
      end

      subroutine gethz(zmtrx,h,hz)
      integer zmtrx(*),h(*),hz(*)
      do 100 i=1,6
         hz(i)=h(zmtrx(i))
 100  continue
      return
      end

      subroutine getzrz(zmtrx,r,zrz)
      integer zmtrx(*),r(6,*),zrz(6,*)
      do 100 i=1,6
      do 110 j=1,6
          zrz(i,j)=r(zmtrx(i),zmtrx(j))
 110      continue
 100  continue
      return
      end

      subroutine table(mp,mq,mr,wxyz,x,y,z,nbf,aa,bb,cc,ff)
      dimension x(mp,mq,mr),y(mp,mq,mr),z(mp,mq,mr),wxyz(mp,mq,mr)
     *        ,aa(1),bb(1),cc(1),ff(1)
      dimension a(3,3),b(3),ipivot(3),index(3,2),pivot(3)
      common /bgn1/ilm(3),icorc(3),pxj(100,3),hj(100,3)
      wt(x1,x2,x3,h,p,q,f)=h*x1+p*x2+q*x3-f
      fuvw(c,f)=-sqrt(f/c)
      eps=1.e-06
      ilm(1)=mp
      ilm(2)=mq
      ilm(3)=mr
      do 100 i=1,3
 100  icorc(i)=1
      call gauss1
      if(nbf.ne.1) go to 150
      do 502 np=1,mp
      do 502 nq=1,mq
      do 502 nr=1,mr
      do 502 i=1,nbf
c     f0=ff(i)
      f0=ff(i)**2
      ua=fuvw(aa(i),f0)
      ub=-ua
      du=ub-ua
      rx    =hj(np,1)*du
      x(np,nq,nr)=ua+(pxj(np,1)+0.5)*du
      f1=f0-aa(i)*x(np,nq,nr)**2
      va=fuvw(bb(i),f1)
      vb=-va
      dv=vb-va
      ry    =hj(nq,2)*dv
      y(np,nq,nr)=va+(pxj(nq,2)+0.5)*dv
      f2=f1-bb(i)*y(np,nq,nr)**2
      wa=fuvw(cc(i),f2)
      wb=-wa
      dw=wb-wa
      rz    =hj(nr,3)*dw
      z(np,nq,nr)=wa+(pxj(nr,3)+0.5)*dw
      wxyz(np,nq,nr)=rx*ry*rz
 502  continue
      return
 150  do 13 i=1,nbf
      absa=sqrt(aa(i)**2+bb(i)**2+cc(i)**2)
      aa(i)=aa(i)/absa
      bb(i)=bb(i)/absa
      cc(i)=cc(i)/absa
      ff(i)=ff(i)/absa
 13   continue
      nbf2=nbf-2
      nbf1=nbf-1
      ua=1000.
      ub=-1000.
      do 10 i=1,nbf2
      ip=i+1
      do 11 j=ip,nbf1
      jp=j+1
      if(1.0-abs(aa(i)*aa(j)+bb(i)*bb(j)+cc(i)*cc(j)).lt.eps) go to 11
      do 12 k=jp,nbf
      if(1.0-abs(aa(i)*aa(k)+bb(i)*bb(k)+cc(i)*cc(k)).lt.eps) go to 12
      if(1.0-abs(aa(j)*aa(k)+bb(j)*bb(k)+cc(j)*cc(k)).lt.eps) go to 12
      a(1,1)=aa(i)
      a(1,2)=bb(i)
      a(1,3)=cc(i)
      a(2,1)=aa(j)
      a(2,2)=bb(j)
      a(2,3)=cc(j)
      a(3,1)=aa(k)
      a(3,2)=bb(k)
      a(3,3)=cc(k)
      b(1)=ff(i)
      b(2)=ff(j)
      b(3)=ff(k)
      call matinv(a,3,3,b,1,det,ipivot,index,pivot)
      do 14 l=1,nbf
      if(wt(b(1),b(2),b(3),aa(l),bb(l),cc(l),ff(l)).gt.eps) go to 12
 14   continue
      if(b(1).lt.ua) ua=b(1)
      if(b(1).gt.ub) ub=b(1)
 12   continue
 11   continue
 10   continue
      du=ub-ua
      do 503 np=1,mp
      rx=hj(np,1)*du
      do 504 nq=1,mq
      do 504 nr=1,mr
 504  x(np,nq,nr)=ua+(pxj(np,1)+0.5)*du
      va=1000.
      vb=-1000.
      do 20 i=1,nbf1
      jp=i+1
      if(1.0-abs(aa(i)).lt.eps) go to 20
      do 21 j=jp,nbf
      if(1.0-abs(aa(j)).lt.eps) go to 21
      if(1.0-abs(aa(i)*aa(j)+bb(i)*bb(j)+cc(i)*cc(j)).lt.eps) go to 21
      a(1,1)=bb(i)
      a(1,2)=cc(i)
      a(2,1)=bb(j)
      a(2,2)=cc(j)
      b(1)=ff(i)-aa(i)*x(np,1,1)
      b(2)=ff(j)-aa(j)*x(np,1,1)
      call matinv(a,3,2,b,1,det,ipivot,index,pivot)
      do 22 l=1,nbf
      if(wt(x(np,1,1),b(1),b(2),aa(l),bb(l),cc(l),ff(l)).gt.eps)
     *         go to 21
 22   continue
      if(b(1).lt.va) va=b(1)
      if(b(1).gt.vb) vb=b(1)
 21   continue
 20   continue
      dv=vb-va
      do 505 nq=1,mq
      ry=hj(nq,2)*dv
      do 506 nr=1,mr
 506  y(np,nq,nr)=va+(pxj(nq,2)+0.5)*dv
      wa=1000.
      wb=-1000.
      do 30 i=1,nbf
      if(abs(cc(i)).lt.eps) go to 30
      b(1)=(ff(i)-aa(i)*x(np,1,1)-bb(i)*y(np,nq,1))/cc(i)
      do 31 l=1,nbf
      if(wt(x(np,1,1),y(np,nq,1),b(1),aa(l),bb(l),cc(l),ff(l)).gt.eps)
     *         go to 30
 31   continue
      if(b(1).lt.wa) wa=b(1)
      if(b(1).gt.wb) wb=b(1)
 30   continue
      dw=wb-wa
      do 507 nr=1,mr
      rz=hj(nr,3)*dw
      z(np,nq,nr)=wa+(pxj(nr,3)+0.5)*dw
      wxyz(np,nq,nr)=rx*ry*rz
 507  continue
 505  continue
 503  continue
      return
      end

      subroutine sitesy(na,mpl,x,isk,irs,isub) 
      real mpl(*),x(6,*)
      integer isk(0:48,*),irs(0:48,*),isub(*)
      integer rr
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /cdim/ idm,nde,ied
      real rx(6)
      real rxs(6,48)
      integer rcomp
      do 50 jk=1,na
      is=isub(jk)
      nsym=0
      nrx=1
      isk(nrx,jk)=1
      call savex(x(1,jk),rxs(1,nrx))
      do 130 ic=0,icent
      do 100 ns=1,nsymo
           call getrx(x(1,jk),rx,rr(1,1,1,is),tt(1,1,is),ns,ic)
c           if(ic.eq.1) then
c                do 202 k=1,idm
c                rx(k)=-rx(k)
c 202            continue
c           end if
           do 110 irx=1,nrx
           if(rcomp(rx,rxs(1,irx),is).eq.1) go to 120
 110       continue
           nrx=nrx+1
           call savex(rx,rxs(1,nrx))
           if(ic.eq.0) then
               isk(nrx,jk)=ns
           else
               isk(nrx,jk)=ns+nsymo
           end if
 120       continue
           if(rcomp(rx,x(1,jk),is).eq.1) then
               nsym=nsym+1
               if(ic.eq.0) then
                    irs(nsym,jk)=ns
               else
                    irs(nsym,jk)=ns+nsymo
               end if
           end if
 100  continue
 130       continue
      isk(0,jk)=nrx
      irs(0,jk)=nsym
      mpl(jk)=1
      if(icent.eq.1) then
c         compress symmetry element > nsymo
          n=0
          do 200 j=1,isk(0,jk)
              if(isk(j,jk).gt.nsymo) go to 201
              n=n+1
 200      continue
 201      continue
c         n: number of equivalent positions generated by given operators
c         isk(0,jk): number of equivalent positions generated by given
c                   symmetry operators and inversion
          mpl(jk)=float(isk(0,jk))/(float(n)*2)
          isk(0,jk)=n
      end if
 50   continue
      write(6,*) 'site symmetry group'
      do 55 jk=1,na
      write(6,*) 'atom',jk,'  ',(irs(j,jk),j=1,irs(0,jk))
 55   continue
      write(6,*) 'multiplicity  equivalent position'
      do 56 jk=1,na
      write(6,*) 'atom',jk,mpl(jk),(isk(j,jk),j=1,isk(0,jk))
 56   continue
      return
      end

      subroutine savex(rx,rxs)
      real rx(*),rxs(*)
      common /cdim/ idm,nde,ied
      do 100 i=1,idm
      rxs(i)=rx(i)
 100  continue
      return
      end

      integer function rcomp(x,rx,is)
      real x(*),rx(*)
      common /cdim/ idm,nde,ied
      common /cctr/ ctr(6,0:48),nctr
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      real tt(6)
      data eps/0.00001/
      rcomp=0
      do 110 j=0,nctr
           call getzx(zmtrx(1,is),ctr(1,j),tt)
           do 100 i=1,3
           xx=abs(x(i)-rx(i)-tt(i))+eps/2
           xx=mod(xx,1.)
           if(xx.gt.eps) go to 110
 100       continue
      rcomp=1
      return
 110  continue
      return
      end

      subroutine getrx(x,rx,r,t,ns,ic)
      real x(*),rx(*),t(6,*)
      integer r(6,6,*)
      common /cdim/ idm,nde,ied
      do 100 i=1,idm
           rx(i)=0
           do 101 j=1,idm
                rx(i)=rx(i)+r(i,j,ns)*x(j)
 101       continue
           rx(i)=rx(i)+t(i,ns)
           if(ic.eq.1) then
               rx(i)=-rx(i)
           end if
 100  continue
      return
      end

      subroutine gethr(h,hr,r,ns)
      integer h(*),hr(*),r(6,6,*)
      common /cdim/ idm,nde,ied
      do 100 i=1,idm
           hr(i)=0
           do 101 j=1,idm
                hr(i)=hr(i)+h(j)*r(j,i,ns)
 101       continue
 100  continue
      return
      end

      subroutine getgij(zmtrx,nsub)
      integer zmtrx(6,*)
c       get metric tensor for each substructure and
c       get wave vector of modulation wave for each substructure
      common /ltccnt/ a,b,c,cosa,cosb,cosc,sina,sinb,sinc,
     *        as,bs,cs,cosas,cosbs,coscs,sinas,sinbs,sincs
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      common /mtrtno/ ax(3,3,3),ay(3,3,3)
      common /kwave/ y(3,3,3),vc(3)
      common /cdim/ idm,nde,ied
      real bb(3),piv(3)
      integer ipiv(3),indx(3,2)
      real bx(3,6)
      data bx/1,0,0,
     *        0,1,0,
     *        0,0,1,
     *        0,0,0,
     *        0,0,0,
     *        0,0,0/
      gabx(1,1)=a*sqrt(1.0-cosa**2-cosb**2-cosc**2+2.0*cosa*cosb*cosc)/
     *         sina
      gabx(1,2)=0.0
      gabx(1,3)=0.0
      gabx(2,1)=a*(cosc-cosa*cosb)/sina
      gabx(2,2)=b*sina
      gabx(2,3)=0.0
      gabx(3,1)=a*cosb
      gabx(3,2)=b*cosa
      gabx(3,3)=c
      vc0=gabx(1,1)*gabx(2,2)*gabx(3,3)
      do 100 i=1,3
      do 100 j=1,3
 100  gaby(i,j)=gabx(i,j)
      call matinv(gaby,3,3,bb,0,det,ipiv,indx,piv)
c      write(6,*) 'gabx=',gabx
c      write(6,*) 'gaby=',gaby
      call yyy(bx(1,1))
      call yyy(bx(1,2))
      call yyy(bx(1,3))
      do 200 n=1,nde
          do 210 j=1,3
          bx(j,n+3)=y(j,n,1)
 210      continue
          call yyy(bx(1,n+3))
 200  continue
c                 for k-th subsustem
c      ax(i,j,k) : i-th components of j-th unit vector in the direct space
c                   in orthogonal coordinate system
c      ay(i,j,k) : i-th components of j-th unit vector in the reciprocal space
c                   in orthogonal coordinate system
       Do 300 n=1,nsub
          do 310 id=1,3
          i=zmtrx(id,n)
          ax(id,1,n)=bx(1,i)
          ax(id,2,n)=bx(2,i)
          ax(id,3,n)=bx(3,i)
          ay(id,1,n)=bx(1,i)
          ay(id,2,n)=bx(2,i)
          ay(id,3,n)=bx(3,i)
 310      continue
          call matinv(ax(1,1,n),3,3,bb,0,det,ipiv,indx,piv)
c         vc(n)=1/det(ax)
c      vc : unit cell volume for n-th substructure
          vc(n)=1/det
          do 320 id=1,3
          do 320 jd=1,3
              i=zmtrx(id,n)
              j=zmtrx(jd,n)
              gabn(id,jd,n)=vinp(bx(1,i),bx(1,j),3)
              gab(id,jd,n)=gabn(id,jd,n)
 320      continue
          call matinv(gab(1,1,n),3,3,bb,0,det,ipiv,indx,piv)
c           write(6,*) 'ax=',((ax(i,j,n),i=1,3),j=1,3)
c           write(6,*) 'ay=',((ay(i,j,n),i=1,3),j=1,3)
c         ax: a,b,c for n-th substructure (orthogonal system)
          an=vabs(ax(1,1,n),3)
          bn=vabs(ax(1,2,n),3)
          cn=vabs(ax(1,3,n),3)
          cosan=vinp(ax(1,2,n),ax(1,3,n),3)/(bn*cn)
          cosbn=vinp(ax(1,3,n),ax(1,1,n),3)/(cn*an)
          coscn=vinp(ax(1,1,n),ax(1,2,n),3)/(an*bn)
          if(nsub.gt.1) then
              write(6,*) 'substructure',n
              write(6,400) an,bn,cn,cosan,cosbn,coscn
          end if
          do 330 kd=1,nde
              k=zmtrx(kd+3,n)
              y(1,kd,n)=vinp(ax(1,1,n),bx(1,k),3)
              y(2,kd,n)=vinp(ax(1,2,n),bx(1,k),3)
              y(3,kd,n)=vinp(ax(1,3,n),bx(1,k),3)
              if(nsub.gt.1) then
                  write(6,*) ' k=',y(1,kd,n),y(2,kd,n),y(3,kd,n)
              end if
 330      continue
 300  continue
      as=sqrt(gabn(1,1,1))
      bs=sqrt(gabn(2,2,1))
      cs=sqrt(gabn(3,3,1))
      cosas=gabn(2,3,1)/(bs*cs)
      cosbs=gabn(1,3,1)/(as*cs)
      coscs=gabn(1,2,1)/(as*bs)
      sinas=sqrt(1.0-cosas**2)
      sinbs=sqrt(1.0-cosbs**2)
      sincs=sqrt(1.0-coscs**2)
      return
 400  format(' a=',f9.4,1x,'b=',f9.4,1x,'c=',f9.4,1x,
     *    'cosa=',f9.5,1x,'cosb=',f9.5,1x,'cosc=',f9.5)
      end

      subroutine xxx(r)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      dimension rr(3),r(3)
      do 10 i=1,3
      rr(i)=0.0
      do 10 j=1,3
      rr(i)=rr(i)+gabx(i,j)*r(j)
 10   continue
      r(1)=rr(1)
      r(2)=rr(2)
      r(3)=rr(3)
      return
      end

      subroutine yyy(r)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      dimension rr(3),r(3)
      do 10 i=1,3
      rr(i)=0.0
      do 10 j=1,3
      rr(i)=rr(i)+r(j)*gaby(j,i)
 10   continue
      r(1)=rr(1)
      r(2)=rr(2)
      r(3)=rr(3)
      return
      end

      subroutine xxxs(r,isub)
c     common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      common /mtrtno/ gabx(3,3,3),gaby(3,3,3)
      dimension rr(3),r(3)
      do 10 i=1,3
      rr(i)=0.0
      do 10 j=1,3
      rr(i)=rr(i)+gabx(i,j,isub)*r(j)
 10   continue
      r(1)=rr(1)
      r(2)=rr(2)
      r(3)=rr(3)
      return
      end

      subroutine yyys(r,isub)
c     common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      common /mtrtno/ gabx(3,3,3),gaby(3,3,3)
      dimension rr(3),r(3)
      do 10 i=1,3
      rr(i)=0.0
      do 10 j=1,3
      rr(i)=rr(i)+r(j)*gaby(j,i,isub)
 10   continue
      r(1)=rr(1)
      r(2)=rr(2)
      r(3)=rr(3)
      return
      end

      subroutine gauss1
      implicit real*8 (a-h,o-z)
      common /bgn1/ ilm(3),icorc(3),pxj(100,3),hj(100,3)
      real pxj,hj
      dimension p(3)
c     calculation of interval and weight of gauss integral
      do 12 l=1,3
      n=ilm(l)
      if(icorc(l).eq.1) then
c     incommensurate case
           eps=1.0d-10
           do 10 k=1,ilm(l)
           xm=float(n+1-2*k)/float(2*n+1)
           x=dsin(xm*3.1415926536)
 30        p(1)=1.0
           p(2)=x
           do 20 i=2,n
           p(3)=x*p(2)+float(i-1)/float(i)*(x*p(2)-p(1))
           p(1)=p(2)
 20        p(2)=p(3)
           d=(1.0d0-x**2)*p(2)/(float(n)*(p(1)-x*p(2)))
           if(dabs(d).lt.eps) go to 40
           x=x-d
           go to 30
 40        w=2.0d0*(1.0d0-x**2)/(float(n)*p(1))**2
           pxj(k,l)=-x/2.0d0
           hj(k,l)=w/2.0d0
 10        continue
           go to 12
      else
c     commensurate case
           do 13 k=1,ilm(l)
           pxj(k,l)=float(k-1)/float(n)
 13        hj(k,l)=1.0/float(n)
      end if
 12   continue
      return
      end

      function vinp(x,y,n)
c*****inner product of n-dimensional vactors, x,y
      dimension x(*),y(*)
      vinp=0
      do 10 i=1,n
 10   vinp=vinp+x(i)*y(i)
      return
      end

      function vabs(x,n)
c*****length of an n-dimensional vactor x
      dimension x(*)
      vabs=0
      do 10 i=1,n
 10   vabs=vabs+x(i)*x(i)
      vabs=sqrt(vabs)
      return
      end

      subroutine getipnf(ip1,ip2,ip3)
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt,ipnf3
      ip1=ipnf1
      ip2=ipnf2
      ip3=ipnf3
      return
      end
