*********subroutine for xray and newtron powder diffraction*******
      subroutine drwpdf(nh,mm,delt,rwp,rwpt)
      real mm(*),delt(*)
      include 'premos.inc'
c     parameter (nhkl=9999,nxprm=250,nmax=12000,nb=500)
c     common /ctodrw1/ qmin,qmax,dq,ndata,iwg,mmax(3),wavl(2),job
      common /ctodrw1/ qmin,qmax,dq,istep,ndata,iwg,mmax(3),wavl(2),
     *   job,ibkgr
      real icmax
      common /ctorms2/ theta(nhkl),qe(3,nhkl),thbm,awl,fi,icmax
      common /ctodrw3/ hwhm(2),rhwhm,gamma,uvw(2),p1,p2,p3,p4,as,sgm
      real lenx,leny
      common /ctodrw4/ lenx,leny,hscl,vscl,delta,ldev,nrange
      common /ctodrw6/ cp(0:2),pp(0:10),pg
      common /ctodrw7/ iwl,ixax,ilp
      common /ctodrw8/ ipt(0:38),nlc
c      common /ctodrw9/ pb(0:6), dpb(6), zps
      common /ctodrw9/ pb(0:12), dpb(12), zps
      common /ctodrw0/ usrmn(20),usrmx(20)
      common /cpof/ pof(nb),dpodp(4,nb),extf(nb),dextf(nb),abf(nb),
     *              dabf(nb)
      common /csimul/ dfdx(nxprm,nhkl),nxx
      complex fc
      real qk
      integer hklm,mpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),mpl(nhkl),fc(nhkl)
      common /cyo/ yo(nmax+2),qint(nmax+2)
      real syobs(0:3),sydef(0:3),wgref(0:3)
      real x(nmax+2), y(nmax+2), dx, dfdxx(nxprm)
      real def(nmax+2), b(nmax+2)
      data pi/3.141592/
c      write(6,*) 'qmin,qmax,dq,ndata,iwg,mmax(1),wavl(1)',
c     *            qmin,qmax,dq,ndata,iwg,mmax(1),wavl(1)
c      write(6,*) 'hwhm(1),gamma,uvw(1),p1,p2,p3,p4,as,sgm',
c     *            hwhm(1),gamma,uvw(1),p1,p2,p3,p4,as,sgm
c      write(6,*) 'lenx,leny,hscl,vscl,delta,ldev,nrange',
c     *            lenx,leny,hscl,vscl,delta,ldev,nrange
c      write(6,*) 'cp(0),pp(0),pg',cp(0),pp(0),pg
c      write(6,*) 'iwl,ixax,ilp',iwl,ixax,ilp
c      write(6,*) 'ipt(0),nlc',ipt(0),nlc
c      write(6,*) 'pb(0),zps',pb(0),zps
c      write(6,*) 'usrmn(1),usrmx(1)',usrmn(1),usrmx(1)
      fact=pi/180
      call intpn()
c     serch maximum structure factor used in pwint
      absfcm=0
      do 47 n=1,nh
          absfc=abs(fc(n))
          if(absfc.gt.absfcm) absfcm=absfc
 47   continue
      dx=dq
      syobs(0)=0
      yomin=1.0e15
      do 49 n=1,ndata
           if(iwl.le.7) then
               xx=qmin+dx*(n-1)
           else if(iwl.eq.8.and.job.eq.1) then
               xx=qmin+dx*(n-1)
           else if(iwl.eq.8.and.(job.eq.0.or.job.eq.2)) then
               xx=qint(n)
           else if(iwl.eq.9.and.(job.eq.0.or.job.eq.2)) then
               xx=qint(n)
           else if(iwl.eq.9.and.job.eq.1) then
               xx=qmin+dx*(n-1)
           end if
           do 48 nr=1,nrange
           if(xx.ge.usrmn(nr).and.xx.le.usrmx(nr)) then
               if(yo(n).eq.0) go to 48
               wgref(0)=1/yo(n)
               syobs(0)=syobs(0)+wgref(0)*yo(n)**2
               if(yo(n).ne.0.0.and.yo(n).lt.yomin) yomin=yo(n)
               go to 49
           end if
 48        continue
 49   continue
 110  continue
      if(job.eq.0.and.pb(1).eq.0.0) then
          pb(1)=yomin/1000
      end if
c     write(6,*) 'yomin=',yomin,'pb(0),pb(1)',pb(0),pb(1)
      ymax=0.
      ycmax=0.
      sydef(0)=0
      syobs(1)=0
      sbg=0
      nbg=0
      dx=dq
      call setise(0,0)
      is=1
      ns=1
c     write(6,*) 'ndata',ndata
      do 150 nr=1,nrange
      do 100 n=ns,ndata
           if(iwl.le.7.and.ixax.eq.1) then
               xx=qmin+dx*(n-1)
               x(n)=xx
           else if(iwl.le.7.and.ixax.eq.0) then
               xx=qmin+dx*(n-1)
               if(abs(ilp).eq.1) then
                   awavl=wavl(1)*2/3+wavl(2)/3
               else
                   awavl=wavl(1)
               end if
               x(n)=sin(xx*fact/2)/awavl*4*pi
           else if(iwl.eq.8.and.job.eq.1) then
               xx=qmin+dx*(n-1)
               x(n)=xx
           else if(iwl.eq.8.and.ixax.eq.1) then
               xx=qint(n)
               x(n)=xx
           else if(iwl.eq.8.and.ixax.eq.0) then
               xx=qint(n)
               awavl=wavl(1)
               x(n)=sin(xx*fact/2)/awavl*4*pi
           else if(iwl.eq.9.and.(job.eq.0.or.job.eq.2)) then
               xx=qint(n)
               x(n)=xx
           else if(iwl.eq.9.and.job.eq.1) then
               xx=qmin+dx*(n-1)
               x(n)=xx
           end if
           if(xx.lt.usrmn(nr)) then
               go to 100
           else if(xx.gt.usrmx(nr)) then
               go to 150
           end if
c          write(6,*) 'enter pwint'
           if(job.eq.0.or.job.eq.1) then
               yc=pwint(nh,xx,dfdxx,is,bgd,absfcm)
           end if
           y(n)=yc
           b(n)=bgd
c           if(y(n).gt.1.0e7) write(6,*) 'n,y,bgd',n,y(n),b(n)
c             nxx: number of refined parameters
c             wgref: weight for individual observation
c             yo(n): observed intensity
c             y (n): calculated intensity
c             b (n): calculated background
           if(job.eq.0.or.job.eq.2) then
                yd=yo(n)
           else
                yd=y(n)
           end if
           if(yd-bgd.gt.ymax) then
                ymax=yd-bgd
c                write(6,*) 'ymax=',ymax
           end if
           if(yc-bgd.gt.ycmax) then
                ycmax=yc-bgd 
c                write(6,*) 'ycmax=',ycmax
           end if
c           if(job.ne.0.or.pb(0).eq.0) go to 100
c           if(yo(n).eq.0) go to 100
           if(job.eq.0.and.pb(0).ne.0.and.yo(n).ne.0) then
           wgref(0)=1/yo(n)
           dfoc=yo(n)-y(n)
           sydef(0)=sydef(0)+wgref(0)*dfoc**2
           syobs(1)=syobs(1)+wgref(0)*(yo(n)-bgd)**2
           wg=wgref(0)/syobs(0)
           lk=0
           do 60 j=1,nxx+nlc
c              dej=wgref(0)*dfdxx(j)/syobs(0)
c              delt(j)=delt(j)+dfoc*dej
              delt(j)=delt(j)+dfoc*wg*dfdxx(j)
              do 61 k=1,j
                 lk=lk+1
c                mm(lk)=mm(lk)+dej*dfdxx(k)
                 mm(lk)=mm(lk)+wg*dfdxx(j)*dfdxx(k)
 61           continue
 60        continue
           end if
 100  continue
 150  ns=n+1
      if(job.eq.0) then
          if(pb(0).eq.0) then
              pb(0)=ymax/ycmax*100
              go to 110
          end if
          rwp=sqrt(sydef(0)/syobs(0))
          rwpt=sqrt(sydef(0)/syobs(1))
      end if
      call pltyoc(x,yo,y,b,def,ymax,qk,hklm,nh)
      return
      end
