      function pwint(nh,xd,dfdxx,is,bgd,absfcm)
c        calculated intensity at xd and its derivatives
      real xd,dfdxx(*)
c     real dhdgij(3,3),dhdkij(3,3),dhdx(15)
      real dhdgij(3,3),dhdkij(3,3),rh(3),dhdx(15)
      include 'premos.inc'
c     parameter (nhkl=9999,nxprm=250,nb=500)
c      common /ctodrw1/ qmin,qmax,dq,ndata,iwg,mmax(3),wavl(2),job
      common /ctodrw1/ qmin,qmax,dq,istep,ndata,iwg,mmax(3),wavl(2),
     *   job,ibkgr
c      common /ctodrw3/ hwhm(2),gamma,uvw(2),p1,p2,p3,p4,as,sgm
      common /ctodrw3/ hwhm(2),rhwhm,gamma,uvw(2),p1,p2,p3,p4,as,sgm
      common /ctodrw6/ cp(0:2),pp(0:10),pg
      common /csimul/ dfdx(nxprm,nhkl),nxx
      common /cdim/ idm,nde
c     common /atomp2/ y(3,3)
      common /ctodrw8/ ipt(0:38),nlc
c      common /ctodrw9/ pb(0:6), dpb(6), zps
      common /ctodrw9/ pb(0:12), dpb(12), zps
      common /cpof/ pof(nb),dpodp(4,nb),extf(nb),dextf(nb),abf(nb),
     *              dabf(nb)
      common /ctodrw7/ iwl,ixax,ilp,alpha
      integer ns,st
      common /cqsort/ ns(nhkl),st(nhkl,2)
      real sqrtpi,ln2,fact
      common /clins/ sqrtpi,ln2,fact
      complex fc
      real qk,qkd,derc(0:2),derp(0:11)
      integer hd(3)
      integer hklm,mpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),mpl(nhkl),fc(nhkl)
      common /criccut/ riccut
c      character icn
c      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15),icn(5,15)
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15)
      common /cupdat/ tanxk(nb),tfct(nb),hwhme(2,nb),c1(nb),c2(nb),
     * coeff(nb),coeff0(nb),coeff1(nb),coeff2(nb),coeff3(nb),peak(nb)
      common /cprfl1/ dgdgmt,dgdtht,dgdast,dgdhei(2),asf,casf
      common /prfhrp/ r(nb),sigma1(nb),sigma2(nb),gamma1(nb),gamma2(nb),
     &  gs12(nb),exp12(nb),erf12(nb),gs22(nb),exp22(nb),erf22(nb),
     &  fnorm(nb),fnorm1(nb),fnorm2(nb)
      data pi/3.141592/
      npfx=21+6
      npfn=28+6
c     nsx: position of scale factor in dfdx
c
c      2-theta angle of grafite
      fact=pi/180
      ln2=log(2.)
      sqrtpi=sqrt(pi/ln2)
c     initialize
      do 11 j=1,nxx+nlc
      dfdxx(j)=0.
 11   continue
c     background intensity
      bgd=backgr(xd,pb(1),dpb)
      pwint=bgd
      if(ipt(0).eq.0) then
          j=nxx
      else if(ipt(0).eq.1) then
          j=nxx+1
      end if
c      do 13 l1=1,6
      do 13 l1=1,6+6
      if(ipt(l1).eq.1) then
          j=j+1
          dfdxx(j)=dfdxx(j)+dpb(l1)
      end if
 13   continue
      if(iwl.le.7) then
          if(abs(ilp).eq.1) then
              lwe=2
          else
              lwe=1
          end if
      else if(iwl.ge.8) then
          lwe=1
      end if
c**************
      isd=is
      do 100 ii=is,nh
      i=ns(ii)
      if(ii-is+1.ge.nb) then
           write(6,*) 'buffer full'
           go to 140
      end if
      absfc=abs(fc(i))
      call setrh(hklm(1,i),rh)
      call dhdg(dhdgij,hklm(1,i),qk(i),rh)
      call dhdk(dhdkij,hklm(1,i),qk(i),rh)
      do k=1,nlp
          dhdx(k)=fdhdx(dhdgij,dhdkij,k)
      end do
c     isat=isatel(hklm(1,i))
      call isatel(hklm(1,i),hd)
      if(hd(1).eq.0.and.hd(2).eq.0.and.hd(3).eq.0) then
          isat=0
      else
c          isat=1
         isat=hd(1)+hd(2)+hd(3)
      end if
      if(iwl.le.8) then
          call updat1(ii,i,np,isat,mpl(i),qk(i)*pi*2,absfc,job)
      else if(iwl.eq.9) then
c         xk: diffraction vector 2*pi*q in inverse angstrome
          qkd=qk(i)*2*pi
          xk=cp(0)+cp(1)*qkd+cp(2)*qkd**2
          call updat2(ii,i,np,isat,cp,pp,pg,xk,qkd,idpos,mpl(i),absfc,
     *                                                            job)
      end if
      do 110 lw=1,lwe
           absfc=abs(fc(i))
           if(iwl.le.8) then
               xx=qk(i)*wavl(lw)/2
c              xx: sin(theta)
               if(xx.gt.0.999) go to 100
c              xk: 2-theta in degree
               xk0=2*asin(xx)/fact        ! 2-theta in degree
               xk=xk0+zps                 ! 2-theta in degree
           end if
           if(xk.lt.qmin.or.xk.gt.qmax) go to 100
           if(lwe.eq.1) then
               wght=1.
           else
               if(lw.eq.1) then
                   wght=2./3.
               else
                   wght=1./3.
               end if
           end if
           dx0=xd-xk                       ! delta 2-theta in degree
c           gt: profile function
            if(iwl.le.8) then
                gt=prfl1(np,dx0,xk0*fact)  ! xk0*fact : 2-theta in radian
c               gt=prfl10(np,dx0,xk*fact)
c                if(pb(0).eq.0) then
                    pt=peak(np)/1000
c                else
c                    pt=icmax/(2000*pb(0))
c                end if
            else
                gt=prfl2(np,dx0)
c                if(pb(0).eq.0) then
                    pt=fnorm(np)/1000
c                else
c                    pt=icmax/(2000*pb(0))
c                end if
            end if
            iskip=0
            if(dx0.ge.0.and.gt.lt.pt) then
                iskip=1
            else if(dx0.le.0.and.gt.lt.pt) then
                iskip=2
            end if
            if(iwl.le.8) then
c               hwhm(1) nearly equal to hwhm(2) is assumed
                if(dx0.gt. 10*hwhme(2,np)) iskip=1
                if(dx0.lt.-10*hwhme(2,np)) iskip=2
            else 
                if(dx0.gt. 10*sigma1(np)) iskip=1
                gammam=max(gamma1(np),gamma2(np))
                if(dx0.lt.-20*gammam) iskip=2
            end if
            if(iskip.eq.1) then
c               starting reflection for the next x
                if(lw.eq.1) isd=ii+1
            else if(iskip.eq.2) then
c               break
                go to 140
            else
                if(job.eq.1.or.(job.eq.0.and.pb(0).eq.0)) then
                   pwint=pwint+coeff0(np)*gt*wght*extf(np)
                else
                   pwint=pwint+coeff0(np)*gt*wght*extf(np)
                   if(iwl.le.8) then
                        if(nlc.ne.0) then
                            call dprfl1(np,derc,derp,isat,qk(i))
c                           call dprfl10(np,derc,derp,isat,qk(i))
                        end if
                        l1m=13+6
                        l2m=npfx-1
                        l1e=l2m+nlp
                   else
                        if(nlc.ne.0) then
                            call dprfl2(pp,qkd,nh,np,dx0,derc,derp,dfdq,
     *                                                             isat)
                        end if
                        l1m=18+6
                        l2m=npfn-1
                        l1e=l2m+nlp
                   end if
                   do 151 j=1,nxx
c                      structural parameters
                       dfdxx(j)=dfdxx(j)+dfdx(j,i)*coeff1(np)*gt*wght
     *                                         *extf(np)
 151               continue
                   if(nlc.ne.0) then
                         j=nxx
c                        l=0
                         do 20 l1=0,l1e
c                        if(ipt(l1).eq.0) go to 20
                         if(ipt(l1).ne.0) then
                         j=j+1
                         if(l1.eq.0) then
c            scale
                             dfdxx(j)=dfdxx(j)+coeff(np)*gt*wght
     *                                     *extf(np)*absfc**2/100
                         else if(l1.ge.7+6.and.l1.le.l1m) then
c            asym-rhwhm or sigm-
                         dfdxx(j)=dfdxx(j)+derp(l1-7-6)*coeff0(np)
     *                                      *extf(np)*wght
                         else if(l1.eq.l1m+1) then
c            sgm or absorption
                             dfdxx(j)=dfdxx(j)+coeff3(np)*gt*wght
     *                                      *dabf(np)
                         else if(l1.eq.l1m+2) then
c            pg or extinction
                             dfdxx(j)=dfdxx(j)+coeff0(np)*gt*wght
     *                                      *dextf(np)
                         else if(l1.ge.l1m+3.and.l1.le.l1m+6) then
c            pi
                             k=l1-l1m-2
                             dfdxx(j)=dfdxx(j)+dpodp(k,np)*coeff2(np)
     *                                   *gt*extf(np)*wght
                         else if(l1.ge.l1m+7.and.l1.le.l2m) then 
c            zps or ci
                             k=l1-l1m-7
                             dfdxx(j)=dfdxx(j)+derc(k)*coeff0(np)
     *                                      *extf(np)*wght
                         else if(l1.gt.l2m) then
c            lattice parameters
                             if(iwl.le.8) then
                                 dthdh=wavl(lw)/(2*cos(xk*fact/2))/fact
                                 dgdh=dgdtht*dthdh
                             else if(iwl.eq.9) then
                                 dgdh=dfdq*2*pi
                             end if
c                             call dhdg(dhdgij,hklm(1,i),qk(i),rh)
c                             call dhdk(dhdkij,hklm(1,i),qk(i),rh)
                             k=l1-l2m
c                            l=l+1
c                             dhdx=fdhdx(dhdgij,dhdkij,k)
c                             dfdxx(j)=dfdxx(j)+dgdh*dhdx*
                             dfdxx(j)=dfdxx(j)+dgdh*dhdx(k)*
     *                                 coeff0(np)*extf(np)*wght
                         end if
                         end if
 20                      continue
                   end if
                end if
           end if
 110  continue
 100  continue
 140  continue
      is=isd
      return
      end

c***************subroutine by f. izumi**********************
c
      subroutine updat2(n,nd,np,isat,c,p,pg,xk,q,idpos,mpl,absfc,job)
**    update various variables that are related to profile parameters,
**    which are stored in common blocks der2, prfhrp, and trange.
**    this subroutine has to be called before calculating profile
**    shape functions from new parameters and their derivatives
**    with respect to refinable parameters.
**    the value of nb (number of bragg reflections) must be altered by
**    the user of this subroutine.
      real c(0:*),p(0:*),xk,d
c      common /ctodrw9/ pb(0:6), dpb(6), zps
      common /ctodrw9/ pb(0:12), dpb(12), zps
**            c: parameters to calculate peak positions, xk(i)
**               xk(i) = c(0) + c(1)*q(i) + c(2)*q(i)**2
**            p: profile parameters
**                p(0)=s1 ; p(1)=s2             Oct. 8 1990
**                p(2)=u1,  p(3)=v1             Oct. 8 1990
**                p(4)=u1,  p(5)=v1             Oct. 8 1990
**                sigma1=s1*sqrt(1+u*q+v*q**2)  Oct. 8 1990
**                sigma2=s2*sqrt(1+u*q+v*q**2)  Oct. 8 1990
* *               gamma1=p(6)                   Oct. 8 1990
**                gamma2=p(7)*q+p(8)*q**2       Oct. 8 1990
**                R=exp(-p(9)*q**p(10))
**                

c     cc=sqrt(pi/2); root2=sqrt(2)
      include 'premos.inc'
c     parameter (nhkl=9999,nb=500)
      real lp
      common /clpfct/ lp(nb)
      common /cupdat/ tanxk(nb),tfct(nb),hwhme(2,nb),c1(nb),c2(nb),
     * coeff(nb),coeff0(nb),coeff1(nb),coeff2(nb),coeff3(nb),peak(nb)
      parameter (cc=1.253314,root2=1.414214)
      parameter (pw0=0.0,pw1=1.0,pw2=0.0,pw3=1.0,pw5=2.0,pw6=-0.5)
      common /der2/dxdq(nb),ds1dp0(nb),ds2dp1(nb),ds1dp2(nb),ds1dp3(nb),
     &  ds2dp4(nb),ds2dp5(nb),
c     &  dg1dp6(nb),dg2dp7(nb),drdp8(nb),drdp9(nb),
     &  dg1dp6(nb),dg2dp7(nb),dg2dp8(nb),drdp9(nb),drdp10(nb),
     &  dads1(nb),dads2(nb),dadg1(nb),dadg2(nb),dadr(nb),dadq(nb),
     &  da1ds1(nb),da1ds2(nb),da1dg1(nb),da1dg2(nb),da1dr(nb),da1dq(nb),
     &  da2ds1(nb),da2ds2(nb),da2dg1(nb),da2dg2(nb),da2dr(nb),da2dq(nb),
     &  sigm13(nb),sigm23(nb),dp10(nb),ds1dq(nb),ds2dq(nb),
     &  dg1dq(nb),dg2dq(nb),drdq(nb)
      common /prfhrp/ r(nb),sigma1(nb),sigma2(nb),gamma1(nb),gamma2(nb),
     &  gs12(nb),exp12(nb),erf12(nb),gs22(nb),exp22(nb),erf22(nb),
     &  fnorm(nb),fnorm1(nb),fnorm2(nb)
      common /cpof/ pof(nb),dpodp(4,nb),extf(nb),dextf(nb),abf(nb),
     *              dabf(nb)
      common /cisie/ is,ie
      real icmax
      common /ctorms2/ theta(nhkl),qe(3,nhkl),thbm,awl,fi,icmax
      common /ctodrw3/ hwhm(2),rhwhm,gamma,uvw(2),p1,p2,p3,p4,as,sgm
      real dpof(4)
      data pi/3.141592/
c       this routine assumes that is=ie=0 initially
c       to set these initial value ==> call setise(0,0)
      if(n.ge.is.and.n.le.ie) then
c         1<=np<=nb   position in a ring buffer
c         use calculated value
          np=mod(n-1,nb)+1
          return
      else
c         save new value at np
          np=mod(n-1,nb)+1
          if(n.le.nb) then
              is=1
              ie=n
          else if(n.gt.nb) then
              ie=ie+1
              is=is+1
          end if
          idpos=0
          i=np
c         sigma1    = p(0) * sqrt(1+p(2)*q+p(3)*q**2)   high-Q  Oct. 8 '90
c         sigma2    = p(1) * sqrt(1+p(4)*q+p(5)*q**2)   low-Q   Oct. 8 '90
          if(isat.eq.0) then
              ds1dp0(i) = sqrt(1+p(2)*q+p(3)*q**2)
              ds2dp1(i) = sqrt(1+p(4)*q+p(5)*q**2)
          else
c              ds1dp0(i) = sqrt(1+p(2)*q+p(3)*q**2)*rhwhm
c              ds2dp1(i) = sqrt(1+p(4)*q+p(5)*q**2)*rhwhm
              ds1dp0(i) = sqrt(1+p(2)*q+p(3)*q**2)*(1+rhwhm*isat)
              ds2dp1(i) = sqrt(1+p(4)*q+p(5)*q**2)*(1+rhwhm*isat)
          end if
          ds1dp2(i) = p(0)*q/(2*ds1dp0(i))
          ds1dp3(i) = p(0)*q**2/(2*ds1dp0(i))
          ds2dp4(i) = p(1)*q/(2*ds2dp1(i))
          ds2dp5(i) = p(1)*q**2/(2*ds2dp1(i))
          sigma1(i) = p(0) * ds1dp0(i)
          sigma2(i) = p(1) * ds2dp1(i)
c         gamma1(i) = p(4) * q**p(5)  ==> p(6)         logn tail Oct. 8 '90
c         gamma2(i) = p(6) * q**p(7)  ==> p(7) * q**2  short tail Oct. 8 '90
          dg1dp6(i) = 1
          dg2dp7(i) = q**2
          dg2dp8(i) = q
          gamma1(i) = p(6)
          gamma2(i) = p(7)*q**2+p(8)*q
          dp10(i)=q**p(10)
          r(i) = exp(-p(9) * dp10(i))
          extf(i) = extfct(pg,absfc,q,mpl,dextfc)
          dextf(i) = dextfc
          if(sigma1(i) .lt. 0 .or. sigma2(i) .lt. 0) then
              call quit('parameter sigma1 or sigma2 negative ???')
          else if (gamma1(i) .lt. 0.0 .or. gamma2(i) .lt. 0.0) then
              call quit('parameter gamma1 or gamma2 negative ???')
          else if(r(i) .lt. 0 .or. r(i) .gt. 1 ) then
              call quit('parameter r<0 or r>1  ???')
          end if
c         r is approximated by avrami's equation
          gs12(i)=sigma2(i)**2/gamma1(i)
          exp12(i)=exp((sigma2(i)/gamma1(i))**2/2)
          erf12(i)=erf(sigma2(i)/(gamma1(i)*root2))
          gs22(i)=sigma2(i)**2/gamma2(i)
          exp22(i)=exp((sigma2(i)/gamma2(i))**2/2)
          erf22(i)=erf(sigma2(i)/(gamma2(i)*root2))
c         fnorm: normalization factor
          fnorm(i)=cc*(sigma1(i)+(1.0-r(i))*sigma2(i)*erf12(i)+
     &    r(i)*sigma2(i)*erf22(i))+(1.0-r(i))*gamma1(i)/exp12(i)
     &    +r(i)*gamma2(i)/exp22(i)
          fnorm(i)=1.0/fnorm(i)
          fnorm1(i)=fnorm(i)*exp12(i)
          fnorm2(i)=fnorm(i)*exp22(i)
c         arrays used to calculate partial derivatives with respect to
c         (1) c(0), c(1), c(2), (2) profile parameters, and (3) q(i)
c                       in subroutine dprfl
          dxdq(i)=c(1)+2.0*c(2)*q
          sigm13(i)=sigma1(i)**3
          sigm23(i)=sigma2(i)**3
c         lp(i)=1/q**2
          lp(i)=flp(q)
          pof(i)=poffct(qe(1,nd),p1,p2,p3,p4,dpof)
          abf(i)=absorp(yk0,sgm,dabf(i))
c         write(6,*) 'n,pof,extf',n,pof(i),extf(i)
          dpodp(1,i)=dpof(1)
          dpodp(2,i)=dpof(2)
          dpodp(3,i)=dpof(3)
          dpodp(4,i)=dpof(4)
          if(job.eq.0) then
              if(pb(0).eq.0) then
                  coeff(i)=lp(i)*mpl*pof(i)
                  coeff0(i)=coeff(i)*absfc**2
                  return
              end if
          else
              coeff(i)=lp(i)*mpl*pof(i)
              coeff0(i)=coeff(i)*absfc**2
              return
          end if
          scl=pb(0)/100
          coeff(i)=lp(i)*mpl*pof(i)
c         coefficient for profile parameters
          coeff0(i)=coeff(i)*absfc**2*scl
c         coefficient for structural parameters
          coeff1(i)=coeff(i)*2*absfc*scl
c         coefficient for prefered orientation function
          coeff2(i)=lp(i)*mpl*absfc**2*scl
c         coefficient for absorption correction parameter
          coeff3(i)=lp(i)*mpl*pof(i)*absfc**2*scl
c          write(6,*) 'coeff,coeff0,coeff1,coeff2',coeff(i),coeff0(i),
c     *                coeff1(i),coeff2(i),coeff3(i)
c         drdp9=-q**p(10)*r
c         drdp10=-p(9)*q**p(10)*r*log(q)
          drdp9(i)=-r(i)*dp10(i)
          drdp10(i)=drdp9(i)*p(9)*log(q)
          dads1(i)=-cc*fnorm(i)**2
          dads2(i)=dads1(i)*((1.0-r(i))*erf12(i)+r(i)*erf22(i))
c         dadg1(i)=fnorm(i)**2*(1.0-r(i))/(gamma1(i)**2*exp12(i))
c         dadg2(i)=fnorm(i)**2*r(i)/(gamma2(i)**2*exp22(i))
c         dadr(i)=cc*sigma2(i)*(erf22(i)-erf12(i))+1.0/(gamma2(i)*
c    &              exp22(i))-1.0/(gamma1(i)*exp12(i))
          dadg1(i)=-fnorm(i)**2*(1.0-r(i))/exp12(i)
          dadg2(i)=-fnorm(i)**2*r(i)/exp22(i)
          dadr(i)=cc*sigma2(i)*(erf22(i)-erf12(i))
     &        +gamma2(i)/exp22(i)-gamma1(i)/exp12(i)
          dadr(i)=-fnorm(i)**2*dadr(i)
          da1ds1(i)=dads1(i)*exp12(i)
c         da1ds2(i)=(dads2(i)+fnorm(i)*gamma1(i)**2*sigma2(i))*exp12(i)
          da1ds2(i)=(dads2(i)+fnorm(i)*sigma2(i)/gamma1(i)**2)*exp12(i)
c           da1dg1 ==> a part of df1dg1
c           da1dg2 ==> a part of df1dg2
c         da1dg1(i)=(dadg1(i)+fnorm(i)*gs12(i))*exp12(i)
c         da1dg2(i)=dadg2(i)*exp12(i)
          da1dg1(i)=(dadg1(i)-2*fnorm(i)*gs12(i)/gamma1(i)**2)*exp12(i)
          da1dg2(i)=dadg2(i)*exp12(i)
          da1dr(i)=dadr(i)*exp12(i)
          da2ds1(i)=dads1(i)*exp22(i)
c         da2ds2(i)=(dads2(i)+fnorm(i)*gamma2(i)**2*sigma2(i))*exp22(i)
          da2ds2(i)=(dads2(i)+fnorm(i)*sigma2(i)/gamma2(i)**2)*exp22(i)
c         da2dg1(i)=dadg1(i)*exp22(i)
c         da2dg2(i)=(dadg2(i)+fnorm(i)*gs22(i))*exp22(i)
          da2dg1(i)=dadg1(i)*exp22(i)
          da2dg2(i)=(dadg2(i)-2*fnorm(i)*gs22(i)/gamma2(i)**2)*exp22(i)
          da2dr(i)=dadr(i)*exp22(i)
c          ds1dq(i)=p(2)*ds1dp2(i)/q+p(3)*2*ds1dp2(i)
c          ds2dq(i)=p(2)*ds2dp2(i)/q+p(3)*2*ds2dp2(i)
          ds1dq(i)=p(2)*ds1dp2(i)/q+p(3)*2*ds1dp2(i)
          ds2dq(i)=p(4)*ds2dp4(i)/q+p(5)*2*ds2dp4(i)
c          dg1dq(i)=p(4)*p(5)*q**(p(5)-1)
c          dg2dq(i)=p(6)*p(7)*q**(p(7)-1)
          dg1dq(i)=0
          dg2dq(i)=2*p(7)*q
          drdq(i)=-p(9)*p(10)*dp10(i)/q*r(i)
c          dadd(i)=cc*ds1dd(i)+
c     &    cc*erf12(i)*((1.0-r(i))*ds2dd(i)-sigma2(i)*drdd(i))
c     &    -(drdd(i)+(1.0-r(i))/gamma1(i)*dg1dd(i))/(gamma1(i)*exp12(i))+
c     &    cc*erf22(i)*(r(i)*ds2dd(i)+sigma2(i)*drdd(i))
c     &     +drdd(i)/(gamma2(i)*exp22(i))
          dadq(i)=cc*ds1dq(i)+
     &    cc*erf12(i)*((1.0-r(i))*ds2dq(i)-sigma2(i)*drdq(i))
     &    +(-drdq(i)*gamma1(i)+(1.0-r(i))*dg1dq(i))/exp12(i)+
     &    cc*erf22(i)*(      r(i)*ds2dq(i)+sigma2(i)*drdq(i))
     &    +( drdq(i)*gamma2(i)     +r(i) *dg2dq(i))/exp22(i)
          dadq(i)=-fnorm(i)**2*dadq(i)

c          da1dd(i)=(dadd(i)+fnorm(i)*(gs12(i)*dg1dd(i)
c     &            +gamma1(i)**2*sigma2(i)*ds2dd(i)))*exp12(i)
c          da2dd=(dadd(i)+fnorm(i)*gamma2(i)**2*sigma2(i)*
c     &         ds2dd(i))*exp22(i)
c          cdf2dd(i)=da2dd+fnorm2(i)*gamma2(i)*c2vd(i)
          da1dq(i)=(dadq(i)+fnorm(i)*(gs12(i)*dg1dq(i)
     &            +sigma2(i)*ds2dq(i)/gamma1(i)**2))*exp12(i)
          da2dq(i)=(dadq(i)+fnorm(i)*(gs22(i)*dg2dq(i)
     &            +sigma2(i)*ds2dq(i)/gamma2(i)**2))*exp22(i)
c          cdf2dq(i)=da2dq(i)+fnorm2(i)*gamma2(i)*dxdq(i)
         idpos=1
         return
       end if
       end

************************************************************************
c           gt=prfl2(np,dx0)
      function prfl2(i,dx0)
**    profile shape function at dx0 (=xk(i)-t) for the i'th reflection
**    the value of nb (number of bragg reflections) must be altered by
**    the user of this subroutine.
**    variables gauss1, gauss2, tail1, tail2, f1, and f2 are used in
**    subroutine dprfl2; therefore, prfl2 must be calculated prior to
**    calling dprfl2.

      integer i
      real dx0
c     dx0 ==> xx-xk
**    input
**            i: reflection number
**        dx0: xk(i) - t, where xk(i) is the peak position and
**               t is the time of flight at this step
**    output
**        prfl2: this function
**
      include 'premos.inc'
c     parameter (nb=500)
      common /prfhrp/ r(nb),sigma1(nb),sigma2(nb),gamma1(nb),gamma2(nb),
     &  gs12(nb),exp12(nb),erf12(nb),gs22(nb),exp22(nb),erf22(nb),
     &  fnorm(nb),fnorm1(nb),fnorm2(nb)
      common /prf2/ gauss1,gauss2,tail1,tail2,f1,f2
      if (dx0 .ge. 0.0) then
c        high-Q region
         gauss1=exp(-0.5*(dx0/sigma1(i))**2)
         prfl2=fnorm(i)*gauss1
      else
c        low-Q region
         if (-dx0 .le. gs12(i) .or. -dx0 .lt. gs22(i)) then
            gauss2=exp(-0.5*(dx0/sigma2(i))**2)
         end if
         if (-dx0 .le. gs12(i)) then
            f1=fnorm(i)*gauss2
         else
            tail1=exp(dx0/gamma1(i))
            f1=fnorm1(i)*tail1
         end if
         if (-dx0 .le. gs22(i)) then
            f2=fnorm(i)*gauss2
         else
            tail2=exp(dx0/gamma2(i))
            f2=fnorm2(i)*tail2
         end if
         prfl2=(1.0-r(i))*f1+r(i)*f2
      end if
      return
      end

************************************************************************
      subroutine dprfl2(p,q,nrefl,i,dx0,derc,derp,dfdq,isat)
**    calculate the contribution of the i'th reflection to the partial
**    derivatives of the profile shape function at dx0 with respect to
**       (1) c(0), c(1), and c(2)
**           xk(i) = c(0) + c(1)*q(i) + c(2)*q(i)*q(i)
**       (2) profile parameters, p(0) - p(10) and rs1
**       (3) q(i)
**    the value of nb (number of bragg reflections) must be altered by
**    the user of this subroutine.
      real p(0:*),q,dx0,derc(0:*),derp(0:*),dfdq
      integer nrefl,i

**    input
**            p: profile parameters
**               p(0)=s1; p(1)=s2;
**               p(2)=u1; p(3)=v1; p(4)=u2, p(5)=v2;
**               p(6)=g1; p(7)=g2; p(8)=g3;
**               p(9)=r1; p(10)=r2
**               p(11)=rs1            
**            q: diffraction vector
**        nrefl: number of reflections
**            i: reflection number
**        dx0: xk(i) - t, where xk(i) is the peak position and
**               t is the time of flight at this step
**    output
**         derc: derivatives of prfik with respect to (c(j),j=0,2)
**         derp: derivatives of prfik with respect to (p(j),j=0,10)
**               and rs1=rhwhm
**         dfdq: derivative of prfik with respect to q
**               where prfik is the value of the profile shape function
**               for the i'th reflection at t
**
      include 'premos.inc'
c     parameter (nb=500)
      common /der2/dxdq(nb),ds1dp0(nb),ds2dp1(nb),ds1dp2(nb),ds1dp3(nb),
c     &  ds2dp2(nb),ds2dp3(nb),
c     &  dg1dp4(nb),dg1dp5(nb),dg2dp6(nb),dg2dp7(nb),drdp8(nb),drdp9(nb),
     &  ds2dp4(nb),ds2dp5(nb),
     &  dg1dp6(nb),dg2dp7(nb),dg2dp8(nb),drdp9(nb),drdp10(nb),
     &  dads1(nb),dads2(nb),dadg1(nb),dadg2(nb),dadr(nb),dadq(nb),
     &  da1ds1(nb),da1ds2(nb),da1dg1(nb),da1dg2(nb),da1dr(nb),da1dq(nb),
     &  da2ds1(nb),da2ds2(nb),da2dg1(nb),da2dg2(nb),da2dr(nb),da2dq(nb),
c     &  sigm13(nb),sigm23(nb),dp9(nb),ds1dq(nb),ds2dq(nb),
     &  sigm13(nb),sigm23(nb),dp10(nb),ds1dq(nb),ds2dq(nb),
     &  dg1dq(nb),dg2dq(nb),drdq(nb)
      common /prfhrp/ r(nb),sigma1(nb),sigma2(nb),gamma1(nb),gamma2(nb),
     &  gs12(nb),exp12(nb),erf12(nb),gs22(nb),exp22(nb),erf22(nb),
     &  fnorm(nb),fnorm1(nb),fnorm2(nb)
      common /ctodrw3/ hwhm(2),rhwhm,gamma,uvw(2),p1,p2,p3,p4,as,sgm
      common /prf2/ gauss1,gauss2,tail1,tail2,f1,f2
c
c     if (dx0 .le. 0) then
      if (dx0 .ge. 0) then
*        (1)
         dfdxk=fnorm(i)*dx0/sigma1(i)**2*gauss1
*        (2)
         dfds1=(dads1(i)+fnorm(i)*dx0**2/sigm13(i))*gauss1
         dfds2=dads2(i)*gauss1
         dfdg1=dadg1(i)*gauss1
         dfdg2=dadg2(i)*gauss1
         dfdr=dadr(i)*gauss1
*        (3)
c        dfdd=(dadd(i)+fnorm(i)*(dx0**2/sigm13(i)*p(1)+
c    &           dx0/sigma1(i)**2*c2vd(i)))*gauss1
         dfdq=(dadq(i)+fnorm(i)*(dx0**2/sigm13(i)*ds1dq(i)+
     &           dx0/sigma1(i)**2*dxdq(i)))*gauss1
      else
c        if (dx0 .le. gs12(i)) then
         if (-dx0 .le. gs12(i)) then
*           f1: fnorm(i)*gauss2
*           (1)
            df1dxk=f1*dx0/sigma2(i)**2
*           (2)
            df1ds1=dads1(i)*gauss2
            df1ds2=(dads2(i)+fnorm(i)*dx0**2/sigm23(i))*gauss2
            df1dg1=dadg1(i)*gauss2
            df1dg2=dadg2(i)*gauss2
            df1dr=dadr(i)*gauss2
*           (3)
            df1dq=(dadq(i)+fnorm(i)*(dx0**2/sigm23(i)*ds2dq(i)+
     &            dx0/sigma2(i)**2*dxdq(i)))*gauss2
         else
*           f1: fnorm1(i)*tail1
*           (1)
c           df1dxk=f1*gamma1(i)
            df1dxk=f1/gamma1(i)
*           (2)
            df1ds1=da1ds1(i)*tail1
            df1ds2=da1ds2(i)*tail1
c           df1dg1=(da1dg1(i)-fnorm1(i)*dx0)*tail1
c           df1dg2=da1dg2(i)*tail1
            df1dg1=(da1dg1(i)-fnorm1(i)*dx0/gamma1(i)**2)*tail1
            df1dg2=da1dg2(i)*tail1
            df1dr=da1dr(i)*tail1
*           (3)
c           df1dd=(da1dd(i)+fnorm1(i)*(gamma1(i)*c2vd(i)-dg1dd(i)*
c    &            dx0))*tail1
            df1dq=(da1dq(i)+fnorm1(i)*(dxdq(i)/gamma1(i)-dg1dq(i)*
     &            dx0))*tail1
         end if
c        if (dx0 .le. gs22(i)) then
         if (-dx0 .le. gs22(i)) then
*           (1)
*           f2: fnorm(i)*gauss2
            df2dxk=f2*dx0/sigma2(i)**2
*           (2)
            df2ds1=dads1(i)*gauss2
            df2ds2=(dads2(i)+fnorm(i)*dx0**2/sigm23(i))*gauss2
            df2dg1=dadg1(i)*gauss2
            df2dg2=dadg2(i)*gauss2
            df2dr=dadr(i)*gauss2
*           (3)
            df2dq=(dadq(i)+fnorm(i)*(dx0**2/sigm23(i)*ds2dq(i)+
     &            dx0/sigma2(i)**2*dxdq(i)))*gauss2
         else
*           f2: fnorm2(i)*tail2
*           (1)
c           df2dxk=f2*gamma2(i)
            df2dxk=f2/gamma2(i)
*           (2)
            df2ds1=da2ds1(i)*tail2
            df2ds2=da2ds2(i)*tail2
c           df2dg1=da2dg1(i)*tail2
c           df2dg2=(da2dg2(i)-fnorm2(i)*dx0)*tail2
            df2dg1=da2dg1(i)*tail2
            df2dg2=(da2dg2(i)-fnorm2(i)*dx0/gamma2(i)**2)*tail2
            df2dr=da2dr(i)*tail2
*           (3)
            df2dq=(da2dq(i)+fnorm2(i)*(dxdq(i)/gamma2(i)-dg2dq(i)*
     &            dx0))*tail2
         end if
*        (1)
         dfdxk = (1.0-r(i))*df1dxk + r(i)*df2dxk
*        (2)
         dfds1 = (1.0-r(i))*df1ds1 + r(i)*df2ds1
         dfds2 = (1.0-r(i))*df1ds2 + r(i)*df2ds2
         dfdg1 = (1.0-r(i))*df1dg1 + r(i)*df2dg1
         dfdg2 = (1.0-r(i))*df1dg2 + r(i)*df2dg2
         dfdr = f2 - f1 + (1.0-r(i))*df1dr + r(i)*df2dr
*        (3)
         dfdq = drdq(i)*(f2 - f1) + (1.0-r(i))*df1dq + r(i)*df2dq
      end if

*     (1)
      derc(0)=dfdxk
      derc(1)=dfdxk*q
      derc(2)=dfdxk*q**2
*     (2)
      derp(0)=dfds1*ds1dp0(i)
      derp(1)=dfds2*ds2dp1(i)
      derp(2)=dfds1*ds1dp2(i)
      derp(3)=dfds1*ds1dp3(i)
      derp(4)=dfds2*ds2dp4(i)
      derp(5)=dfds2*ds2dp5(i)
      derp(6)=dfdg1*dg1dp6(i)
      derp(7)=dfdg2*dg2dp7(i)
      derp(8)=dfdg2*dg2dp8(i)
      derp(9)=dfdr*drdp9(i)
      derp(10)=dfdr*drdp10(i)
      if(isat.eq.0) then
          derp(11)=0
      else
          if(dx0.ge.0) then
c              derp(11)=derp(0)*p(0)/rhwhm
              derp(11)=derp(0)*p(0)*isat/(1+rhwhm*isat)
          else
c              derp(11)=derp(1)*p(1)/rhwhm
              derp(11)=derp(1)*p(1)*isat/(1+rhwhm*isat)
          end if
      end if
*     (3)
*     derivative with respect to d(i) ==> derivative with respect to q
c      dfdq=dfdq
c      write(6,*) 'derc,derp',(derc(k),k=0,2),(derp(k),k=0,11),dfdq
      return
      end

      function extfct(pg,absfc,q,mpl,dextfc)
      real pg,absfc,q,dextfc
      integer mpl
c     extfct=1-pg*absfc**2*mpl/q**4
      dextfc=-absfc**2*mpl/q**4
      extfct=1+pg*dextfc
      if(extfct.le.0) call quit('extinction factor negative?')
      return
      end

      subroutine empty(np)
      return
      end
