
      subroutine sctabl
      common /csct/ sct(721)
      pai2=6.28318
      do 10 i=1,721
      x=pai2*float(i-1)/720.0
      sct(i)=sin(x)
 10   continue
      return
      end

      subroutine sexpt
      common /cexpt/ expt(500)
      do 10 i=1,200
      x=-float(i-1)/400.0
      ii=i
 10   expt(ii)=exp(x)
      do 20 i=1,200
      x=-float(i-1)/200.0-0.5
      ii=i+200
 20   expt(ii)=exp(x)
      do 30 i=1,100
      x=-float(i-1)/100.0-1.5
      ii=i+400
 30   expt(ii)=exp(x)
      return
      end

      subroutine gauss2
      implicit real*8 (a-h,o-z)
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      real*4 y,vc
      common /kwave/ y(3,3,3),vc(3)
      common /cdim/ idm,nde
      real*4  pxj,hj
      dimension p(3)
c     calculation of interval and weight of gauss integral
      icom=0
      do 20 l=1,3
      if(icorc(l).eq.1) then
           me=ilm(l)
      else
           me=ilc(1)*ilc(2)*ilc(3)
      end if
      do 20 m=1,me
      pxj(m,l)=0.0
 20   hj(m,l)=1.0
c
      write(6,*) 'coefficients for gauss integral'
      do 12 l=1,nde
      if(icorc(l).eq.1) then
c          incommansurate case
           n=ilm(l)
           eps=1.0d-10
           do 10 k=1,ilm(l)
           xm=float(n+1-2*k)/float(2*n+1)
           x=dsin(xm*3.1415926536d0)
 30        p(1)=1.0
           p(2)=x
           do 21 i=2,n
           p(3)=x*p(2)+float(i-1)/float(i)*(x*p(2)-p(1))
           p(1)=p(2)
 21        p(2)=p(3)
           d=(1.0d0-x**2)*p(2)/(float(n)*(p(1)-x*p(2)))
           if(dabs(d).lt.eps) go to 40
           x=x-d
           go to 30
 40        w=2.0d0*(1.0d0-x**2)/(float(n)*p(1))**2
           pxj(k,l)=-x/2.0d0
           hj(k,l)=w/2.0d0
 10        continue
           write(6,'(8f10.6)') (pxj(k,l),k=1,ilm(l))
           write(6,'(8f10.6)') (hj(k,l),k=1,ilm(l))
      else
c          commensurate case
           k=0
           icom=icom+1
           do 13 k3=1,ilc(3)
           do 13 k2=1,ilc(2)
           do 13 k1=1,ilc(1)
           k=k+1
           pxj(k,l)=y(1,l,1)*(k1-1)+y(2,l,1)*(k2-1)+y(3,l,1)*(k3-1)
c          pxj(k,l)=y(l,1)*(k1-1)+y(l,2)*(k2-1)+y(l,3)*(k3-1)
           pxj(k,l)=mod(pxj(k,l),1.)
           if(pxj(k,l).lt.0) pxj(k,l)=pxj(k,l)+1
           if(icom.eq.1) then
                  hj(k,l)=1.0/(ilc(1)*ilc(2)*ilc(3))
           else
                  hj(k,l)=1.0
           end if
 13        continue
      end if
 12   continue
      return
      end

      subroutine begin(csb,nw,nt,na,nl,x,isub,ifrt1,ifrt2,coeff,
     *                ns,icnt,trd)
      dimension csb(nw,na,*),x(6,*),isub(*),ifrt2(nw,3,*),coeff(nw,*)
      character*4 ifrt1(nw,2,*)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /cdim/ idm,nde
      common /kwave/ y(3,3,3),vc(3)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      integer rr
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      dimension arg(6),agd(6),rs(6,6,3),bb(6),ipv(6),ind(6,2),piv(6)
      dimension trd(6),nm(6)
      character sgn1,sgn2,chr1,chr2
      character*2 cs1,cs2
      data sgn1/'+'/,sgn2/'-'/,cs1/'cC'/,cs2/'sS'/
c*******************************************************************
c      calculation of fourier terms for each independent atom
c*******************************************************************
      do 21 j=1,nw
      do 21 jk=1,na
      do 21 m=1,nl
 21   csb(j,jk,m)=0.0
      do 241 nd=1,nsub
         do 24 i=1,idm
         do 24 j=1,idm
 24      rs(i,j,nd)=rr(i,j,ns,nd)
         call matinv(rs(1,1,nd),6,idm,bb,0,det,ipv,ind,piv)
 241  continue
c
      do 10 i=1,nw
      do 12 j=1,nt
      chr1=ifrt1(i,1,j)(1:1)
      if(chr1.eq.sgn1) then
            sgn=1
      else if(chr1.eq.sgn2) then
            sgn=-1
      else
            go to 13
      end if
      if(coeff(i,j).eq.0.0) coeff(i,j)=1.0
      do 11 jk=1,na
           js=isub(jk)
           do 22 k=1,6
 22        arg(k)=0.0
           do 20 nd=1,idm
           arg(nd)=x(nd,jk)
           if(nd.ge.4) then
                ni=nd-3
                arg(nd)=arg(nd)+
     *          y(1,ni,js)*x(1,jk)+y(2,ni,js)*x(2,jk)+y(3,ni,js)*x(3,jk)
           end if
 20        continue
           m=0
c     incommensuratr loop
           do 51 m3=1,ilm(3)
           do 51 m2=1,ilm(2)
           do 51 m1=1,ilm(1)
c     commensurate loop
           do 51 n1=1,ilc(1)*ilc(2)*ilc(3)
           nm(1)=m1
           nm(2)=m2
           nm(3)=m3
           m=m+1
           if(icorc(1).eq.0) nm(1)=n1
           if(icorc(2).eq.0) nm(2)=n1
           if(icorc(3).eq.0) nm(3)=n1
           do 23 nd=1,nde
           agd(nd)=0
                do 231 k=1,3
 231            agd(nd)=agd(nd)+
     *          rs(nd+3,k,js)*(arg(k)-tt(k,ns,js)-trd(k))
                do 232 k=4,idm
 232            agd(nd)=agd(nd)+rs(nd+3,k,js)*
     *          (arg(k)+pxj(nm(k-3),k-3)-tt(k,ns,js)-trd(k))
           if(icnt.eq.1) agd(nd)=-agd(nd)
 23        continue
           a=0
           do 233 nd=1,nde
 233       a=a+agd(nd)*ifrt2(i,nd,j)
           chr2=ifrt1(i,2,j)(1:1)
           if(index(cs1,chr2).gt.0) then
                cs=cos(a*pai2)*sgn
           else if(index(cs2,chr2).gt.0) then
                cs=sin(a*pai2)*sgn
           else
                cs=0.0
           end if
 51        csb(i,jk,m)=csb(i,jk,m)+cs*coeff(i,j)
 11   continue
 12   continue
 13   je=j-1
 10   continue
      return
      end

      subroutine matinv(a,nm,n,b,m,determ,ipivot,index,pivot)
c
c    n*n matrix a is replaced by its inverse matrix a**-1
c    if m is nonzero vector b is replaced by a**-1*b
c
      dimension a(nm,nm),b(nm),ipivot(nm),index(nm,2),pivot(nm)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do 20 j=1,n
  20  ipivot(j)=0
      do 555 i=1,n
      amax=0.0
      do 105 j=1,n
      if(ipivot(j).eq.1) go to 105
      do 100 k=1,n
      if(ipivot(k)-1) 80,100,740
  80  if(abs(amax).ge.abs(a(j,k))) go to 100
      irow=j
      icolum=k
      amax=a(j,k)
 100  continue
 105  continue
      ipivot(icolum)=ipivot(icolum)+1
      if(irow.eq.icolum) go to 260
      determ=-determ
      do 200 l=1,n
      swap=a(irow,l)
      a(irow,l)=a(icolum,l)
 200  a(icolum,l)=swap
      if(m.eq.0) go to 260
      swap=b(irow)
      b(irow)=b(icolum)
      b(icolum)=swap
 260  index(i,1)=irow
      index(i,2)=icolum
      pivot(i)=a(icolum,icolum)
      determ=determ*pivot(i)
      a(icolum,icolum)=1.0
      do 350 l=1,n
 350  a(icolum,l)=a(icolum,l)/pivot(i)
      if(m.eq.0) go to 380
      b(icolum)=b(icolum)/pivot(i)
 380  do 550 l1=1,n
      if(l1.eq.icolum) go to 550
      t=a(l1,icolum)
      a(l1,icolum)=0.0
      do 450 l=1,n
 450  a(l1,l)=a(l1,l)-a(icolum,l)*t
      if(m.eq.0) go to 550
      b(l1)=b(l1)-b(icolum)*t
 550  continue
 555  continue
      do 710 i=1,n
      l=n+1-i
      if(index(l,1).eq.index(l,2)) go to 710
      jrow=index(l,1)
      jcolum=index(l,2)
      do 700  k=1,n
      swap=a(k,jrow)
      a(k,jrow)=a(k,jcolum)
 700  a(k,jcolum)=swap
 710  continue
 740  continue
      return
      end

      subroutine chlsk(m,b,x,n,mi,isng,dmp,sqrtm)
c     solve the normal equation mx=b  where m is n*n real positive
c                  matrix
c     choleskis decomposition of matrix m to l*lt where l is lower
c     triangular matrix and lt is its transpose matrix
c     m is replaced by l
c     if mi=0,1   x is calculated
c     if mi=1,2   m is replaced by its inversion
      real m(1),b(1),x(1),sqrtm(1)
c     normalization
      ii=0
      ij=0
      do 10 i=1,n
      ii=ii+i
      sqrtm(i)=sqrt(m(ii))
      if(mi.ne.2) x(i)=b(i)/sqrtm(i)
      do 10 j=1,i
      ij=ij+1
      m(ij)=m(ij)/(sqrtm(i)*sqrtm(j))
 10   if(i.eq.j) m(ij)=m(ij)+dmp
c     choleskis decomposition
      isng=0
      i0=0
      do 11 i=1,n
      i0=i0+i-1
      j0=i0-i+1
      do 11 j=i,n
      j0=j0+j-1
      am=0.0
      do 12 k=1,i
      jk=j0+k
      ik=i0+k
      if(k.ne.i) am=am-m(jk)*m(ik)
 12   if(k.eq.i) am=am+m(jk)
      if(j.eq.i.and.am.le.0.0) then
           isng=1
           write(6,*) 'matrix is singular or nonpositive'
           return
      end if
      if(j.eq.i) m(jk)=sqrt(am)
 11   if(j.ne.i) m(jk)=am/m(ik)

c     solution of normal equation
      if(mi.eq.2) go to 25
      ij=0
      do 20 i=1,n
      am=x(i)
      do 20 j=1,i
      ij=ij+1
      if(j.ne.i) am=am-m(ij)*x(j)
 20   if(j.eq.i) x(i)=am/m(ij)
      nn=n*(n+1)/2
      do 22 j=1,n
      i=n+1-j
      ki=nn+i
      am=x(i)
      do 22 kd=i,n
      k=n+i-kd
      ki=ki-k
      if(k.ne.i) am=am-m(ki)*x(k)
 22   if(k.eq.i) x(i)=am/m(ki)
      do 24 i=1,n
 24   x(i)=x(i)/sqrtm(i)
      if(mi.eq.0) return
c     matrix inversion of matrix l
 25   i0=0
      do 30 i=1,n
      i0=i0+i-1
      j0=i0-i+1
      do 31 j=i,n
      am=0.0
      if(j.eq.i) am=1.0
      j0=j0+j-1
      ki=i0+1
      do 31 k=i,j
      jk=j0+k
      ki=ki+k-1
      if(k.ne.j) am=am-m(jk)*m(ki)
 31   if(k.eq.j) m(ki)=am/m(jk)
 30   continue
c     matrix inversion of matrix m
      ij=0
      i0=0
      do 40 i=1,n
      i0=i0+i-1
      do 40 j=1,i
      am=0.0
      k0=i0-i+1
      do 41 k=i,n
      k0=k0+k-1
      ki=k0+i
      kj=k0+j
 41   am=am+m(ki)*m(kj)
      ij=ij+1
 40   m(ij)=am/(sqrtm(i)*sqrtm(j))
      return
      end

      subroutine txr(x)
      dimension x(*)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      data eps/1.0e-30/
      do 10 kr=1,i6,2
      ks=kr+1
      a=x(kr)
      b=x(ks)
      x(kr)=sqrt(a**2+b**2)
      if(abs(a).lt.eps.or.abs(b).lt.eps) go to 20
      x(ks)=atan2(-b,a)
      go to 10
 20   continue
      if(abs(a).lt.eps.and.abs(b).gt.eps) x(ks)=sign(pai2/4.0,-b)
      if(abs(b).lt.eps.and.a.gt.eps) x(ks)=0.0
      if(abs(b).lt.eps.and.-a.gt.eps) x(ks)=pai2/2.0
      if(abs(a).lt.eps.and.abs(b).lt.eps) x(ks)=0.0
 10   continue
      return
      end

      subroutine trx(x)
      dimension x(*)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      do 10 kr=1,i6,2
      ks=kr+1
      a=x(kr)
      b=x(ks)
      x(kr)=a*cos(b)
      x(ks)=-a*sin(b)
 10   continue
      return
      end

      subroutine prmtbl(x,df,isub,ips,na,nw,nx,nzc,ja,ea,xx,bx,px,
     *                it,nl,iw)
      dimension x(*),df(*),isub(*),ips(*),ja(4,*),ea(*),xx(6,*),
     *          bx(it,*),px(*)
      common /cdim/ idm,nde
      character*6 atom
      common /cltc/ atom(100)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /cctwn/ dt(6,48)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      dimension comp1(3),comp2(0:12),comp3(1),comp4(7),comp5(3),
     *          comp6(0:12),zx(20)
      integer wx(20),wy(20),ifrt(20)
      integer dspmdl,tmpmdl,sctmdl
      common /ceat/ eat(6,3),ebt(6,3)
      character*4 comp1,comp2,comp3,comp4,comp5,comp6,aa,wc(20)
      data comp1 /'u','v','w'/,
     *     comp2 /'Beq','B1','B2','B3','B4','B5','B6',
     *            'B1''','B2''','B3''','B4''','B5''','B6'''/,
     *     comp3 /'p'/,
     *     comp4 /'B','B1''','B2''','B3''','B4''','B5''','B6'''/,
     *     comp5 /'x','y','z'/,
     *     comp6 /'Beq','U1','U2','U3','U4','U5','U6',
     *            'B1''','B2''','B3''','B4''','B5''','B6'''/
c****************************************************************
c    write atomic parameter table
c    iw=1: parameter table, iw=2: standard dev. table
c    iw=3: atomic parameters for a superstructure
c****************************************************************
      pi8=8*(3.141592)**2

      if(nde.eq.2) then
          aa=comp2(9)
          comp2(9)=comp2(12)
          comp2(12)=aa
          aa=comp4(4)
          comp4(4)=comp4(7)
          comp4(7)=aa
          aa=comp6(9)
          comp6(9)=comp6(12)
          comp6(12)=aa
      end if
      ncl=6
      kde=(nw-1)/ncl+1
      if(iw.eq.1.or.iw.eq.2) then
          do 12 kd=1,kde
              if(kd.eq.kde) ne=mod(nw-1,ncl)+1
              if(kd.ne.kde) ne=ncl
              do 13 k=1,ne
              ifrt(k)=k+ncl*(kd-1)
 13           continue
              if(kd.eq.1) write(6,202) (ifrt(k),k=1,ne)
              if(kd.ne.1) write(6,204) (ifrt(k),k=1,ne)
 12       continue
      end if
      write(6,201)
      do 10 i=1,na
      jk=isub(i)
      do 22 iy=1,3
      if(dspmdl.eq.0.and.iy.eq.1) go to 22
      if(tmpmdl.eq.0.and.iy.eq.2) go to 22
      if(sctmdl.eq.0.and.iy.eq.3) go to 22
      if(iy.eq.1) then   ! x,y,z
          is=i1
          ie=i2
          js=1
          je=3
          fact=100000
      else if(iy.eq.2) then  ! B or Bi, Ui
          is=i3
          ie=i4
          if(itempf.eq.0) then   ! isotropic
              js=1
              je=1
              fact=1000
           else                  ! anisotropic
              js=0
              je=it
              fact=100000
          end if
      else if(iy.eq.3) then  ! p
          is=i5
          ie=i6
          js=1
          je=1
          fact=1000
      end if
      do 11 j=js,je
      if(iw.eq.1.or.iw.eq.2) then
          do 111 kd=1,kde
          if(kd.ne.kde) ne=ncl
          if(kd.eq.kde) ne=mod(nw-1,ncl)+1
          do 210 k=1,ne
          if(j.ne.0) then    ! x,y,z, Bi/Ui ,p
              wx(k)=0.0
              wy(k)=0.0
              write(wc(k),'(a)') '----'
              zx(k)=0.0
              in=0
              if(is.ne.1) then
                  do 31 l=2,is
 31               in=in+ja(4,l-1)
              end if
              do 220 ix=is,ie
              nz=ja(4,ix)
              do 21 n=1,nz
              in=in+1
              if(ja(1,in).eq.i.and.ja(2,in).eq.j.and.
     *                  ja(3,in).eq.k+(kd-1)*ncl) then
                  ad=x(ix)*ea(in)
                  bd=df(ix)*ea(in)
                  if(iw.eq.1) then
c                    parameters and their differences
                       wx(k)=wx(k)+ad*fact
                       wy(k)=wy(k)+bd*fact
                       if(ips(ix).eq.1) then
 20                       write(wc(k),'(i4)') wy(k)
                       end if
                  else if(iw.eq.2) then
c                    parameters and their std.
                       wx(k)=wx(k)+ad*fact
                       zx(k)=zx(k)+bd**2
                       wy(k)=sqrt(zx(k))*fact
                       if(ips(ix).eq.1) then
                           write(wc(k),'(i4)') wy(k)
                       end if
                  end if
              end if
 21           continue
 220          continue
          else if(j.eq.0) then  ! Beq
              wx(k)=0.0
              wy(k)=0.0
              write(wc(k),'(a)') '----'
              zx(k)=0.0
              in=0
              if(is.ne.1) then
                  do 32 l=2,is
 32               in=in+ja(4,l-1)
              end if
              do 230 ix=is,ie
              nz=ja(4,ix)
c             calculation of Beq
              do 23 n=1,nz
              in=in+1
              if(itempf.eq.1.or.itempf.eq.-1) then   ! Beq
                  if(ja(1,in).eq.i.and.ja(2,in).le.6.and.
     *                  ja(3,in).eq.k+(kd-1)*ncl) then
                     if(iw.eq.1) then
c                    parameters and their differences
c                        wx(k)=wx(k)+ad*fact
c                        wy(k)=wy(k)+bd*fact
                        wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact/100
                        wy(k)=wy(k)+df(ix)*ebt(ja(2,in),jk)*fact/100
                        if(ips(ix).eq.1) then
                            write(wc(k),'(i4)') wy(k)
                        end if
                     else if(iw.eq.2) then
c                     parameters and their std.
c                        wx(k)=wx(k)+ad*fact
c                        zx(k)=zx(k)+bd**2
                        wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact/100
                        zx(k)=wy(k)+(df(ix)*ebt(ja(2,in),jk))**2
                        wy(k)=sqrt(zx(k))*fact/100
                        if(ips(ix).eq.1) then
                            write(wc(k),'(i4)') wy(k)
                        end if
                     end if
                  end if
              else if(itempf.eq.2.or.itempf.eq.-2) then  ! Beq
                  if(ja(1,in).eq.i.and.ja(2,in).le.6.and.
     *                  ja(3,in).eq.k+(kd-1)*ncl) then
                     if(iw.eq.1) then
c                    parameters and their differences
c                        wx(k)=wx(k)+ad*fact
c                        wy(k)=wy(k)+bd*fact
                        wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact/100
                        wy(k)=wy(k)+df(ix)*ebt(ja(2,in),jk)*fact/100
                        if(ips(ix).eq.1) then
                            write(wc(k),'(i4)') wy(k)
                        end if
                     else if(iw.eq.2) then
c                     parameters and their std.
c                        wx(k)=wx(k)+ad*fact
c                        zx(k)=zx(k)+bd**2
c                        wy(k)=sqrt(zx(k))*fact
                        wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact/100
                        zx(k)=wy(k)+(df(ix)*ebt(ja(2,in),jk)*fact)**2/
     *                       100
                        wy(k)=sqrt(zx(k))*fact
                        if(ips(ix).eq.1) then
                            write(wc(k),'(i4)') wy(k)
                        end if
                     end if
                  end if
              end if
 23           continue
 230          continue
          end if
 210      continue
          if(dspmdl.eq.1.and.iy.eq.1) then
              if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
              if(kd.eq.1) write(6,200) atom(i),comp1(j),
     *                     (wx(k),wc(k),k=1,ne)
          else if(tmpmdl.eq.1.and.iy.eq.2) then
              if(itempf.eq.1.or.itempf.eq.-1) then
                  if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                  if(kd.eq.1) write(6,200) atom(i),
     *                      comp2(j),(wx(k),wc(k),k=1,ne)
              else if(itempf.eq.2.or.itempf.eq.-2) then
                  if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                  if(kd.eq.1) write(6,200) atom(i),
     *                      comp6(j),(wx(k),wc(k),k=1,ne)
              else if(itempf.eq.0) then
                  if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                  if(kd.eq.1) write(6,200) atom(i),
     *                      comp4(j),(wx(k),wc(k),k=1,ne)
              end if
          else if(sctmdl.ne.0.and.iy.eq.3) then
              if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
              if(kd.eq.1) write(6,200) atom(i),
     *                      comp3(j),(wx(k),wc(k),k=1,ne)
          end if
 111      continue
      end if
 11   continue
 22   continue
      write(6,201)
 10   continue
      if(itwin.ne.0) then
           ntwin=abs(itwin)
           do 801 i=1,ntwin
           volr(i)=0.
           do 802 j=1,6
           dt(j,i)=0.
 802       continue
 801       continue
        if(i8.gt.i6) then
c          twin volume
           do 80 i=i7,i8
                nz=ja(4,i)
           do 80 n=1,nz
                in=in+1
                itw=ja(1,in)
                volr(itw)=volr(itw)+x(i)*ea(in)
 80        continue
           write(6,'('' twin domain volume ratio: '',8f12.6)')
     *       (volr(itw),itw=1,ntwin)
        write(6,201)
        end if
c       if(i10.gt.i8) then
c          phase shift
c           do 81 i=i9,i10
c           nz=ja(4,i)
c           do 81 n=1,nz
c           in=in+1
c           itw=ja(1,in)
c           j=ja(2,in)
c           dt(j,itw)=dt(j,itw)+x(i)*ea(in)
c 81        continue
c           write(6,'('' additional shift for twinoperators:'',6f12.6)')
c     *       ((dt(j,itw),j=1,6),itw=1,ntwin)
c           write(6,201)
c       end if
      end if
      write(6,'('' scale factors: '',6f12.6)') (x(i),i=i11,i12)
c      if(isext.ne.0) then
c         write(6,'('' extinction parameters: '',2f12.6)')
c     *        (x(i),i=i13,i14)
c      end if
      write(6,201)
 40   continue
      if(nde.eq.2) then
          aa=comp2(9)
          comp2(9)=comp2(12)
          comp2(12)=aa
          aa=comp4(4)
          comp4(4)=comp4(7)
          comp4(7)=aa
          aa=comp6(9)
          comp6(9)=comp6(12)
          comp6(12)=aa
      end if
      return
 200  format(1h ,a,1x,a4,6(i6,'(',a,')'))
 203  format(1h ,11x,    6(i6,'(',a,')'))
 201  format(1h )
 202  format(1h ,'fourier trm',6(i6,6x))
 204  format(1h ,'           ',6(i6,6x))
      end

      subroutine prmtbl0(x,df,ips,na,nw,nx,nzc,ja,ea,xx,bx,px,it,nl,iw)
      dimension x(*),df(*),ips(*),ja(4,*),ea(*),xx(6,*),bx(it,*),px(*)
      common /cdim/ idm,nde
      character*6 atom
      common /cltc/ atom(100)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /cctwn/ dt(6,48)
      character*4 aa,wc(20)
      character*4 comp1(3),comp2(12),comp3(1),comp4(7),comp5(3)
      dimension zx(20)
      integer wx(20),wy(20),ifrt(20)
      integer dspmdl,tmpmdl,sctmdl
      data comp1/'u','v','w'/,comp2/'b1','b2','b3','b4','b5','b6'
     *       ,'b1''','b2''','b3''','b4''','b5''','b6'''/,comp3/'p'/
     *       ,comp4/'b','b1''','b2''','b3''','b4''','b5''','b6'''/
     *       ,comp5/'x','y','z'/
c****************************************************************
c    write atomic parameter table
c    iw=1: parameter table, iw=2: standard dev. table
c    iw=3: atomic parameters for a superstructure
c****************************************************************
      if(nde.eq.2) then
          aa=comp2(9)
          comp2(9)=comp2(12)
          comp2(12)=aa
          aa=comp4(4)
          comp4(4)=comp4(7)
          comp4(7)=aa
      end if
      ncl=6
      kde=(nw-1)/ncl+1
      if(iw.eq.1.or.iw.eq.2) then
          do 12 kd=1,kde
              if(kd.eq.kde) ne=mod(nw-1,ncl)+1
              if(kd.ne.kde) ne=ncl
              do 13 k=1,ne
              ifrt(k)=k+ncl*(kd-1)
 13           continue
              if(kd.eq.1) write(6,202) (ifrt(k),k=1,ne)
              if(kd.ne.1) write(6,204) (ifrt(k),k=1,ne)
 12       continue
      end if
      write(6,201)
      do 10 i=1,na
      do 22 iy=1,3
      if(dspmdl.eq.0.and.iy.eq.1) go to 22
      if(tmpmdl.eq.0.and.iy.eq.2) go to 22
      if(sctmdl.eq.0.and.iy.eq.3) go to 22
      if(iy.eq.1) je=3
      if(iy.eq.2) je=it
      if(iy.eq.3) je=1
      do 11 j=1,je
      if(iw.eq.1.or.iw.eq.2) then
          do 111 kd=1,kde
          if(kd.ne.kde) ne=ncl
          if(kd.eq.kde) ne=mod(nw-1,ncl)+1
          do 20 k=1,ne
          wx(k)=0.0
          wy(k)=0.0
          write(wc(k),'(a)') '----'
          zx(k)=0.0
          if(iy.eq.1) then
              is=i1
              ie=i2
          else if(iy.eq.2) then
              is=i3
              ie=i4
          else if(iy.eq.3) then
              is=i5
              ie=i6
          end if
          in=0
          if(is.ne.1) then
              do 21 l=2,is
 21           in=in+ja(4,l-1)
          end if
          if(iy.eq.1) then
                fact=100000
          else if(iy.eq.2) then
c               if(itempf.eq.0.and.j.eq.1) then
                if(itempf.eq.0) then
                    fact=1000
                else
                    fact=100000
                end if
          else if(iy.eq.3) then
                fact=1000
          end if
          do 20 ix=is,ie
          nz=ja(4,ix)
          do 20 n=1,nz
              in=in+1
              if(ja(1,in).eq.i.and.ja(2,in).eq.j.and.
     *                         ja(3,in).eq.k+(kd-1)*ncl) then
                  ad=x(ix)*ea(in)*fact
                  bd=df(ix)*ea(in)*fact
                  if(iw.eq.1) then
c                    parameters and their differences
                       wx(k)=wx(k)+sign(abs(ad)+0.5,ad)
                       wy(k)=wy(k)+sign(abs(bd)+0.5,bd)
                       if(ips(ix).eq.1) then
                           write(wc(k),'(i4)') wy(k)
                       end if
                  end if
                  if(iw.eq.2) then
c                    parameters and their std.
                       wx(k)=wx(k)+sign(abs(ad)+0.5,ad)
                       zx(k)=zx(k)+bd**2
                       wy(k)=sqrt(zx(k))
                       if(ips(ix).eq.1) then
                           write(wc(k),'(i4)') wy(k)
                       end if
                  end if
              end if
 20       continue
          if(dspmdl.eq.1.and.iy.eq.1) then
              if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
              if(kd.eq.1) write(6,200) atom(i),comp1(j),
     *                     (wx(k),wc(k),k=1,ne)
          else if(tmpmdl.eq.1.and.iy.eq.2) then
              if(itempf.ne.0) then
                  if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                  if(kd.eq.1) write(6,200) atom(i),
     *                      comp2(j),(wx(k),wc(k),k=1,ne)
              else 
                  if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                  if(kd.eq.1) write(6,200) atom(i),
     *                      comp4(j),(wx(k),wc(k),k=1,ne)
              end if
          else if(sctmdl.ne.0.and.iy.eq.3) then
              if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
              if(kd.eq.1) write(6,200) atom(i),
     *                      comp3(j),(wx(k),wc(k),k=1,ne)
          end if
 111      continue
      end if
 11   continue
 22   continue
      write(6,201)
 10   continue
      if(itwin.ne.0) then
           ntwin=abs(itwin)
           do 801 i=1,ntwin
           volr(i)=0.
           do 802 j=1,6
           dt(j,i)=0.
 802       continue
 801       continue
      if(i8.gt.i6) then
c          twin volume
           do 80 i=i7,i8
                nz=ja(4,i)
           do 80 n=1,nz
                in=in+1
                itw=ja(1,in)
                volr(itw)=volr(itw)+x(i)*ea(in)
 80        continue
           write(6,'('' twin domain volume ratio: '',8f12.6)')
     *       (volr(itw),itw=1,ntwin)
      write(6,201)
      end if
      if(i10.gt.i8) then
c          phase shift
           do 81 i=i9,i10
           nz=ja(4,i)
           do 81 n=1,nz
           in=in+1
           itw=ja(1,in)
           j=ja(2,in)
           dt(j,itw)=dt(j,itw)+x(i)*ea(in)
 81        continue
           write(6,'('' additional shift for twinoperators:'',6f12.6)')
     *       ((dt(j,itw),j=1,6),itw=1,ntwin)
           write(6,201)
      end if
      end if
      write(6,'('' scale factors: '',6f12.6)') (x(i),i=i11,i12)
      write(6,201)
 40   continue
      if(nde.eq.2) then
          aa=comp2(9)
          comp2(9)=comp2(12)
          comp2(12)=aa
          aa=comp4(4)
          comp4(4)=comp4(7)
          comp4(7)=aa
      end if
      return
 200  format(1h ,a,1x,a4,6(i6,'(',a,')'))
 203  format(1h ,11x,    6(i6,'(',a,')'))
 201  format(1h )
 202  format(1h ,'fourier trm',6(i6,6x))
 204  format(1h ,'           ',6(i6,6x))
      end

      subroutine egvctr(r,ja,ea,nx,nzc,xjl,bjl,fjl,csb,it,
     *                   nw,na,nl,x,b,p,isub)
      dimension ea(*),ja(4,*),xjl(3,na,*),bjl(it,na,*),
     *   fjl(1,na,*),r(*),csb(nw,na,*),x(6,*),b(*),p(*),isub(*)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /cctwn/ dt(6,48)
      common /cdim/ idm,nde
      integer dspmdl,tmpmdl,sctmdl
c      common /ceat/ eat(6,3)
      common /ceat/ eat(6,3),ebt(6,3)
c
c     calculation of atomic position, temperature factor, and scattering
c     in modulated structure
c
      m=0
      do 70 ml=1,ilm(1)*ilm(2)*ilm(3)
      do 70 n1=1,ilc(1)*ilc(2)*ilc(3)
           m=m+1
           do 71 jk=1,na
           js=isub(jk)
           do 72 j=1,3
 72        xjl(j,jk,m)=x(j,jk)
           if(itempf.eq.0) then
               do 731 j=1,it
               if(j.eq.1) then
                   bjl(j,jk,m)=b(jk)
               else
                   bjl(j,jk,m)=0
               end if                
 731           continue
           else
               do 732 j=1,it
               if(j.le.6) then
                   bjl(j,jk,m)=b(jk)*eat(j,js)
               else
                   bjl(j,jk,m)=0
               end if
 732           continue
           end if
           fjl(1,jk,m)=p(jk)
 71        continue
           in=0
           do 74 i=i1,i6
           nz=ja(4,i)
           do 74 n=1,nz
           in=in+1
           jk=ja(1,in)
           if(jk.eq.0) go to 74
           j=ja(2,in)
           k=ja(3,in)
           if(i.gt.i2) go to 75
           xjl(j,jk,m)=xjl(j,jk,m)+r(i)*ea(in)*csb(k,jk,m)
           go to 74
 75        if(i.gt.i4) go to 76
           bjl(j,jk,m)=bjl(j,jk,m)+r(i)*ea(in)*csb(k,jk,m)
           go to 74
 76        if(sctmdl.eq.0) go to 74
           fjl(1,jk,m)=fjl(1,jk,m)+r(i)*ea(in)*csb(k,jk,m)
 74        continue
           if(sctmdl.ne.0) go to 70
           do 78 jk=1,na
 78        fjl(1,jk,m)=1.0
 70   continue
      if(itwin.eq.0) then
           volr(1)=1.0
      else
           ntwin=itwin
           do 801 i=1,ntwin
           volr(i)=0.
           do 802 j=1,6
           dt(i,j)=0.
 802       continue
 801       continue
      end if
      if(i8.gt.i6) then
c          twin volume
           do 80 i=i7,i8
                nz=ja(4,i)
           do 80 n=1,nz
                in=in+1
                itw=ja(1,in)
                volr(itw)=volr(itw)+r(i)*ea(in)
 80        continue
      end if
 82   continue
c      if(i10.gt.i8) then
cc          phase shift
c           do 81 i=i9,i10
c           nz=ja(4,i)
c           do 81 n=1,nz
c           in=in+1
c           itw=ja(1,in)
c           j=ja(2,in)
c           dt(itw,j)=dt(itw,j)+r(i)*ea(in)
c 81        continue
c      end if
 83   continue
      return
      end

      subroutine extcor(mp,mq,mr,x,y,z,wxyz,ads,ama,yd,fcal,ext,extd)
      dimension aa(10),bb(10),cc(10),ff(10),cm(3,3),om(3,3)
      common /extcr1/wv,abc0,cm,om,aa,bb,cc,ff,nbf,cef,cbt2,vol
      dimension s(3),so(3),sop(3),sp(3),yd(3),extd(2)
      dimension x(mp,mq,mr),y(mp,mq,mr),z(mp,mq,mr),wxyz(mp,mq,mr)
      us(s1,s2,s3,a,b,c)=a*s1**2+b*s2**2+c*s3**2
      vs(s1,s2,s3,x1,x2,x3,a,b,c)=2.0*(a*x1*s1+b*x2*s2+c*x3*s3)
      ws(x1,x2,x3,a,b,c,f)=a*x1**2+b*x2**2+c*x3**2-f
      vt(s1,s2,s3,h,p,q)=h*s1+p*s2+q*s3
      wt(x1,x2,x3,h,p,q,f)=h*x1+p*x2+q*x3-f
      st1(u,v,w)=(-v+sqrt(v**2-4.0*u*w))/(2.0*u)
      st2(v,w)=-w/v
      ai0(u)=1+u**2/4.0+u**4/64.0+u**6/2304.0
      ai0d(u)=u/2.0+u**3/16.0+u**5/384.0
      xc=cm(1,1)*yd(1)+cm(1,2)*yd(2)+cm(1,3)*yd(3)
      yc=cm(2,1)*yd(1)+cm(2,2)*yd(2)+cm(2,3)*yd(3)
      zc=cm(3,1)*yd(1)+cm(3,2)*yd(2)+cm(3,3)*yd(3)
      call dif(xc,yc,zc,sop,sp,stt,ctt)
      call xmpy(om,sop,so,3,3,1)
      call xmpy(om,sp,s,3,3,1)
      alph=6.28318*stt/wv
      deno=1.+ads*ama*alph
      deno2=deno**2
      tau=ads/deno
      dtad=1./deno2
      dtam=-ads**2*alph/deno2
      fcal2=fcal**2
      ctt2=ctt**2
      pf=cbt2+ctt2
      sg1=tau*cef*fcal2
      sg2=sg1*ctt2
      vol=0.0
      ext1=0.0
      ext2=0.0
      ext3=0.
      ext4=0.
      do 502 np=1,mp
      do 502 nq=1,mq
      do 502 nr=1,mr
      to=1000.
      t=1000.
      x1=x(np,nq,nr)
      x2=y(np,nq,nr)
      x3=z(np,nq,nr)
      do 426 i=1,nbf
      top=1000.
      tp=1000.
      if(nbf.ne.1) go to 427
      ws0=ws(x1,x2,x3,aa(i),bb(i),cc(i),ff(i))
      us0=us(so(1),so(2),so(3),aa(i),bb(i),cc(i))
      us1=us(s(1),s(2),s(3),aa(i),bb(i),cc(i))
      vs0=vs(so(1),so(2),so(3),x1,x2,x3,aa(i),bb(i),cc(i))
      vs1=vs(s(1),s(2),s(3),x1,x2,x3,aa(i),bb(i),cc(i))
      top=st1(us0,-vs0,ws0)
      tp=st1(us1,vs1,ws0)
 427  if(nbf.eq.1) go to 428
      ws0=wt(x1,x2,x3,aa(i),bb(i),cc(i),ff(i))
      vs0=vt(so(1),so(2),so(3),aa(i),bb(i),cc(i))
      vs1=vt(s(1),s(2),s(3),aa(i),bb(i),cc(i))
      if(abs(vs0).gt.1.e-20) top=st2(-vs0,ws0)
      if(abs(vs1).gt.1.e-20) tp=st2(vs1,ws0)
 428  continue
      if(top.gt.0.0.and.top.lt.to) to=top
      if(tp.gt.0.0.and.tp.lt.t) t=tp
 426  continue
c     compute extinction factor
      q=wxyz(np,nq,nr)
      ta=to+t
      sta=2.0*sqrt(to*t)
      exp1=exp(-(abc0+sg1)*ta)*q
      exp2=exp(-(abc0+sg2)*ta)*q
      ai01=ai0(sg1*sta)
      ai02=ai0(sg2*sta)
      ext1=ext1+exp1*ai01
      ext2=ext2+exp2*ai02
      ext3=ext3-exp1*(ai01*ta-ai0d(sg1*sta)*sta)
      ext4=ext4-exp2*(ai02*ta-ai0d(sg2*sta)*sta)
      vol=vol+q
 502  continue
      ext=(cbt2  *ext1+ctt2  *ext2)/(vol*pf)
      ext=sqrt(ext)
      exd=(cbt2*ext3+ctt2*ext4*ctt2)*cef*fcal2/(2.0*ext*vol*pf)
      extd(1)=exd*dtad
      extd(2)=exd*dtam
      return
      end

      subroutine xmpy(a,b,c,lm,ln,lp)
      dimension a(3,1),b(3,1),c(3,1)
      do 30 i=1,lm
      do 30 k=1,lp
      c(i,k)=0.
      do 30 j=1,ln
 30   c(i,k)=c(i,k)+a(i,j)*b(j,k)
      return
      end

      subroutine dif(xc,yc,zc,so,s,stt,ctt)
      dimension so(3),s(3)
      data pi4/0.785398/
      xy=sqrt(xc**2+yc**2)
      xyz=sqrt(xy**2+zc**2)
      sth=xyz/2.0
      cth=sqrt(1.0-sth**2)
      stt=2.0*sth*cth
      ctt=cth**2-sth**2
      phi=pi4
      chi=pi4
      if(xc.ne.0) phi=atan2(yc,xc)
      cph=cos(phi)
      sph=sin(phi)
      if(xy.ne.0) chi=atan2(zc,xy)
      cch=cos(chi)
      sch=sin(chi)
      s11=sth*cch*cph
      s12=cth*sph
      s21=sth*cch*sph
      s22=cth*cph
      s31=sth*sch
      so(1)=-s11-s12
      so(2)=-s21+s22
      so(3)=-s31
      s(1)=s11-s12
      s(2)=s21+s22
      s(3)=s31
      return
      end

      subroutine tdxr(x,dx,ips,nx,ie)
      dimension x(*),dx(*)
      dimension ips(*)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      k=0
      k2=0
      do 10 kr=1,i6,2
      ks=kr+1
      if(ips(kr).eq.0.and.ips(ks).eq.0) go to 10
      k2=k2+2
      k1=k2-1
      a=sqrt(x(kr)**2+x(ks)**2)
      da=dx(k1)
      db=dx(k2)
      if(ips(kr).eq.0) go to 11
      k=k+1
      dx(k )=(x(kr)*da+x(ks)*db)/a
 11   if(ips(ks).eq.0) go to 10
      k=k+1
      dx(k )=x(ks)*da-x(kr)*db
 10   continue
      do 12 i=i7,i12
      if(ips(i).eq.0) go to 12
      k=k+1
      k2=k2+1
      dx(k)=dx(k2)
 12   continue
      return
      end

      function asf(yb,jk)
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand
      i=yb/0.05+1.0
      if(i.ge.29) i=(yb-1.4)/0.1+29.0
      if(i.ge.35) go to 20
      j=i+1
      if(i.ge.29) go to 21
      ai=float(i-1)*0.05
      asf=ascf(i,jk)+(ascf(j,jk)-ascf(i,jk))*(yb-ai)/0.05+df1(jk)
      return
 21   ai=float(i-29)*0.1+1.4
      asf=ascf(i,jk)+(ascf(j,jk)-ascf(i,jk))*(yb-ai)/0.1+df1(jk)
      return
 20   continue
      asf=0.0
      return
      end

      subroutine pnf1(f,g,h,fjl,ja,ea,csb,m,ie,ips,x,ij,nwd,nad,nu)
      dimension fjl(1,nad,*),csb(nwd,nad,*),ea(*),ja(4,*),g(*)
      dimension h(*),ips(*),x(*)
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      common /cpnf/ grad1,expn1,grad2,expn2,np
      real m(*)
      dimension nm(3)
c***********************************************************************
c     penalty function for occupation probability
c      ipnf1=1: limit upper and lower side
c      ipnf1=2: limit only lower side
c      fjl: the occupation probability at the calculated points
c      f: value of the penalty function
c      m: the normal matrix
c      g: the right hand side of the normal equation
c***********************************************************************
      a=na
      f=0.0
      ge=expn1
      do 11 jk=1,na
      l=0
      do 11 m3=1,ilm(3)
      do 11 m2=1,ilm(2)
      do 11 m1=1,ilm(1)
      do 11 l1=1,ilc(1)*ilc(2)*ilc(3)
           nm(1)=m1
           nm(2)=m2
           nm(3)=m3
           if(icorc(1).eq.0) nm(1)=l1
           if(icorc(2).eq.0) nm(2)=l1
           if(icorc(3).eq.0) nm(3)=l1
           hjl=hj(nm(1),1)*hj(nm(2),2)*hj(nm(3),3)
           l=l+1
           p=fjl(1,jk,l)
c          calculation of narmal matrix
           gk=0.0
           gl=0.0
           if(p.gt.0) go to 50
           gk=(-p)**expn1
           gl=-ge*(-p)**(expn1-1.0)
 50        if(p.le.1.or.ipnf1.eq.2) go to 51
           gk=(p-1)**expn1
           gl=ge*(p-1)**(expn1-1.0)
 51        continue
           if(ij.eq.0.or.gk.eq.0.0) go to 11
           je=0
           js=0
           ii=0
           jn=0
           do 12 i=1,i6
           if(ips(i).eq.1) je=je+1
           if(i.lt.i5.and.ips(i).eq.1) js=js+1
           if(ipol.ne.1.and.ips(i).eq.0) go to 12
           is=i+mod(i,2)
           ic=is-1
           if(ipol.eq.1.and.ips(ic).eq.0.and.ips(is).eq.0)
     *            go to 12
           ii=ii+1
           h(ii)=0.0
           if(i.lt.i5) go to 12
           df=0.0
           nz=ja(4,i)
           do 13 n=1,nz
           in=jn+n
           if(ja(1,in).ne.jk) go to 13
           k=ja(3,in)
           df=df+ea(in)*csb(k,jk,l)
 13        continue
           h(ii)=df*gl
 12        jn=jn+ja(4,i)
           jl=js*(js+1)/2
           js1=js+1
           if(je.lt.js1) go to 11
           if(ipol.eq.1) call tdxr(x,h,ips,nu,ie)
           do 14 i=js1,je
           hi=h(i)*hjl*grad1/a
           g(i)=g(i)-hi*gk
           do 14 j=1,i
           jl=jl+1
 14        m(jl)=m(jl)+hi*h(j)
 11   f=f+gk*gk*hjl*grad1
      f=sqrt(f/a)
      return
      end

      subroutine pnf2(f,g,h,ja,ea,csb1,csb2,m,
     *       ie,ips,r,ij,x,isub,ifrt1,ifrt2,coeff,d,n1,n2)
      dimension csb1(n1,*),csb2(n1,*),ea(*),ja(4,*),ifrt2(*),d(*)
      character*4 ifrt1(*)
      real m(*)
      dimension g(*),h(n2,*),ips(*),r(*),x(6,*),isub(*),coeff(*)
c     ******n1=nw,n2=nu******
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      integer atom1,atom2,w
c      common /cpnf2/ atom1(100),atom2(100),nsym(100),
c     *        icnt(100),trd(6,100),dmax(100),dmin(100),npi(100)
      common /cpnf2/ atom1(200),atom2(200),nsym(200),
     *        icnt(200),trd(6,200),dmax(200),dmin(200),npi(200)
      common /cpnf/ grad1,expn1,grad2,expn2,np
      integer rr
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3)
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      dimension x1(6),x2(6),x3(6),u1(3),u2(3),u3(3),sign(2)
     *        ,x1l(3),x2l(3),djl(3),td(6),ttd(6),tt0(6)
      dimension nm(3)
      data sign/1.0,-1.0/,tt0/6*0.0/
c***********************************************************************
c     penalty function for the restriction of atomic distances
c      np: number of atom pairs
c      atom1, atom2: atom numbers of a pair
c      nsym: symmetry operator number generating the second atom
c      nsymi: symmetry operator number of the inverse operator of the
c             above operator
c      icnt: if inversion is necessary to obtain the second atom
c            in addition to the above operator, give 1,
c            otherwise, give 0 for icnt
c      tdr: additional translation accompanied by the above operator
c                  after the inversion if icnt=1
c        rr(i,j,nsym), tt(i), trd(i,nsym) generate the second atom
c        from the atom2-th atom
c      f: the value of the penalty function
c      m: the normal matrix
c      g: the right hand side of the normal equation
c***********************************************************************
      a=np
      f=0.0
      ge=expn2
      n=0
      do 11 l1=1,np
      do 115 i=1,n2
      do 115 l=1,nl
115   h(i,l)=0
c  calculation of interatomic distances
      do 117 l=1,nl
 117  d(l)=0
      n2e=npi(l1)
      do 118 l2=1,n2e
      n=n+1
c  initialization
      j1=atom1(n)
      j2=atom2(n)
      js=isub(j1)
      if(isub(j2).ne.js) then
        call quit('penalty function between different substructures')
      end if
      k=nsym(n)
      do 111 j=1,6
      x1(j)=x(j,j1)
 111  x2(j)=x(j,j2)
cc ****  1990/09/22 modified by A. Yamamoto
c           additional translation after the inversion
          do 712 id=1,6
              if(icnt(n).eq.0) then
                  td(id)=trd(id,n)
              else
                  td(id)=-trd(id,n)
              end if
 712      continue
          do 710 id=1,3
 710      ttd(id)=tt(id,k,js)+td(id)
          do 711 id=4,6
 711      ttd(id)=0
      call getrx(x2,x3,rr(1,1,k,js),ttd,1,icnt(n))
c      do 112 j=1,6
c      x3(j)=0
c           do 1121 l=1,6
c 1121      x3(j)=x3(j)+rr(j,l,k,js)*x2(l)
c      if(j.le.3) then
c          x3(j)=x3(j)+tt(j,k,js)+trd(j,n)
c      end if
c      td(j)=trd(j,n)
c 112  continue
c      if(icnt(n).eq.1) then
c           do 114 j=1,6
c 114       x3(j)=-x3(j)
c      end if
      call begin(csb1,nw,nt,1,nl,x1,isub(j1),ifrt1,ifrt2,coeff,
     *    1,0,tt0)
      call begin(csb2,nw,nt,1,nl,x3,isub(j1),ifrt1,ifrt2,coeff,
     *    nsym(n),icnt(n),td)
      l=0
      do 116 m3=1,ilm(3)
      do 116 m2=1,ilm(2)
      do 116 m1=1,ilm(1)
      do 116 ll=1,ilc(1)*ilc(2)*ilc(3)
           nm(1)=m1
           nm(2)=m2
           nm(3)=m3
           if(icorc(1).eq.0) nm(1)=ll
           if(icorc(2).eq.0) nm(2)=ll
           if(icorc(3).eq.0) nm(3)=ll
           hjl=hj(nm(1),1)*hj(nm(2),2)*hj(nm(3),3)
           l=l+1
           in=0
           do 73 i=1,3
           u1(i)=0
 73        u2(i)=0
           do 74 i=i1,i2
           nz=ja(4,i)
           do 74 nn=1,nz
           in=in+1
           jk=ja(1,in)
           j=ja(2,in)
           w=ja(3,in)
           if(jk.eq.j1) u1(j)=u1(j)+r(i)*ea(in)*csb1(w,l)
           if(jk.eq.j2) u2(j)=u2(j)+r(i)*ea(in)*csb2(w,l)
 74        continue
           do 75 j=1,3
           x1l(j)=u1(j)+x1(j)
           u3(j)=rr(j,1,k,js)*u2(1)+
     *                 rr(j,2,k,js)*u2(2)+rr(j,3,k,js)*u2(3)
           if(icnt(n).eq.0) x2l(j)=u3(j)+x3(j)
 75        if(icnt(n).eq.1) x2l(j)=-u3(j)+x3(j)
           do 76 j=1,3
 76        djl(j)=x1l(j)-x2l(j)
           dd=0
           do 77 i=1,3
           do 77 j=1,3
 77        dd=dd+djl(i)*gab(i,j,js)*djl(j)
           d(l)=d(l)+sqrt(dd)/n2e
c   calculation of derivatives
           ii=0
           je=0
           jn=0
           if(ij.eq.0) go to 116
           do 12 i=i1,i2
           if(ips(i).eq.1) je=je+1
           if(ipol.ne.1.and.ips(i).eq.0) go to 12
           is=i+mod(i,2)
           ic=is-1
           if(ipol.eq.1.and.ips(ic).eq.0.and.ips(is).eq.0)
     *           go to 12
           ii=ii+1
           df=0.0
           nz=ja(4,i)
           do 13 nn=1,nz
           in=jn+nn
           jk=ja(1,in)
           if(jk.ne.j1.and.jk.ne.j2) go to 13
           j=ja(2,in)
           w=ja(3,in)
           if(jk.eq.j1) df=df+ea(in)*csb1(w,l)*(gab(j,1,js)*djl(1)+
     *              gab(j,2,js)*djl(2)+gab(j,3,js)*djl(3))/d(l)
           if(jk.eq.j2) df=df-ea(in)*csb2(w,l)*sign(icnt(n)+1)*
     *     (rr(1,j,k,js)*
     *     (gab(1,1,js)*djl(1)+gab(1,2,js)*djl(2)+gab(1,3,js)*djl(3))
     *     +rr(2,j,k,js)*
     *     (gab(2,1,js)*djl(1)+gab(2,2,js)*djl(2)+gab(2,3,js)*djl(3))
     *     +rr(3,j,k,js)*
     *     (gab(3,1,js)*djl(1)+gab(3,2,js)*djl(2)+gab(3,3,js)*djl(3))
     *     )/d(l)
 13        continue
           h(ii,l)=h(ii,l)+df/n2e
 12        jn=jn+ja(4,i)
 116  continue
 118  continue
      do 11 l=1,nl
      gk=0
      gl=0
      dd=dmax(l1)-dmin(l1)
      d1=dmin(l1)-d(l)
      d2=d(l)-dmax(l1)
      if(d1.lt.0) go to 50
      gk=(d1/dd)**expn2
      gl=-ge*d1**(expn2-1.0)/dd**expn2
 50   if(d2.lt.0) go to 51
      gk=(d2/dd)**expn2
      gl=+ge*d2**(expn2-1.0)/dd**expn2
 51   continue
      if(gk.eq.0) go to 11
      jl=0
      if(je.le.0) go to 11
      if(ipol.eq.1) call tdxr(r,h,ips,nu,ie)
c  generation of normal matrix
      do 14 i=1,je
      h(i,l)=h(i,l)*gl
      hi=h(i,l)*hjl*grad2/a
      g(i)=g(i)-hi*gk
      do 14 j=1,i
      jl=jl+1
 14   m(jl)=m(jl)+hi*h(j,l)
 11   f=f+gk*gk*hjl*grad2
c  calculation of penalty function
      f=sqrt(f/a)
      return
      end

      subroutine wtfhkl(fct,iwf,y)
      dimension y(*)
      common /fhkl/ hkln(100),fobs(100),fcal(100),wght(100),im(20),is
      common /cdim/ idm,nde
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      integer rr
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      common /filen/ flfobs,flfcal
      dimension r(20),re(20),rw(20),sfow(20),sfocw(20),nn(20),nsat(20)
      dimension sfo(20),sfod(20),sfoc(20),sfocd(20)
      integer hkln,ih(6),wh(4,6),jh(6)
      integer wfobs(4),wfcal(4),wfofc(4),iw(2)
      character*2 iform(2)
      character*4 wwght(2)
      character*26 flfcal,flfobs
      integer h4,hd
      common /islct/ hd(3),h4(3,40),nslct
      complex fcal
      data iform/'  ','  '/,wwght/'*   ','    '/
c     open(unit=91,access='direct',recl=1200,file=flfobs)
c     open(unit=92,access='direct',recl=800,file=flfcal)
      nds=i12-i10
c********************************************************************
c     scaling of fobs
c********************************************************************
      ir1=0
      i=0
      do 75 inds=1,nds
          ime=im(inds)
          if(ime.eq.0) go to 75
          do 76 ia=1,ime
              i=mod(i,100)
              if(i.eq.0) ir1=ir1+1
              if(i.eq.0) read(unit=91,rec=ir1) hkln,fobs,wght
              i=i+1
              fobs(i)=fobs(i)/y(i10+inds)
 76       if(i.eq.100) write(unit=91,rec=ir1) hkln,fobs,wght
 75   continue
      if(i.ne.100) write(unit=91,rec=ir1) hkln,fobs,wght
c***********************************************************************
c     write fo fc df
c***********************************************************************
      ir1=0
      mipm=mod(is-1,100)+1
      ipm=(is-1)/100+1
      micm=mod(mipm-1,50)+1
      icm=(mipm-1)/50+1
      if(iwf.eq.1) write(6,200) fct
      do 50 ip=1,ipm
      ic=2
      if(ip.eq.ipm) ic=icm
      if(iwf.eq.1) write(6,203) (iform(i),i=1,ic)
      do 60 ii=1,50
      il=50
      if(ip.eq.ipm) il=micm
      if(ii.eq.il+1) ic=ic-1
      if(ic.eq.0) go to 60
      do 61 ij=1,ic
      jj=ii+(ij-1)*50+(ip-1)*100
      mj=mod(jj-1,100)+1
      if (mj.eq.1) ir1=ir1+1
      if(mj.eq.1) read(unit=91,rec=ir1) hkln,fobs,wght
      if(mj.eq.1) read(unit=92,rec=ir1) fcal
      call ihkln(ih,hkln(mj))
      do 70 k=1,6
 70   wh(ij,k)=ih(k)
      if(wght(mj).eq.0.0) iw(ij)=1
      if(wght(mj).ne.0.0) iw(ij)=2
      fo       =fobs(mj)*fct
      fc       =sqrt(real(fcal(mj))**2+aimag(fcal(mj))**2)*fct
      fd       =fo-fc
      wfobs(ij)=sign(abs(fo)+0.5,fo)
      wfcal(ij)=sign(abs(fc)+0.5,fc)
      wfofc(ij)=sign(abs(fd)+0.5,fd)
 61   continue
      if(iwf.ne.1) go to 60
      write(6,204) ((wh(i,k),k=1,6),wfobs(i),wfcal(i),
     1wwght(iw(i)),wfofc(i),i=1,ic)
 60   continue
      if(iwf.eq.1) write(6,205)
 50   continue
 51   continue
c     close(unit=91)
c     close(unit=92)
      if(nslct.eq.0) return
c***********************************************************************
c     calculate partial r-factors
c***********************************************************************
c     open(unit=91,access='direct',recl=1200,file=flfobs)
c     open(unit=92,access='direct',recl=800,file=flfcal)
      write(6,208)
      jpm=(nslct-1)/20+1
      do 33 ip=1,jpm
      ir1=1+(ip-1)*20
      ir2=ip*20
      do 31 i=1,20
      nsat(i)=0
      r(i)=0.0
      re(i)=0.0
      rw(i)=0.0
      sfo(i)=0
      sfod(i)=0
      sfow(i)=0.0
      sfoc(i)=0
      sfocw(i)=0.0
 31   sfocd(i)=0
      do 32 jp=1,ipm
      read(unit=91,rec=jp) hkln,fobs,wght
      read(unit=92,rec=jp) fcal
      mje=100
      if(jp.eq.ipm) mje=mipm
      do 32 mj=1,mje
      call ihkln(ih,hkln(mj))
      do 500 nd=1,nsub
          call gethz(zmtrx(1,nd),ih,jh)
          do 141 ia=1,nslct
          do 141 n=1,nsymo
              do 142 j=1,nde
              hd(j)=0
              do 142 k=1,nde
 142          hd(j)=hd(j)+jh(k+3)*rr(k+3,j+3,n,nd)
              do 143 j=1,nde
              if(abs(hd(j)-h4(j,ia)).gt.0)go to 144
 143          continue
          go to 13
 144      do 145 j=1,nde
          if(abs(hd(j)+h4(j,ia)).gt.0) go to 141
 145      continue
          go to 13
 141      continue
 500  continue
c          go to 10
 510  continue
 13   ir=ia
      if(ir.lt.ir1.or.ir.gt.ir2) go to 32
      ir=ir-(ip-1)*20
      if(wght(mj).eq.0.0) go to 32
      fo       =fobs(mj)*fct
      fc       =sqrt(real(fcal(mj))**2+aimag(fcal(mj))**2)*fct
      fd       =fo-fc
      if(fobs(mj).ne.0.0) sfod(ir)=sfod(ir)+fo
      if(fobs(mj).ne.0.0) sfocd(ir)=sfocd(ir)+abs(fd)
      sfo(ir)=sfo(ir)+fo
      sfoc(ir)=sfoc(ir)+abs(fd)
      sfow(ir)=sfow(ir)+fo**2*wght(mj)
      sfocw(ir)=sfocw(ir)+fd**2*wght(mj)
      nsat(ir)=nsat(ir)+1
 32   continue
      jm=20
      if(ip.eq.jpm) jm=mod(nslct-1,20)+1
      do 63 i=1,jm
      nn(i)=i+(ip-1)*20
      if(sfod(i).ne.0) re(i)=sfocd(i)/sfod(i)
      sfow(i)=sqrt(sfow(i))
      sfocw(i)=sqrt(sfocw(i))
      if(sfow(i).ne.0.0) rw(i)=sfocw(i)/sfow(i)
 63   if(sfo(i).ne.0) r(i)=sfoc(i)/sfo(i)
      write(6,207) (nn(i),(h4(j,i+ir1-1),j=1,3),r(i),re(i),rw(i),sfo(i)
     1,sfow(i),nsat(i),i=1,jm)
 33   continue
c     close(unit=91)
c     close(unit=92)
      return
 200  format(1h ,'fo and fc (',f12.6,')')
 203  format(1h ,2(a1,'h1',1x,'h2',1x,'h3',1x,'h4',1x,'h5',1x,'h6',3x,
     1'fo',3x,'fc',3x,'df',4x))
 204  format(1h ,2(3i3,3i3,2i5,a1,i4,4x))
 205  format(1h1)
 206  format(1h )
 207  format(1h ,'group',i3,2x,'h4 h5 h6=',3i3,2x,'r =',f6.3,2x,'rd=',
     1f6.3,2x,'rw=',f6.3,2x,'sfo=',f10.0,2x,'sfow=',f10.0,2x,'no.ref.=',
     2i10)
 208  format(1h ,'partial r-factor')
      end

      subroutine ihkln(ih,hkln)
      integer ih(6),hkln,hm
      common /chkln/ iex(6),hm(6)
      ih(1)=hkln/iex(1)-hm(1)
      do 10 i=2,6
 10   ih(i)=mod(hkln,iex(i-1))/iex(i)-hm(i)
      return
      end


