      subroutine quit(c)
      character*(*) c
      write(6,'(a)') c
      call exit()
      end
      subroutine rdap(na,isft,mpl,x)
      common /cwflag/ iwflag(6)
      common /cltc/ atom(2,100)
      dimension isft(na),mpl(na),x(6,na)
      real mpl
      if(iwflag(3).eq.1) then
           write(6,301) na
      end if
      do 9 i=1,na
      read(5,102) ik,(atom(j,i),j=1,2),isft(i),(x(j,i),j=1,6),mpl(i)
      if(iwflag(3).eq.1) then
            write(6,302)ik,(atom(j,i),j=1,2),isft(i),(x(j,i),j=1,6),
     *      mpl(i)
      end if
 9    continue
      if(iwflag(3).eq.1) then
           write(6,300)
      end if
 102  format(i2,a4,a2,i2,7f9.6)
 300  format(1h )
 301  format(1h ,'na=',i3/1h ,6hnumber,2x,9ha.symbole,2x,9hs.f.table,4x
     * ,'unit vector components of atomic position',16x,'multiplicity')
 302  format(1h ,i4,6x,a4,a2,6x,i2,6x,6f9.6,4x,f12.6)
      return
      end
      subroutine rdasf(ip)
      common /cwflag/ iwflag(6)
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand
      dimension a(4,20),b(4,20),c(20)
      do 10 i=1,20
      df1(i)=0.0
 10   df2(i)=0.0
      read(5,101) ne,iand,ia
      if(ia.ne.0) ia=1
      if(iwflag(3).eq.1) then
           write(6,205) ne,iand,ia
      end if
      do 20 ik=1,ne
      if(ia.eq.0) read(5,100) (ascf(i,ik),i=1,35)
      if(ia.eq.1) read(5,102) (a(i,ik),b(i,ik),i=1,4),c(ik)
      if(iand.eq.1) read(5,102) df1(ik),df2(ik)
      if(ia.eq.1.and.ip.eq.-1) read(5,102) (a(i,ik+ne),b(i,ik+ne),
     *        i=1,4),c(ik+ne)
      if(ia.eq.0.and.ip.eq.-1) read(5,100) (ascf(i,ik+ne),i=1,35)
      if(ip.eq.-1.and.iand.eq.1) read(5,100) df1(ik+ne),df2(ik+ne)
 20   continue
      if(iwflag(3).eq.1) then
           write(6,202)
      end if
      do 30 ik=1,ne
      if(ia.eq.1) then
           do 31 i=1,35
           sint=((i-1)*0.05)**2
           ascf(i,ik)=c(ik)
           if(ia.eq.1) ascf(i,ik+ne)=c(ik+ne)
           do 31 j=1,4
           ascf(i,ik)=ascf(i,ik)+a(j,ik)*exp(-b(j,ik)*sint)
           if(ip.eq.-1) ascf(i,ik+ne)=ascf(i,ik+ne)+a(j,ik+ne)*
     *              exp(-b(j,ik+ne)*sint)
 31        continue
      end if
      if(iwflag(3).eq.1) then
           if(iand.ne.1) write(6,2001) ik
           if(iand.eq.1) write(6,2002) ik,df1(ik),df2(ik)
           if(ia.eq.1) write(6,203) (i,a(i,ik),i,b(i,ik),i=1,4),c(ik)
           write(6,201) (ascf(i,ik),i=1,35)
           if(ip.ne.-1) go to 30
           if(iand.ne.1) write(6,2041)
           if(iand.eq.1) write(6,2042) df1(ik+ne),df2(ik+ne)
           if(ia.eq.1) write(6,203) (i,a(i,ik+ne),i,b(i,ik+ne),i=1,4),
     *          c(ik+ne)
           write(6,201) (ascf(i,ik+ne),i=1,35)
      end if
 30   continue
      return
 100  format(12f6.3)
 101  format(3i3)
 102  format(9f8.5)
 2001 format(1h ,'table',i3)
 2002 format(1h ,'table',i2,8x,'real and imaginary parts of dispersion
     *         correction',2f10.5)
 201  format((1h ,12(f6.3,4x)))
 202  format(1h ,'atomic scattering factor table')
 203  format(1h ,'input data'/1h ,4('a',i1,'=',f10.6,1x,'b',i1,'=',
     *         f10.6,1x),'c=',f10.6)
 2041 format(1h ,'second species')
 2042 format(1h ,'second species real and imaginary parts of dispersion
     *          correction',2f10.5)
 205  format(1h ,'ne=',i3,2x,'iand=',i3,2x,'inpd=',i3)
      end
      subroutine rdextc
      common /cwflag/ iwflag(6)
      common /extcr1/ wv,abc0,cm,om,aa,bb,cc,ff,nbf,cef,cbt2,vol
      common /extcr2/ ex(1000),ey(1000),ez(1000),wxyz(1000),mp,mq,mr
      dimension cm(3,3),om(3,3),aa(10),bb(10),cc(10),ff(10)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3)
c     read data for extinction correction
      read(5,110) nbf,mp,mq,mr,icm
      if(mp*mq*mr.gt.1000) then
          write(6,'(1h ,a)') 'mp*mq*mr>1000'
          stop
      end if
      read(5,112) (aa(i),bb(i),cc(i),ff(i),i=1,nbf)
      read(5,111) wv,abc0,bth,amag
      read(5,111) ((cm(i,j),j=1,3),i=1,3)
      if(icm.eq.0) go to 20
      if(iwflag(3).eq.1) then
           write(6,213) ((cm(i,j),j=1,3),i=1,3)
      end if
      do 10 i=1,3
      do 10 j=1,3
      om(i,j)=0
      do 10 k=1,3
 10   om(i,j)=om(i,j)+cm(i,k)*gaby(k,j)
      do 11 i=1,3
      do 11 j=1,3
 11   cm(i,j)=om(i,j)
 20   read(5,111) ((om(j,i),j=1,3),i=1,3)
      if(iwflag(3).eq.1) then
           write(6,210) nbf,mp,mq,mr,icm
           write(6,211) (aa(i),bb(i),cc(i),ff(i),i=1,nbf)
           write(6,212) wv,abc0,bth,amag
           write(6,213) ((cm(i,j),j=1,3),i=1,3)
           write(6,214) ((om(j,i),j=1,3),i=1,3)
      end if
      v=gabx(1,1)*gabx(2,2)*gabx(3,3)*amag
      cef=(wv*28.18/v)**2
      cbt=cos(2.0*bth*6.28318/360.0)
      cbt2=cbt**2
      call table(mp,mq,mr,wxyz,ex,ey,ez,nbf,aa,bb,cc,ff)
      do 195 i=1,3
      do 195 j=1,3
 195  cm(i,j)=cm(i,j)*wv
      return
 110  format(26i3)
 111  format(10f8.5)
 112  format(4f8.5)
 210  format(1h ,'nbf',i3,3x,'mp',i3,3x,'mq',i3,3x,'mr',i3,3x,'icm',i3)
 211  format(1h ,'boundary functions'/1h ,5x,'aa',10x,'bb',10x,'cc',
     *        10x,'ff'/(1h ,4f12.5))
 212  format(1h ,'wave length',f12.5,6x,'linear absorption coef.',
     *        f12.5,6x,'bragg angle of monochrometer',f12.5/1h ,
     *       'magnification of calculated structure factors',f12.5)
 213  format(1h ,'cell orientation matrix'/(1h ,3f12.5))
 214  format(1h ,'orientation matrix'/(1h ,3f12.5))
      end
      subroutine rdfour(nw,nt,ifrt1,ifrt2,coeff)
      common /cwflag/ iwflag(6)
      dimension ifrt1(nw,2,nt),ifrt2(nw,3,nt),coeff(nw,nt),sig(4),cs(4),
     *         n1(4),n2(4),n3(4),cef(4),ico(4)
      character*4 iblk,sig,cs,ico,ifrt1
      data iblk/' '/
      do 30 i=1,nw
      do 30 k=1,nt
      do 301 j=1,2
 301  ifrt1(i,j,k)='    '
      do 302 j=1,3
 302  ifrt2(i,j,k)=0
 30   continue
      if(iwflag(3).eq.1) then
           write(6,201)
      end if
      i=1
      k=0
 10   read(5,100) (sig(j),cs(j),n1(j),n2(j),n3(j),cef(j),ico(j),j=1,4)
      do 11 j=1,4
      if(sig(j).eq.iblk.and.cs(j).eq.iblk) go to 11
      k=k+1
      ifrt1(i,1,k)=sig(j)
      ifrt1(i,2,k)=cs(j)
      ifrt2(i,1,k)=n1(j)
      ifrt2(i,2,k)=n2(j)
      ifrt2(i,3,k)=n3(j)
      coeff(i,k)=cef(j)
      if(cef(j).eq.0.0) coeff(i,k)=1.0
      if(ico(j).ne.iblk) go to 11
      if(iwflag(3).eq.1) then
             write(6,200) i,((ifrt1(i,jj,l),jj=1,2),
     *                 (ifrt2(i,jj,l),jj=1,3),coeff(i,l),l=1,k)
      end if
      k=0
      i=i+1
 11   continue
      if(i.ne.nw+1) go to 10
      return
 100  format(4(2a1,3i2,f10.6,1x,a1))
 200  format(1h ,i3,2x,4(2a1,'(',3i2,')',f10.6,2x)/(1h ,5x,4(2a1,'(',
     *       3i2,')',f10.6,2x)))
 201  format(1h ,'fourier terms')
      end

      subroutine rdintl(x,mx,ja,ea,x1,n1,n2)
      common /cwflag/ iwflag(6)
      dimension x(n1,n2,*),mx(n1,n2,*),ja(4,*),ea(*),x1(*)
      common /cnsti/ ix,ib,if,itvr,itst,nds,na4
      common /cltc/ atom(2,100)
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl
      common /citfs/ itfs(100)
      common /ceat/ eat(6)
      common /cdim/ idm,nde
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      integer dspmdl,tmpmdl,sctmdl
      character*4 cmp1,cmp2,cmp3,cmp4,aa,no,iblk,mx
      dimension cmp1(3),cmp2(7),cmp3(12),cmp4(1)
      dimension xt1(3,3),xt2(3),xt3(3)
      data no/'#'/,iblk/' '/
      data cmp1/'u','v','w'/,cmp2/'b','b44d','b55d','b66d','b56d',
     *      'b64d','b45d'/,cmp3/'b11','b22','b33','b23','b31',
     *      'b12','b44d','b55d','b66d','b56d','b64d','b45d'/,
     *      cmp4/'p'/
c*******************************************************************
c                      read initial parameters
c*******************************************************************
      if(nde.ne.2) go to 500
      aa=cmp2(4)
      cmp2(4)=cmp2(7)
      cmp2(7)=aa
      aa=cmp3(9)
      cmp3(9)=cmp3(12)
      cmp3(12)=aa
 500  continue

c*****initialization necessary for the case of itempf=-1,-2*********
      do 1000 i=1,3
      do 1000 j=1,3
      xt1(i,j)=0
 1000 if(i.eq.j) xt1(i,i)=1
      do 1001 i=1,3
      do 1002 j=1,3
 1002 xt2(j)=xt1(i,j)
      call yyy(xt2)
 1001 eat(i)=(xt2(1)**2+xt2(2)**2+xt2(3)**2)/4
      do 1003 i=1,3
      ix1=i+1
      ix2=i+2
      ix1=mod(ix1-1,3)+1
      ix2=mod(ix2-1,3)+1
      do 1004 j=1,3
      xt2(j)=xt1(ix1,j)
 1004 xt3(j)=xt1(ix2,j)
      call yyy(xt2)
      call yyy(xt3)
 1003 eat(i+3)=(xt2(1)*xt3(1)+xt2(2)*xt3(2)+xt2(3)*xt3(3))/4
c*******************************************************************
c             read independent initial amplitudes
c*******************************************************************
      if(iwflag(3).eq.1) then
           write(6,201) (i,i=1,nw)
      end if
      do 10 i=1,na
      if(iwflag(3).eq.1) then
           write(6,209) i
      end if
      if(dspmdl.eq.0) go to 30
      do 11 j=1,3
      read(5,100) (x(i,j,k),mx(i,j,k),k=1,nw)
      if(iwflag(3).eq.1) then
           write(6,200) (atom(k,i),k=1,2),cmp1(j),
     *                  (x(i,j,k),mx(i,j,k),k=1,nw)
      end if
 11   continue
 30   if(tmpmdl.eq.0) go to 31
      js=4
      je=3+it
c     if(itempf.eq.2.and.itfs(i).eq.0) je=3+it-5
      if(itempf.le.-1.and.itfs(i).eq.0) je=3+it-5  ! isotropic
c     if(itempf.eq.1.or.itempf.eq.2.and.itfs(i).eq.1) go to 123
      if(itempf.ge.1.or.(itempf.le.-1.and.itfs(i).eq.1)) go to 123
      do 121 j=js,je
      read(5,100) (x(i,j,k),mx(i,j,k),k=1,nw)
      if(iwflag(3).eq.1) then
           write(6,200) (atom(k,i),k=1,2),cmp2(j-3),
     *                   (x(i,j,k),mx(i,j,k),k=1,nw)
      end if
 121  continue
c123  if(itempf.eq.0.or.itempf.eq.2.and.itfs(i).eq.0) go to 134
 123  if(itempf.eq.0.or.(itempf.le.-1.and.itfs(i).eq.0)) go to 134
      do 122 j=js,je
      read(5,100) (x(i,j,k),mx(i,j,k),k=1,nw)
      if(iwflag(3).eq.1) then
           write(6,200) (atom(k,i),k=1,2),cmp3(j-3),
     *                     (x(i,j,k),mx(i,j,k),k=1,nw)
      end if
 122  continue
 134  continue
 31   if(sctmdl.eq.0) go to 10
      js=4+it
      je=4+it
c      if(itempf.eq.2.and.itfs(i).eq.0) js=4+it-5
c      if(itempf.eq.2.and.itfs(i).eq.0) je=4+it-5
      if(itempf.le.-1.and.itfs(i).eq.0) js=4+it-5
      if(itempf.le.-1.and.itfs(i).eq.0) je=4+it-5
      do 13 j=js,je
      read(5,100) (x(i,j,k),mx(i,j,k),k=1,nw)
      if(iwflag(3).eq.1) then
           write(6,200) (atom(k,i),k=1,2),cmp4(1),
     *                   (x(i,j,k),mx(i,j,k),k=1,nw)
      end if
 13   continue
 10   continue
c**********************************************************************
c                     variable parameter table
c**********************************************************************
      read(5,112) jx,jb,jf
      if(iwflag(3).eq.1) then
           write(6,207) jx,jb,jf
      end if
      ii=0
      ic=0
      ixs=1
      ixe=0
      ibs=1
      ibe=0
      ifs=1
      ife=0
      if(dspmdl.eq.1) then
c***********table for atom position****************
           do 21 i=1,na
           do 21 j=1,3
           do 21 k=1,nw
           if(mx(i,j,k).ne.iblk) go to 21
           ii=ii+1
           ic=ic+1
           ja(1,ic)=i
           ja(2,ic)=j
           ja(3,ic)=k
           ja(4,ii)=1
           ea(ic)=1.0
           x1(ii)=x(i,j,k)
 21        continue
           ixs=ii+1
           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
                write(6,203)
                if(ii.ne.0) write(6,202)
     *               (no,i,ja(1,i),ja(2,i),ja(3,i),ea(i),i=1,ic)
           end if
           call rdsymv(ja,ea,nzc,jx,ii,ic)
           ixe=ii
      end if
      if(tmpmdl.eq.1) then
c************table for temperature factor*************
           ij=ii+1
           jj=0
           if(iwflag(3).eq.1) then
                write(6,204)
           end if
           do 22 i=1,na
           je=it
c          if(itempf.eq.2.and.itfs(i).eq.0) je=it-5
           if(itempf.le.-1.and.itfs(i).eq.0) je=it-5
           do 22 j=1,je
           do 22 k=1,nw
           if(mx(i,j+3,k).ne.iblk) go to 22
           jj=jj+1
           ii=ii+1
c          if(itempf.eq.2.and.itfs(i).eq.0.and.j.eq.1) go to 220
           if(itempf.le.-1.and.itfs(i).eq.0.and.j.eq.1) go to 220
           ic=ic+1
           ja(1,ic)=i
           ja(2,ic)=j
c          if(itempf.eq.2.and.itfs(i).eq.0.and.j.gt.1) ja(2,ic)=j+5
           if(itempf.le.-1.and.itfs(i).eq.0.and.j.gt.1) ja(2,ic)=j+5
           ja(3,ic)=k
           ja(4,ii)=1
           ea(ic)=1.0
           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
c               if(itempf.eq.2) write(6,202)
                if(itempf.le.-1) write(6,202)
     *                 no,ii,ja(1,ic),ja(2,ic),ja(3,ic),ea(ic)
           end if
c220       if(itempf.ne.2.or.itfs(i).ne.0.or.j.ne.1) go to 222
 220       if(itempf.gt.0.or.itfs(i).ne.0.or.j.ne.1) go to 222
           ja(4,ii)=6
           do 221 kx=1,6
           ic=ic+1
           ja(1,ic)=i
           ja(2,ic)=kx
           ja(3,ic)=k
 221       ea(ic)=eat(kx)
           icw=ic-6
           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
c               if(itempf.eq.2) write(6,202)
                if(itempf.le.-1) write(6,202)
     *                   (no,ii,ja(1,icw+l),ja(2,icw+l),
     *                       ja(3,icw+l),ea(icw+l),l=1,6)
           end if
 222       x1(ii)=x(i,j+3,k)
 22        continue
           ibs=ii+1
           k=ic-ii
           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
c                if(jj.ne.0.and.itempf.ne.2) write(6,202)
                 if(jj.ne.0.and.itempf.gt.0) write(6,202)
     *                     (no,i,ja(1,i+k),ja(2,i+k),
     *                       ja(3,i+k),ea(i+k),i=ij,ii)
           end if
c          if(itempf.ne.2) call rdsymv(ja,ea,nzc,jb,ii,ic)
c          if(itempf.eq.2) call rdsymw(ja,ea,nzc,jb,ii,ic)
           if(itempf.gt.0) call rdsymv(ja,ea,nzc,jb,ii,ic)
           if(itempf.lt.0) call rdsymw(ja,ea,nzc,jb,ii,ic)
           ibe=ii
      end if
      if(sctmdl.eq.1.or.sctmdl.eq.-1) then
c**********table for occupation probability**********
           ij=ii+1
           kk=0
           do 23 i=1,na
           je=it
c          if(itempf.eq.2.and.itfs(i).eq.0) je=it-5
           if(itempf.le.-1.and.itfs(i).eq.0) je=it-5
           do 23 j=1,1
           do 23 k=1,nw
           if(mx(i,j+3+je,k).ne.iblk) go to 23
           kk=kk+1
           ii=ii+1
           ic=ic+1
           ja(1,ic)=i
           ja(2,ic)=j
           ja(3,ic)=k
           ja(4,ii)=1
           ea(ic)=1.0
           x1(ii)=x(i,j+3+je,k)
 23        continue
           ifs=ii+1
           k=ic-ii
           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
                write(6,205)
                if(kk.ne.0) write(6,202)
     *                (no,i,ja(1,i+k),ja(2,i+k),ja(3,i+k)
     *                        ,ea(i+k),i=ij,ii)
           end if
           call rdsymv(ja,ea,nzc,jf,ii,ic)
           ife=ii
      end if
c*****twin domain**************************************
      if(itvr.gt.0) then
           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
                write(6,210)
           end if
           call rdsymv(ja,ea,nzc,itvr,ii,ic)
      end if
c*****out of step**************************************
      if(itst.gt.0) then
           if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
                write(6,211)
           end if
           call rdsymv(ja,ea,nzc,itst,ii,ic)
      end if
c*******************************************************************
c         read independent structural parameters related with
c           the constrained amplitudes and other parameters
c*******************************************************************
      iend=max0(ixe,ibe,ife)
      ios=iend+1
      ioe=iend+nds+itvr+itst
      if(isext.eq.1) ioe=ioe+2
      read(5,101) (x1(i),i=ixs,ixe),(x1(i),i=ibs,ibe),(x1(i),i=ifs,ife)
     *       ,(x1(i),i=ios,ioe)
c********************************************************************
      if(iwflag(3).eq.1) then
           write(6,212) (x1(i),i=ixs,ixe),(x1(i),i=ibs,ibe),
     *            (x1(i),i=ifs,ife),(x1(i),i=ios,ioe)
      end if
c********************************************************************
      if(iwflag(3).eq.1) then
           write(6,208)
      end if
      if(nde.ne.2) return
      aa=cmp2(4)
      cmp2(4)=cmp2(7)
      cmp2(7)=aa
      aa=cmp3(9)
      cmp3(9)=cmp3(12)
      cmp3(12)=aa
      return
 100  format((12x,6(f9.4,a1)))
 101  format(8(f9.4,1x))
 110  format(4i3,f12.6)
 111  format(4(3i3,f11.6))
 112  format(3i3)
 200  format(1h ,a4,a2,2x,a4,6(f9.5,a1)/(1h ,12x,6(f9.5,a1)))
 201  format(1h ,'fourier term',6i10/(1h ,12x,6i10))
 202  format((1h ,5(a1,i3,1x,3i3,f9.4,3x)))
 203  format(1h ,'positional parameter')
 204  format(1h ,'thermal parameter')
 205  format(1h ,'occupational parameter')
 206  format(1h ,'je=',i3,1x,'ja1=',i3,1x,'ja2=',i3,1x,'ja3=',i3,1x,
     *       'ea=',f12.6)
 207  format(1h ,'jx=',i3,1x,'jb=',i3,1x,'jf=',i3/1h ,
     *     'correspondence between fourier amplitudes and independent',
     *         ' parameters')
 208  format(1h1)
 209  format(1h ,'atom',i3)
 210  format(1h ,'domain size')
 211  format(1h ,'out of step')
 212  format(1h ,'additional parameters'/(1h ,(8f10.4)))
      end
      subroutine rdiobs(iwght)
      common /cwflag/ iwflag(6)
      common /fhkl/ hkln(100),fobs(100),fcal(100),wght(100),im(20),is(2)
     *         ,sf
      common /cdim/ idm,nde
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12
      common /sym/ rr(24,6,6),tt(24,6),nsymo,icent
      integer hkln,nslct,ih(6),hm
      common /islct/ hd(3),h4(3,40),nslct
      common /filen/ flfobs,flfcal
      integer h4
      complex fcal
      character*26 flfobs,flfcal
      character*4 fmt(19)
      common /chkln/ iex(6),hm(6)
c     open(unit=91,access='direct',recl=1200,file=flfobs)
c     open(unit=92,access='direct',recl=800,file=flfcal)
      nds=i12-i10
      read(5,103) nslct,((h4(i,j),i=1,nde),j=1,nslct)
      if(nde.eq.3) go to 211
      j=nde+1
      do 212 k=1,nslct
      do 212 i=j,3
 212  h4(i,k)=0
 211  continue
      read(5,105) fmin,wg0,hm
      if(iwflag(3).eq.1) then
           write(6,201) fmin,wg0
      end if
      read(5,100) inp,iorf,fmt
      if(iwflag(3).eq.1) then
           write(6,202) inp,iorf,fmt
      end if
      do 21 i=1,6
      if(hm(i).ne.0) go to 20
 21   continue
      do 22 i=1,3
      j=i+3
      hm(i)=24
 22   hm(j)=10
 20   iex(6)=1
      do 24 i=1,5
      j=6-i
 24   iex(j)=iex(j+1)*(hm(j+1)*2+1)
 111  i=0
      is(1)=0
      is(2)=0
      sf=0.0
      iw1=0
      if(inp.ne.5) rewind 3
      do 11 inds=1,nds
      ii=0
 10   continue
      if(mod(i,100).eq.0) i=0
      ih(4)=0
      ih(5)=0
      ih(6)=0
      if(inp.eq.5) read(5,fmt) (ih(j),j=1,idm),aiobs,wg
      if(inp.ne.5) read(3,fmt) (ih(j),j=1,idm),aiobs,wg
      if(ih(1).eq.999) go to 11
      iabsn=0
      do 23 j=1,6
      if(iabs(ih(j)).gt.hm(j)) go to 10
 23   continue
      if(nslct.eq.0) go to 13
      do 141 ia=1,nslct
      do 141 n=1,nsymo
          do 142 j=1,nde
          hd(j)=0
          do 142 k=1,nde
 142      hd(j)=hd(j)+ih(k+3)*rr(n,k+3,j+3)
          do 143 j=1,nde
          if(abs(hd(j)-h4(j,ia)).gt.0.00001) go to 144
 143      continue
          go to 13
 144      do 145 j=1,nde
          if(abs(hd(j)+h4(j,ia)).gt.0.00001) go to 141
 145      continue
          go to 13
 141  continue
      go to 10
 13   ii=ii+1
      i=i+1
      is(1)=is(1)+1
 16   continue
      hkln(i)=0
      do 17 j=1,6
 17   hkln(i)=hkln(i)+(ih(j)+hm(j))*iex(j)
      if(iorf.eq.1) fobs(i)=aiobs
      if(iorf.ne.1) fobs(i)=sqrt(aiobs)
      wght(i)=wghtf(fobs(i),iwght,fmin,wg,wg0)
      if(wght(i).ne.0.0) is(2)=is(2)+1
      sf=sf+fobs(i)**2*wght(i)
      if(i.eq.100) iw1=iw1+1
      if(i.eq.100) write(unit=91,rec=iw1) hkln,fobs,wght
      go to 10
 11   im(inds)=ii
      if(i.ne.0) write(unit=91,rec=iw1+1) hkln,fobs,wght
      if(iwflag(3).eq.1) then
           write(6,200) is,hm
      end if
c     close(unit=91)
c     close(unit=92)
      return
 100  format(2i2,19a4)
 102  format(6f12.6)
 103  format(22i3)
 104  format(18i3)
 105  format(2f12.6,6i3)
 200  format(1h ,'number of total reflections',i5,5x,
     *            'number of reflections used',i5/1h ,
     *            'maximum miller indices',6i5)
 201  format(1h ,'fmin=',f12.6,3x,'wg0=',f12.6)
 202  format(1h ,'inp=',i3,3x,'iorf=',i3,3x,'fmt=',19a4)
      end

      function wghtf(fobs,iwght,fmin,wg,wg0)
c     weighting scheme
      wghtf=wg
      if(iwght.eq.1.and.fobs.gt.fmin) wghtf=1.0
      if(iwght.lt.2.and.fobs.le.fmin) wghtf=wg0
      if(iwght.eq.2.and.fobs.gt.fmin) wghtf=100.0/fobs**2
      if(iwght.eq.2.and.fobs.le.fmin) wghtf=100.0/fmin**2
      if(iwght.eq.3.and.fobs.gt.fmin) wghtf=fobs/10.
      if(iwght.eq.3.and.fobs.le.fmin) wghtf=fmin/10.
      return
      end
      subroutine rdlc
      common /cwflag/ iwflag(6)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3)
      common /ctitle/ mater(20)
      read(5,99) mater
      read(5,100) a,b,c,cosa,cosb,cosc
      if(iwflag(2).eq.1) then
           write(6,299) mater
      end if
      if(iwflag(3).eq.1) then
           write(6,300) a,b,c,cosa,cosb,cosc
      end if
      sina=sqrt(1.0-cosa**2)
      sinb=sqrt(1.0-cosb**2)
      sinc=sqrt(1.0-cosc**2)
      gabx(1,1)=a*sqrt(1.0-cosa**2-cosb**2-cosc**2+2.0*cosa*cosb*cosc)/
     *         sina
      gabx(1,2)=0.0
      gabx(1,3)=0.0
      gabx(2,1)=a*(cosc-cosa*cosb)/sina
      gabx(2,2)=b*sina
      gabx(2,3)=0.0
      gabx(3,1)=a*cosb
      gabx(3,2)=b*cosa
      gabx(3,3)=c
      vc=gabx(1,1)*gabx(2,2)*gabx(3,3)
      gaby(1,1)=gabx(2,2)*gabx(3,3)/vc
      gaby(1,2)=0.0
      gaby(1,3)=0.0
      gaby(2,1)=(-gabx(2,1)*gabx(3,3))/vc
      gaby(2,2)=(gabx(1,1)*gabx(3,3))/vc
      gaby(2,3)=0.0
      gaby(3,1)=(gabx(2,1)*gabx(3,2)-gabx(2,2)*gabx(3,1))/vc
      gaby(3,2)=(-gabx(1,1)*gabx(3,2))/vc
      gaby(3,3)=(gabx(1,1)*gabx(2,2))/vc
      gab(1,1)=a**2
      gab(2,2)=b**2
      gab(3,3)=c**2
      gab(1,2)=a*b*cosc
      gab(2,3)=b*c*cosa
      gab(3,1)=c*a*cosb
      gab(2,1)=gab(1,2)
      gab(3,2)=gab(2,3)
      gab(1,3)=gab(3,1)
 99   format(20a4)
 100  format(6f12.6)
 299  format(1h ,20a4)
 300  format(1h ,20hlattice constants   ,2ha=,f10.6,3h(a),2x,2hb=,f10.6,
     *  3h(a),2x,2hc=,f10.6,3h(a),2x,5hcosa=,f10.6,2x,5hcosb=,f10.6,2x,
     *      5hcosc=,f10.6)
      return
      end
      subroutine rdpnf2
      common /cwflag/ iwflag(6)
      common /cpnf2/ atom1(100),atom2(100),nsym(100),
     *       icnt(100),trd(100,6),dmax(100),dmin(100),npi(100)
      common /cpnf/ grad1,expn1,grad2,expn2,np
      integer atom1,atom2
      read(5,100) np
      if(iwflag(3).eq.1) then
           write(6,200) np
      end if
      do 20 i=1,np
 20   npi(i)=0
      if(iwflag(3).eq.1) then
           write(6,201)
      end if
      i=0
      j=1
 10   i=i+1
      read(5,110) atom1(i),atom2(i),nsym(i),icnt(i),(trd(i,k),k=1,6)
     *        ,rdmin,rdmax,icont
      if(icont.ne.0) icont=1
      npi(j)=npi(j)+1
      if(icont.eq.1) then
           if(iwflag(3).eq.1) then
                 write(6,210) j,atom1(i),atom2(i),nsym(i),icnt(i),
     *                        (trd(i,k),k=1,6)
           end if
      else
           if(iwflag(3).eq.1) then
                 write(6,210) j,atom1(i),atom2(i),nsym(i),icnt(i),
     *                        (trd(i,k),k=1,6),rdmin,rdmax
           end if
      end if
      if(icont.eq.0) then
           dmin(j)=rdmin
           dmax(j)=rdmax
           j=j+1
      end if
      if(j.ne.np+1) go to 10
      return
 100  format(i3)
 110  format(4i3,8f8.6,i3)
 200  format(1h ,'constraint condition for bond distances'/1h ,'nb=',
     *           i3)
 201  format(1h ,6x,'atom pair',24x,'additional translation vector'
     *          /1h ,'no.',2x,'atom 1',2x,
     *         'atom 2',2x,'sym. no.',2x,'icnt',4x,
     *         't1',9x,'t2',9x,'t3',9x,'t4',9x,'t5',9x,
     *         't6',9x,'dmin',7x,'dmax')
 210  format(1h ,i3,2x,2(i5,2x),1x,i5,5x,i3,3x,8f11.6)
      end

      subroutine rdsymo(na,isk)
      common /cwflag/ iwflag(6)
      dimension isk(na,24)
      common /sym/ rr(24,6,6),tt(24,6),nsymo,icent
      common /bgn/ ilm(3),icorc(3),ilc(3)
      common /atomp2/ y(3,3)
      common /cdim/ idm,nde
      common /cskip/ iskip
      common /extcr/ nextnc,icef(6,24),nmod(24)
      dimension imps(24),fmt(2)
      dimension rg(5,6,6),tg(5,6)
      dimension re(24,3,3),ri(24,3,3),te(24,3),ti(24,3)
      character*4 fmt
      data fmt/'in','  '/
c     initialozation
      do 16 i=1,3
      ilm(i)=1
      ilc(i)=1
      icorc(i)=0
      do 16 j=1,3
 16   y(i,j)=0.0
c
      read(5,100) nde,nsymo,icent,ige,iskip,nextnc
      do 17 nd=1,nde
 17   read(5,102) (y(nd,j),j=1,3),icorc(nd),ilm(nd)
c
      icom=0
      do 15 i=1,nde
      if(icorc(i).eq.0) icom=1
 15   if(icorc(i).eq.0) ilm(i)=1
c
      if(icom.eq.1) read(5,100) ilc
      if(iwflag(3).eq.1) then
           write(6,210) nde,nsymo,icent,ige,iskip,nextnc
      end if
      idm=nde+3
      if(iwflag(3).eq.1) then
           write(6,205)
      end if
      do 60 nd=1,nde
      if(icorc(nd).eq.1) ii=1
      if(icorc(nd).eq.0) ii=2
      if(iwflag(3).eq.1) then
           write(6,204) nd,(y(nd,j),j=1,3),icorc(nd),ilm(nd),fmt(ii)
      end if
 60   continue
      if(iwflag(3).eq.1) then
           if(icom.eq.1) write(6,211) ilc
           write(6,'(1h )')
      end if
      do 10 k=1,nsymo
      read(5,101) ((re(k,i,j),j=1,3),i=1,3),(te(k,i),i=1,3)
      read(5,101) ((ri(k,i,j),j=1,3),i=1,3),(ti(k,i),i=1,3)
 10   continue
c*****call getri(re,ri,nsymo,y,nde)
      if(iwflag(3).eq.1) then
           if(icent.eq.1) then
                 write(6,2022)
           else
                 write(6,2021)
           end if
           if(ige.eq.1) then
                write(6,201) 'generating elements'
           end if
           write(6,'(1h )')
      end if
      nn=nde+1
      do 12 i=1,nsymo
      call getrr(rr,tt,i,re,ri,te,ti)
 12   continue
      if(iwflag(3).eq.1) then
           call wtsymo(rr,tt,nsymo,idm)
      end if
      if(ige.eq.1) then
           call ordr(re,imps,nsymo,3)
           do 123 i=1,nsymo
           do 123 j=1,idm
           tg(i,j)=tt(i,j)
           do 123 k=1,idm
           rg(i,j,k)=rr(i,j,k)
 123       continue
           impt=1
           do 13 i=1,6
           tt(1,i)=0.0
           do 13 j=1,6
           rr(1,i,j)=0.0
           rr(1,i,i)=1.0
 13        continue
           do 50 ns=1,nsymo
           imp=imps(ns)
           do 11 i=2,imp
           do 11 j=1,impt
           mp1=j+(i-2)*impt
           mp2=j+(i-1)*impt
 11        call mpso(rg,tg,ns,5,rr,tt,mp1,mp2,24)
 50        impt=impt*imp
           nsymo=impt
           if(iwflag(3).eq.1) then
                write(6,207)
                write(6,'(1h )')
                call wtsymo(rr,tt,nsymo,idm)
           end if
      end if
 81   continue
      if(iskip.eq.1) then
           do 42 i=1,na
 42        read(5,103) (isk(i,j),j=1,nsymo)
           if(iwflag(3).eq.1) then
                write(6,209)
                do 40 i=1,na
 40             write(6,208) i,(isk(i,j),j=1,nsymo)
           end if
      end if
      if(nextnc.eq.0) return
      if(iwflag(3).eq.1) then
           write(6,231)
      end if
      do 90 i=1,nextnc
      read(5,100) (icef(j,i),j=1,6),nmod(i)
      if(iwflag(3).eq.1) then
           write(6,230) (icef(j,i),j=1,6),nmod(i)
      end if
 90   continue
      return
 100  format(7i3)
 101  format(9f5.2,3f9.6,i3)
 102  format(3f8.5,2i3)
 103  format(24i3)
 200  format(1h ,2x,i2,4x,9f6.2,5x,3f10.6,5x,i3)
 201  format(1h ,a)
 2021 format(1h ,'symmetry operation',10x,'noncentrosymmetric')
 2022 format(1h ,'symmetry operation',10x,'centrosymmetric')
 204  format(1h ,'wavevector k',i1,10x,3f9.6,3x,'icorc=',i3,2x
     *       ,'ilm=',i3,2x,a2,'commensurate')
 205  format(1h ,'basic wavevectors')
 206  format(1h ,'generating elements')
 207  format(1h ,'symmetry operators generated by generating elements')
 208  format(1h ,i3,10x,24i3)
 209  format(1h ,'atom',9x,'symmetry operator to be skipped =1')
 210  format(1h ,'ndm=',i2,2x,'nsymo=',i3,2x,'icent=',i2,2x,'ige=',
     *           i2,2x,'iskip=',i2,2x,'nextnc=',i2)
 211  format(1h ,'periods along a,b,c axes' ,3i5)
 230  format(1h ,7i5)
 231  format(1h ,'extinction rules for general reflections'/1h ,
     *          'm1,m2,..,m6,m of m1*h1+m2*h2+...+m6*h6=m*n')
      end

      subroutine getrr(rr,tt,ns,re,ri,te,ti)
      dimension rr(24,6,6),tt(24,6)
      dimension re(24,3,3),ri(24,3,3),te(24,3),ti(24,3)
      common /cdim/ idm,nde
      common /atomp2/ y(3,3)
      do 12 i=1,idm
      if(i.le.3) then
           tt(ns,i)=te(ns,i)
      else
           tt(ns,i)=ti(ns,i-3)
      end if
      do 12 j=1,idm
      if(i.le.3.and.j.le.3) then
           rr(ns,i,j)=re(ns,i,j)
      else if(i.le.3.and.j.gt.3) then
           rr(ns,i,j)=0
      else if(i.gt.3.and.j.le.3) then
           rr(ns,i,j)=0
           do 121 k=1,3
 121       rr(ns,i,j)=rr(ns,i,j)+y(i-3,k)*re(ns,k,j)
           do 122 k=1,nde
 122       rr(ns,i,j)=rr(ns,i,j)-ri(ns,i-3,k)*y(k,j)
      else
           rr(ns,i,j)=ri(ns,i-3,j-3)
      end if
 12   continue
      do 13 i=1,6
      do 13 j=idm+1,6
 13   rr(ns,i,j)=0
      do 14 i=idm+1,6
      do 14 j=1,6
 14   rr(ns,i,j)=0
      do 15 i=idm+1,6
 15   tt(ns,i)=0
      return
      end

      subroutine ordr(re,imps,nsymo,idm)
      dimension re(24,3,3),imps(24)
      integer r(6,6),a(6,6),b(6,6)
      data eps/0.001/
      do 10 i=1,nsymo
           do 11 j=1,idm
           do 11 k=1,idm
           r(j,k)=re(i,j,k)+sign(eps,re(i,j,k))
 11        b(j,k)=r(j,k)
           do 12 j=1,7
c    check whether r is identity operator or not
                do 16 k=1,idm
                if(r(k,k).ne.1) go to 15
                do 16 l=1,idm
                if(k.ne.l.and.r(k,l).ne.0) go to 15
 16             continue
                imps(i)=j
                go to 10
c       a=r
 15             do 13 k=1,idm
                do 13 l=1,idm
 13             a(k,l)=r(k,l)
c       r=a*b   ==> r=r*re
                do 14 k=1,idm
                do 14 l=1,idm
                r(k,l)=0
                do 14 m=1,idm
 14             r(k,l)=r(k,l)+a(k,m)*b(m,l)
 12        continue
 10   continue
      do 20 i=1,nsymo
      if(imps(i).ge.7) then
           ierror=1
           go to 21
      else
           ierror=0
      end if
 20   continue
 21   continue
      if(ierror.eq.1) then
           write(6,'(1h ,''error in symmetry operator ?'',a,24i3)')
     *      '  order: ',(imps(i),i=1,nsymo)
      end if
      return
      end

      subroutine wtsymo(rr,tt,nsymo,idm)
      common /cwflag/ iwflag(6)
      dimension rr(24,6,6),tt(24,6)
      integer wd(3),w,wr(24,6,6)
      data wd/6,5,4/,eps/0.001/
      do 20 i=1,nsymo
      do 20 j=1,idm
      do 20 k=1,idm
      wr(i,j,k)=rr(i,j,k)+sign(eps,rr(i,j,k))
 20   continue
      w=wd(idm-3)
      ll=(nsymo-1)/w+1
      le=nsymo-(ll-1)*w
      do 31 ii=1,ll
      lbgn=(ii-1)*w+1
      if(ii.ne.ll) lend=lbgn+w-1
      if(ii.eq.ll) lend=lbgn+le-1
      do 31 i=1,idm
      if(idm.eq.4) write(6,204) ((wr(k,i,j),j=1,idm),tt(k,i),
     *                 k=lbgn,lend)
      if(idm.eq.5) write(6,205) ((wr(k,i,j),j=1,idm),tt(k,i),
     *                 k=lbgn,lend)
      if(idm.eq.6) write(6,206) ((wr(k,i,j),j=1,idm),tt(k,i),
     *                 k=lbgn,lend)
      if(i.eq.idm) write(6,'(1h )')
 31   continue
      return
 204  format(1h ,6(4i3,f8.4,2x))
 205  format(1h ,5(5i3,f8.4,2x))
 206  format(1h ,4(6i3,f8.4,2x))
      end

      subroutine mpso(r1,t1,m1,n1,r2,t2,m2,m3,n2)
      dimension r1(n1,6,6),t1(n1,6),r2(n2,6,6),t2(n2,6)
      do 10 i=1,6
      t2(m3,i)=0.0
      do 11 j=1,6
 11   t2(m3,i)=t2(m3,i)+r1(m1,i,j)*t2(m2,j)
      t2(m3,i)=t2(m3,i)+t1(m1,i)
      do 12 j=1,6
      r2(m3,i,j)=0.0
      do 12 k=1,6
 12   r2(m3,i,j)=r2(m3,i,j)+r1(m1,i,k)*r2(m2,k,j)
 10   continue
      return
      end

      subroutine rdtsym(itwin)
      common /cwflag/ iwflag(6)
      common /sym/ rr(24,6,6),tt(24,6),nsymo,icent
      common /cdim/ idm,nde
      dimension re(24,3,3),ri(24,3,3),te(24,3),ti(24,3)
c     read symmetry operators for twin
      if(itwin.ge.1) write(6,203) 'twin operator'
      if(itwin.lt.0) write(6,203) 'twin operator for coherent twin'
      write(6,'(1h )')
      ie=iabs(itwin)
      do 11 i=1,ie
      j=nsymo+i
      read(5,101) ((re(j,l,k),k=1,3),l=1,3),(te(j,k),k=1,3)
      read(5,101) ((ri(j,l,k),k=1,3),l=1,3),(ti(j,k),k=1,3)
      call getrr(rr,tt,j,re,ri,te,ti)
 11   continue
c*****call getri(re(nsymo+1,1,1),ri(nsymo+1,1,1),ie,y,nde)
      if(iwflag(3).eq.1) then
           call wtsymo(rr(nsymo+1,1,1),tt(nsymo+1,1),ie,idm)
      end if
      return
 101  format(9f5.3,3f9.6)
 201  format(1h ,2x,i2,4x,9f6.2,5x,3f10.6,5x,f10.6)
 203  format(1h ,a)
      end
      subroutine rdsymv(ja,ea,nzc,jx,ix,in)
      common /cwflag/ iwflag(6)
      dimension ea(nzc),ja(4,nzc),ia(4),jr(4,3),er(4)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf
      integer dspmdl,tmpmdl,sctmdl
      character*4 ql,no,ia
      data ql/' '/,no/'#'/
      if(jx.eq.0) return
      if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
           write(6,201)
      end if
      ix0=ix
      jn=in
      ja4=0
 1    continue
      read(5,101) ((jr(i,j),j=1,3),er(i),ia(i),i=1,4)
      do 13 i=1,4
      if(ia(i).eq.ql.and.jr(i,1).eq.0.and.jr(i,2).eq.0.and.jr(i,3).eq.0)
     *       go to 13
      in=in+1
      ja4=ja4+1
      if(ia(i).eq.ql) ix=ix+1
      if(in.gt.nzc) go to 20
      do 14 j=1,3
 14   ja(j,in)=jr(i,j)
      ea(in)=er(i)
      if(ia(i).eq.ql) ja(4,ix)=ja4
      if(ia(i).eq.ql) ja4=0
 20   if(ia(i).eq.ql.and.ix-ix0.eq.jx) go to 15
 13   continue
      go to 1
 15   if(in.gt.nzc.and.ix-ix0.lt.jx) go to 1
      if(in.gt.nzc.and.ix-ix0.eq.jx) go to 99
      ix1=ix0+1
      do 10 i=ix1,ix
      nz=ja(4,i)
      if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
           write(6,202) (no,i,(ja(j,n+jn),j=1,3),ea(n+jn),n=1,nz)
      end if
 10   jn=jn+nz
      return
 99   l=in-nzc
      write(6,203) l
      stop
 101  format(4(3i3,f10.6,a1))
 201  format(1h )
 202  format((1h ,5(a1,i3,1x,3i3,f9.4,3x)))
 203  format(1h ,'lack of nzc',i6)
      end
      subroutine rdsymw(ja,ea,nzc,jx,ix,in)
      common /cwflag/ iwflag(6)
      dimension ea(nzc),ja(4,nzc),ia(4),jr(4,3),er(4)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf
      common /ceat/ eat(6)
      common /citfs/ itfs(100)
      integer dspmdl,tmpmdl,sctmdl
      character*4 ql,ia
      data ql/' '/
      if(jx.eq.0) return
      if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
           write(6,201)
      end if
      ix0=ix
      jn=in
      ja4=0
 1    continue
      read(5,101) ((jr(i,j),j=1,3),er(i),ia(i),i=1,4)
      do 13 i=1,4
      if(ia(i).eq.ql.and.jr(i,1).eq.0.and.jr(i,2).eq.0.and.jr(i,3).eq.0)
     *        go to 13
      kend=1
      if(ia(i).eq.ql) ix=ix+1
      if(itfs(jr(i,1)).eq.0.and.jr(i,2).eq.1) kend=6
      do 30 k=1,kend
      in=in+1
      ja4=ja4+1
      if(in.gt.nzc) go to 20
      do 14 j=1,3
 14   ja(j,in)=jr(i,j)
      ea(in)=er(i)
      if(itfs(jr(i,1)).eq.0.and.jr(i,2).eq.1) ja(2,in)=k
      if(itfs(jr(i,1)).eq.0.and.jr(i,2).gt.1) ja(2,in)=jr(i,2)+5
      if(itfs(jr(i,1)).eq.0.and.jr(i,2).eq.1) ea(in)=er(i)*eat(k)
 30   continue
      if(ia(i).eq.ql) ja(4,ix)=ja4
      if(ia(i).eq.ql) ja4=0
 20   if(ia(i).eq.ql.and.ix-ix0.eq.jx) go to 15
 13   continue
      go to 1
 15   if(in.gt.nzc.and.ix-ix0.lt.jx) go to 1
      if(in.gt.nzc.and.ix-ix0.eq.jx) go to 99
      ix1=ix0+1
      do 10 i=ix1,ix
      nz=ja(4,i)
      if(iwflag(3).eq.1.and.iwflag(5).gt.0) then
           write(6,202) (i,(ja(j,n+jn),j=1,3),ea(n+jn),n=1,nz)
      end if
 10   jn=jn+nz
      return
 99   l=in-nzc
      write(6,203) l
      stop
 101  format(4(3i3,f10.6,a1))
 201  format(1h )
 202  format((1h ,5(i3,'#',1x,3i3,f9.4,3x)))
 203  format(1h ,'lack of nzc',i6)
      end
